// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Bt848_32/rcs/848lin.cpp 2.2 1997/09/09 23:12:30 dtharp Released $
// $Log: 848lin.cpp $
// Revision 2.2  1997/09/09 23:12:30  dtharp
// Mods required for vxd rename.
// Revision 2.1  1996/06/10 20:11:53  ssm
// MarkBeta1AsRev2
// Revision 1.2  1996/04/28 01:25:15  rudyl
// ver 1.00 - both I2C and GPIO are now objects of register class.
// Created a set of API wrapper functions to invoke member functions of the classes.
// Revision 1.1  1996/04/26 23:52:44  rudyl
// Initial revision
// Revision 1.3  1996/04/24 22:53:39  rudyl
// Removed hard-coded dir for Pisces.vxd
// Revision 1.2  1996/04/09 22:33:26  rudyl
// Added copyright info.

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation. All Rights Reserved.
//
//  Module:
//
//    848lin.cpp
//
//  Abstract:
//
//    Returns the base address of the Bt848
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "848lin.h"

//****************************************************************************
//  LPBYTE GetBt848LinearAddress( void )
//  	Purpose:  Obtain base memory address for the Bt848
//  	Input:	  None
//  	Output:	  None
//  	Return:	  NULL if fails, else memory address
//****************************************************************************
LPBYTE GetBt848LinearAddress(void)
{
  DWORD dwDataSize = 0;
  LPBYTE lpRegBase = NULL;

  HANDLE TestDev = CreateFile( "\\\\.\\BTPCIVID",
    GENERIC_READ | GENERIC_WRITE,
    0,              // exclusive access
    NULL,           // no security
    OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, // | FILE_FLAG_OVERLAPPED
    NULL );

  if ( TestDev == INVALID_HANDLE_VALUE )
    return lpRegBase;

  DeviceIoControl( TestDev, 2, NULL, 0, &lpRegBase,
                   sizeof( LPVOID ), &dwDataSize, NULL );
  CloseHandle( TestDev );

  return lpRegBase;
}
