// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Bt848_32/rcs/HWInfo.h 1.2 1997/09/09 23:12:32 dtharp Released $
// $Log: HWInfo.h $
// Revision 1.2  1997/09/09 23:12:32  dtharp
// Mods required for vxd rename.
// Revision 1.1  1997/07/23 00:13:07  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1997 Rockwell Semiconductor Systems. All Rights Reserved.
//
//  Module:
//
//    HWInfo.h
//
//  Abstract:
//
//    Class header and implementation file to obtain hardware information.
//
//  Author:
//
//    Rudy Liang
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __HWINFO_H
#define __HWINFO_H

#include <windows.h>
#include "vxdfunc.h"

/////////////////////////////////////////////////////////////////////////////
// CLASS HWInfo
//
// Description:
//    This class is designed to obtain hardware information of the Brooktree
//    video decoder family hardware through requesting service to VxD.
//
// Member Functions:
//   virtual WORD GetDeviceID( void ) - return device ID
//   virtual BYTE GetRevisionID( void ) - return revision ID
//
/////////////////////////////////////////////////////////////////////////////

class HWInfo
{
protected:
   PCI_CONFIG_848 hwInfo;

public:
   HWInfo( void )
   {
      // initialize structure
      hwInfo.DeviceID = 0xFFFF;
      hwInfo.RevisionID = 0xFF;

      // ask VxD to fill hardware info structure
      HANDLE TestDev = CreateFile( "\\\\.\\BTPCIVID",
                                   GENERIC_READ | GENERIC_WRITE,
                                   0,              // exclusive access
                                   NULL,           // no security
                                   OPEN_EXISTING,
                                   FILE_ATTRIBUTE_NORMAL,
                                   NULL );

      if ( TestDev == INVALID_HANDLE_VALUE )
         return;

      DWORD dwDataSize = 0;

      // obtain hardware info
      PCI_CONFIG_848 * pStruct;

      // VxD expect ptr to ptr to PCI_CONFIG_848 structure
      if ( TRUE == DeviceIoControl( TestDev, FNGetPciHdr, NULL, 0, &pStruct,
                                     sizeof( LPVOID ), &dwDataSize, NULL ) )
         hwInfo = *pStruct;

      CloseHandle( TestDev );
   }

   ~HWInfo( void ) {};

   inline virtual WORD GetDeviceID( void ) const { return hwInfo.DeviceID; }
   inline virtual BYTE GetRevisionID( void ) const { return hwInfo.RevisionID; }
};

#endif   // __HWINFO_H
