// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Bt848_32/rcs/bt848api.cpp 2.15 1997/09/30 18:37:02 rudyl Released $
// $Log: bt848api.cpp $
// Revision 2.15  1997/09/30 18:37:02  rudyl
// Renamed BlockRead() & BlockWrite() to MultiRead() & MultiWrite().
// Revision 2.14  1997/09/16 20:08:38  dtharp
// Changes requrired for BtPciVid.drv name change to BtVid.drv.
// Revision 2.13  1997/09/11 00:08:37  dtharp
// Mods required for name change of Bt848_32.dll to BtVid_32.dll.
// Revision 2.12  1997/09/10 20:41:19  dtharp
// Mods required for name change bt848_16.dll -> BtVid_16.dll.
// Revision 2.11  1997/09/09 23:12:31  dtharp
// Mods required for vxd rename.
// Revision 2.10  1997/09/03 17:51:54  dtharp
// Mods required for name change of Bt848.drv to BtPciVid.drv.
// Revision 2.9  1997/08/23 01:42:58  rudyl
// Added sub-addr to I2CHWBlockRead & Write.
// Revision 2.8  1997/08/14 18:11:08  rudyl
// Graft from 2.7.1.3. Added Gemini support.
// Revision 2.7.1.3  1997/07/30 01:03:35  rudyl
// Gemini: Added support and I2CHWBlockRead() and I2CHWBlockWrite().
// Revision 2.7.1.2  1997/07/23 00:14:44  rudyl
// Added APIs to get dev ID, etc.
// Revision 2.7.1.1  1997/07/18 19:42:38  rudyl
// Add Gemini support.
// Revision 2.7  1997/07/18 00:43:55  rudyl
// Added define _BUILD_BT848DLL.
// Revision 2.6  1997/05/03 00:44:44  dtharp
// 848A Merge: from 2.4.1.3
// Revision 2.5  1997/04/16 15:49:16  rudyl
// Graft from 2.4.2.2:
// Added functions to thunk down to capture driver.
// Revision 2.4.2.2  1997/03/20 23:31:42  rudyl
// Added thunk.
// Revision 2.4.2.1  1997/03/20 21:14:16  rudyl
// Thunk from 32 bit dll to capture driver.
// Revision 2.4  1996/06/25 21:57:42  rudyl
// Added I2CGetLastError() and changed return types for I2CInitHWMode() and I2CInitSWMode().
// Revision 2.3  1996/06/25 19:21:54  ssm
// added decoder register write permission checking
// Revision 2.2  1996/06/21 05:15:05  rudyl
// Added ReadDecoder() and only function prototype for WriteDecoder().
// Still need to add meat into WriteDecoder().
// Revision 2.1  1996/06/10 20:12:02  ssm
// MarkBeta1AsRev2
// Revision 1.8  1996/05/30 19:08:25  rudyl
// Removed vxd related calls from Bt848api.h to vxdcall.h.
// Moved define of __BT848CLASS & __BT848FUNC to def__.h so both Bt848api.h and vxdCall.h can include it.
// Also added software control of I2C; seems working properly but need to cleanup the codes and add comments.
// Revision 1.7  1996/05/24 18:38:48  rudyl
// Added software control of SCL & SDA. Code compiled OK. No testing done.
// Revision 1.6  1996/05/23 19:20:01  rudyl
// Added functions skeleton (no code inside) for software control of I2C.
// Revision 1.4  1996/04/30 01:11:32  sasha
// Removed DMA related functions.  Added DLLEntryPoint and moved 
// base address initialization there. Added support for thunks
// Revision 1.3  1996/04/29 17:51:32  rudyl
// A few parameter type changes in I2C (thus in API) to make it consistent with GPIO.
// Revision 1.2  1996/04/28 01:25:17  rudyl
// ver 1.00 - both I2C and GPIO are now objects of register class.
// Created a set of API wrapper functions to invoke member functions of the classes.
// Revision 1.1  1996/04/26 23:19:33  rudyl
// Initial revision
// Revision 1.1  1996/04/26 23:12:28  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation. All Rights Reserved.
//
//  Module:
//
//    Bt848api.cpp
//
//  Abstract:
//
//    Implementation file for BT848 API DLL
//    This file contains a set of API calls for the I2C and GPIO classes.
//    Each function defined here invokes the corresponding member function
//    of the specified class. All the API functions here serve the purpose
//    of wrapping around the classes defined internally.
//
/////////////////////////////////////////////////////////////////////////////

#define _BUILD_BT848DLL    // all __BT848FUNC functions are exported
                                                                                            
#include "bt848api.h"
#include "i2c.h"
#include "gpio.h"
#include "848lin.h"
#include "decPerm.h"
#include "hwinfo.h"

/////////////////////////////////////////////////////////////////////////////
// External Variables
/////////////////////////////////////////////////////////////////////////////
extern HANDLE hVxD;                           // handle to VxD

/////////////////////////////////////////////////////////////////////////////
// Instantiate objects of the internal classes
/////////////////////////////////////////////////////////////////////////////
I2C i2c;
GPIO gpio;


/////////////////////////////////////////////////////////////////////////////
// I2C DATA/CONTROL REGISTER API
/////////////////////////////////////////////////////////////////////////////

bool __BT848FUNC I2CIsInitOK( void )
{
   return i2c.IsInitOK();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CInitHWMode( long freq )
{
   return i2c.I2CInitHWMode( freq );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CInitSWMode( long freq )
{
   return i2c.I2CInitSWMode( freq );
}

//---------------------------------------------------------------------------
void __BT848FUNC I2CSetFreq( long freq )
{
   i2c.I2CSetFreq( freq );
}

//---------------------------------------------------------------------------
int __BT848FUNC I2CReadDiv( void )
{
   return i2c.I2CReadDiv();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CHWRead( BYTE address, BYTE *value )
{
   return i2c.I2CHWRead( address, value );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CHWWrite2( BYTE address, BYTE value1 )
{
   return i2c.I2CHWWrite2( address, value1 );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CHWWrite3( BYTE address, BYTE value1, BYTE value2 )
{
   return i2c.I2CHWWrite3( address, value1, value2 );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWStart( void )
{
   return i2c.I2CSWStart();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWStop( void )
{
   return i2c.I2CSWStop();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWRead( BYTE * value )
{
   return i2c.I2CSWRead( value );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWWrite( BYTE value )
{
   return i2c.I2CSWWrite( value );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWSendACK( void )
{
   return i2c.I2CSWSendACK();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWSendNACK( void )
{
   return i2c.I2CSWSendNACK();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWSetSCL( Level scl )
{
   return i2c.I2CSWSetSCL( scl );
}

//---------------------------------------------------------------------------
int __BT848FUNC I2CSWReadSCL( void )
{
   return i2c.I2CSWReadSCL();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSWSetSDA( Level sda )
{
   return i2c.I2CSWSetSDA( sda );
}

//---------------------------------------------------------------------------
int __BT848FUNC I2CSWReadSDA( void )
{
   return i2c.I2CSWReadSDA();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CSetSync( State sync )
{
   return i2c.I2CSetSync( sync );
}

//---------------------------------------------------------------------------
int __BT848FUNC I2CReadSync( void )
{
   return i2c.I2CReadSync();
}

//---------------------------------------------------------------------------
int __BT848FUNC I2CGetLastError( void )
{
   return i2c.I2CGetLastError();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CHWMultiWrite( BYTE address, BYTE subAddr, BYTE * pBlock, int len )
{
   return i2c.I2CHWMultiWrite( address, subAddr, pBlock, len );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC I2CHWMultiRead( BYTE address, BYTE subAddr, BYTE * pBlock, int len )
{
   return i2c.I2CHWMultiRead( address, subAddr, pBlock, len );
}


/////////////////////////////////////////////////////////////////////////////
// GPIO, GPOE, GPIE, and GPDATA REGISTER API
/////////////////////////////////////////////////////////////////////////////

bool __BT848FUNC GPIOIsInitOK( void )
{
   return gpio.IsInitOK();
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPCLKMODE( State s )
{
   gpio.SetGPCLKMODE( s );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPCLKMODE( void )
{
   return gpio.GetGPCLKMODE();
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPIOMODE( GPIOMode mode )
{
   gpio.SetGPIOMODE( mode );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPIOMODE( void )
{
   return gpio.GetGPIOMODE();
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPWEC( State s )
{
   gpio.SetGPWEC( s );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPWEC( void )
{
   return gpio.GetGPWEC();
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPINTI( State s )
{
   gpio.SetGPINTI( s );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPINTI( void )
{
   return gpio.GetGPINTI();
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPINTC( State s )
{
   gpio.SetGPINTC( s );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPINTC( void )
{
   return gpio.GetGPINTC();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC SetGPOEBit( int bit, State s )
{
   return gpio.SetGPOE( bit, s );
}

//---------------------------------------------------------------------------
void __BT848FUNC SetGPOE( DWORD value )
{
   gpio.SetGPOE( value );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPOEBit( int bit )
{
   return gpio.GetGPOE( bit );
}

//---------------------------------------------------------------------------
DWORD __BT848FUNC GetGPOE( void )
{
   return gpio.GetGPOE();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC SetGPIEBit( int bit , State s )
{
   return gpio.SetGPIE( bit, s );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC SetGPIE( DWORD value )
{
   return gpio.SetGPIE( value );
}

//---------------------------------------------------------------------------
int __BT848FUNC GetGPIEBit( int bit )
{
   return gpio.GetGPIE( bit );
}

//---------------------------------------------------------------------------
DWORD __BT848FUNC GetGPIE( void )
{
   return gpio.GetGPIE();
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC SetGPDATA( GPIOReg *data, int size, int offset )
{
   return gpio.SetGPDATA( data, size, offset );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC GetGPDATA( GPIOReg *data, int size, int offset )
{
   return gpio.GetGPDATA( data, size, offset );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC SetGPDATABits( int fromBit, int toBit, DWORD value, int offset )
{
   return gpio.SetGPDATA( fromBit, toBit, value, offset );
}

//---------------------------------------------------------------------------
ErrorCode __BT848FUNC GetGPDATABits( int fromBit, int toBit, DWORD *value, int offset )
{
   return gpio.GetGPDATA( fromBit, toBit, value, offset );
}


/////////////////////////////////////////////////////////////////////////////
// DECODER REGISTER API
/////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------
// Local Function Prototypes
//---------------------------------------------------------------------------
ErrorCode LegalDecoderOffset( WORD regOffset );


/////////////////////////////////////////////////////////////////////////////
//  Method:  ErrorCode ReadDecoder( WORD regOffset, BYTE * value )
//  Purpose: Read a decoder register's content
//  Input:   WORD regOffset - offset of the register to retrieve (must be in
//                            DWORD boundary)
//  Output:  BYTE * value   - byte read from decoder
//  Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC ReadDecoder( WORD regOffset, BYTE * value )
{
   if( LegalDecoderOffset( regOffset ) != Success )
      return( Fail );

   // now declare a byte register with the specified offset
   RegisterB reg ( regOffset, RO );

   // obtain the content of the register
   *value = reg;

   return ( Success );
}

/////////////////////////////////////////////////////////////////////////////
//  Method:  ErrorCode WriteDecoder( WORD regOffset, BYTE value )
//  Purpose: Modify a decoder register's content
//  Input:   WORD regOffset - offset of the register to modify (must be in
//                            DWORD boundary)
//           BYTE value     - value to set to
//  Output:  None
//  Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC WriteDecoder( WORD regOffset, BYTE value )
{
   if( LegalDecoderOffset( regOffset ) != Success )
      return( Fail );

   // user passes in Bt848 reg adr, we need to div by 4 for
   // lookup into perm array
   unsigned char mask = decoderWriteMask[ (regOffset >> 2) ];

   if ( mask == 0x00 )
      return( Fail );	// no writes allowed to this reg

   // now declare a byte register with the specified offset
   RegisterB reg ( regOffset, RW );

   // this code just prevents the user from changing a read-only
   // bit,  It does not report success or failure.
   unsigned char change = value & mask;  // bits that may be changed
   unsigned char save = reg & ~mask;  // bits that may not be changed

   // now modify content of register
   reg = change | save;

   return ( Success );
}


/////////////////////////////////////////////////////////////////////////////
// HARDWARE INFORMATION API
/////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------
//  Method:  WORD GetHWDeviceID( void )
//  Purpose: Obtain hardware device ID
//  Input:   None
//  Output:  None
//  Return:  Hardware device ID or 0xFFFF if error
//---------------------------------------------------------------------------
WORD __BT848FUNC GetHWDeviceID( void )
{
   HWInfo hwInfo;
   return hwInfo.GetDeviceID();
}

//---------------------------------------------------------------------------
//  Method:  int GetHWRevisionID( void )
//  Purpose: Obtain hardware revision ID
//  Input:   None
//  Output:  None
//  Return:  Hardware revision ID or 0xFF if error
//---------------------------------------------------------------------------
int __BT848FUNC GetHWRevisionID( void )
{
   HWInfo hwInfo;
   return (int)hwInfo.GetRevisionID();
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt848( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt848( void )
{
   return ( ( GetHWDeviceID() == 0x0350 ) &&    // AND
            ( ( GetHWRevisionID() == 0x00 ) ||  // 0x00 or
              ( GetHWRevisionID() & 0x01 ) ) ); // ends with 0x01
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt848A( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt848A( void )
{
   return ( ( GetHWDeviceID() == 0x0350 ) && ( GetHWRevisionID() & 0x02 ) );    // ends with 0x2
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt849A( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt849A( void )
{
   return ( GetHWDeviceID() == 0x0351 );
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt848Family( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//  Note:    Bt848 family includes Bt848, Bt848A and Bt849A
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt848Family( void )
{
   return ( IsBt848() || IsBt848A() || IsBt849A() );
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt878( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt878( void )
{
   return ( GetHWDeviceID() == 0x036E );
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt879( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt879( void )
{
   return ( GetHWDeviceID() == 0x036F );
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt880( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt880( void )
{
   return ( GetHWDeviceID() == 0x0370 );
}

//---------------------------------------------------------------------------
//  Method:  BOOL IsBt878Family( void )
//  Purpose: Check if specified hardware is installed
//  Input:   None
//  Output:  None
//  Return:  TRUE if specified hardware is found, else FALSE
//  Note:    Bt878 family includes Bt878, Bt879 and Bt880
//---------------------------------------------------------------------------
BOOL __BT848FUNC IsBt878Family( void )
{
   return ( IsBt878() || IsBt879() || IsBt880() );
}


/////////////////////////////////////////////////////////////////////////////
// LOCAL INTERNAL FUNCTIONS
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  Method:  ErrorCode LegalDecoderOffset( WORD regOffset )
//  Purpose: Check if decoder register offset is valid
//  Input:   WORD regOffset - offset of the decoder register to verified
//  Output:  None
//  Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode LegalDecoderOffset( WORD regOffset )
{
   // the last decoder register is ODD Video Timing Control (0xEC)
   if ( regOffset > 0xFC )
      return ( Fail );

   if ( regOffset & 0x0003) // offset must be multiple of 4
      return ( Fail );

	return( Success );
}	








//---------------------------------------------------------------------------
extern "C" BOOL I2C_GPIO_ThunkConnect32( LPCSTR, LPCSTR, HINSTANCE hInst, DWORD dwReason );

extern "C" BOOL DRV_ThunkConnect32( LPCSTR, LPCSTR, HINSTANCE hInst, DWORD dwReason );

/* Function: DllEntryPoint
 * Purpose: Handles system notifications
 */
int PASCAL DllEntryPoint( HINSTANCE hInst, DWORD dwReason, LPVOID )
{
   if ( !I2C_GPIO_ThunkConnect32( "btVid_16.dll", "btVid_32.dll", hInst, dwReason ) )
      return FALSE;

   if ( !DRV_ThunkConnect32( "btVid.drv", "btVid_32.dll", hInst, dwReason ) )
      return FALSE;

   if ( dwReason == DLL_PROCESS_ATTACH )
   {
      // Establish communication with VxD
      hVxD = CreateFile( "\\\\.\\BTPCIVID",
         GENERIC_READ | GENERIC_WRITE,
         0,              // exclusive access
         NULL,           // no security
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL | FILE_FLAG_DELETE_ON_CLOSE, // | FILE_FLAG_OVERLAPPED
         NULL );

   	if ( hVxD == INVALID_HANDLE_VALUE )
   		return ( FALSE );

      // obtain base address
      LPBYTE lpRegBase = GetBt848LinearAddress();
      if ( lpRegBase != NULL )
         RegBase::SetBaseAddress( (DWORD)lpRegBase );
      else
      {
      	CloseHandle( hVxD );    // Terminate communication with VxD
         return FALSE;
      }
   }
   else if ( dwReason == DLL_PROCESS_DETACH )
   {
   	CloseHandle( hVxD );    // Terminate communication with VxD
   }

   return TRUE;
}


