// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Bt848_32/rcs/decPerm.h 1.4 1997/08/14 18:22:07 rudyl Released $
// $Log: decPerm.h $
// Revision 1.4  1997/08/14 18:22:07  rudyl
// Added Gemini support.
// Revision 1.3  1997/05/05 19:42:06  dtharp
// 848A Merge: from 1.2.1.3
// Revision 1.2.1.3  1997/02/13 01:32:26  rudyl
// updated decoder permissions.
// Revision 1.2.1.2  1997/01/23 20:46:27  rudyl
// Added permissions for new regs to Bt848A.
// Revision 1.2.1.1  1997/01/22 21:06:10  rudyl
// Start Pisces+ work.
// Add read/write permission to new decoder regs.
// Revision 1.2  1996/06/25 21:57:43  rudyl
// Added I2CGetLastError() and changed return types for I2CInitHWMode() and I2CInitSWMode().

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation. All Rights Reserved.
//
//  Module:
//
//    decPerm.h
//
//  Abstract:
//
//    Header file contains a list of writable decoder register bits
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __DECPERM_H
#define __DECPERM_H

// this array holds the decoder register write permission
// masks.  A bit set to 1 allows a write of that bit
// in the decoder registers
unsigned char decoderWriteMask[] = {
0x03,	// STATUS             array index= 0  reg offset=0x00
0x7F,	// IFORM             	array index= 1  reg offset=0x04
0x00,	// TDEC              	array index= 2  reg offset=0x08
0x00,	// CROP              	array index= 3  reg offset=0x0c
0x00,	// VDELAY_LO         	array index= 4  reg offset=0x10
0x00,	// VACTIVE_LO        	array index= 5  reg offset=0x14
0x00,	// HDELAY_LO         	array index= 6  reg offset=0x18
0x00,	// HACTIVE_LO        	array index= 7  reg offset=0x1c
0x00,	// HSCALE_HI         	array index= 8  reg offset=0x20
0x00,	// HSCALE_LO         	array index= 9  reg offset=0x24
0xFF,	// BRIGHT            	array index=10  reg offset=0x28
0xF7,	// MISCCONTROL       	array index=11  reg offset=0x2c
0xFF,	// CONTR_LO          	array index=12  reg offset=0x30
0xFF,	// SAT_U_LO          	array index=13  reg offset=0x34
0xFF,	// SAT_V_LO          	array index=14  reg offset=0x38
0xFF,	// HUE               	array index=15  reg offset=0x3c
0xF8,	// SCLOOP            	array index=16  reg offset=0x40
0x00,	// WC_UP             	array index=17  reg offset=0x44
0xE0,	// OFORM             	array index=18  reg offset=0x48
0xC0,	// VSCALE_HI         	array index=19  reg offset=0x4c
0x00,	// VSCALE_LO         	array index=20  reg offset=0x50
0x00,	// TEST              	array index=21  reg offset=0x54
0x00,	// VPOLE             	array index=22  reg offset=0x58
0x00,	// IDCODE            	array index=23  reg offset=0x5c
0xFF,	// ADELAY            	array index=24  reg offset=0x60
0xFF,	// BDELAY            	array index=25  reg offset=0x64
0x3F,	// ADC               	array index=26  reg offset=0x68
0x07,	// VTC               	array index=27  reg offset=0x6c
0x00,	// RES_1C            	array index=28  reg offset=0x70
0x00,	// RES_1D            	array index=29  reg offset=0x74
0x00,	// RES_1E            	array index=30  reg offset=0x78
0x00,	// SRESET            	array index=31  reg offset=0x7c
// now a duplicate set to handle the odd field
// note that not all of these masks have a physical register
// associated with them.  These are marked as "fake"
// I include them to avoid having to calculate the proper
// array index for registers > 0x7C
0x00,	// TGLB     array index=32  reg offset=0x80
0x78,	// TGCTRL   array index=33  reg offset=0x84
0x00,	// ODD_TDEC(fake)   	array index=34  reg offset=0x88
0x00,	// ODD_CROP          	array index=35  reg offset=0x8c
0x00,	// ODD_VDELAY_LO     	array index=36  reg offset=0x90
0x00,	// ODD_VACTIVE_LO    	array index=37  reg offset=0x94
0x00,	// ODD_HDELAY_LO     	array index=38  reg offset=0x98
0x00,	// ODD_HACTIVE_LO    	array index=39  reg offset=0x9c
0x00,	// ODD_HSCALE_HI     	array index=40  reg offset=0xa0
0x00,	// ODD_HSCALE_LO     	array index=41  reg offset=0xa4
0x00,	// ODD_BRIGHT(fake) 	array index=42  reg offset=0xa8
0xF7,	// ODD_MISCCONTROL   	array index=43  reg offset=0xac
0xFF,	// VTOTAL_LO    	   	array index=44  reg offset=0xb0
0x03,	// VTOTAL_HI    	   	array index=45  reg offset=0xb4
0x00,	// ODD_SAT_V_LO(fake)	array index=46  reg offset=0xb8
0x00,	// ODD_HUE(fake)    	array index=47  reg offset=0xbc
0xF8,	// ODD_SCLOOP        	array index=48  reg offset=0xc0
0x00,	// ODD_WC_UP(fake)  	array index=49  reg offset=0xc4
0x00,	// ODD_OFORM(fake)  	array index=50  reg offset=0xc8
0xC0,	// ODD_VSCALE_HI     	array index=51  reg offset=0xcc
0x00,	// ODD_VSCALE_LO     	array index=52  reg offset=0xd0
0x00,	// ODD_TEST(fake)   	array index=53  reg offset=0xd4
0x00,	// ODD_VPOLE(fake)  	array index=54  reg offset=0xd8
0x00,	// ODD_IDCODE(fake) 	array index=55  reg offset=0xdc
0x00,	// ODD_ADELAY(fake) 	array index=56  reg offset=0xe0
0x00,	// ODD_BDELAY(fake) 	array index=57  reg offset=0xe4
0xFF,	// FCAP    	array index=58  reg offset=0xe8
0x07,	// ODD_VTC           	array index=59  reg offset=0xec
0xFF,	// PLL_F_LO    array index=60  reg offset=0xf0
0xFF,	// PLL_F_HI    array index=61  reg offset=0xf4
0xFF,	// PLL_XCI     array index=62  reg offset=0xf8
0xFF	// DVSIF       array index=63  reg offset=0xfc
};

#endif  // __DECPERM_H

