// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Bt848_32/rcs/vxdcall.cpp 2.8 1997/08/08 22:22:15 rudyl Released $
// $Log: vxdcall.cpp $
// Revision 2.8  1997/08/08 22:22:15  rudyl
// Fix BoundsChecker warnings.
// Revision 2.7  1997/07/18 00:43:56  rudyl
// Added define _BUILD_BT848DLL.
// Revision 2.6  1997/05/28 18:02:52  trantq
// - Fix mismatched parenthesis.
// Revision 2.5  1997/05/28 17:58:22  trantq
// Merge in Bug fix ID424 
// Revision 2.4.1.2  1997/05/28 17:56:30  trantq
// Fix Bug ID 424 - DLL has no range checking.
// Revision 2.4  1997/05/28 16:49:48  trantq
// Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431
// Revision 2.3.1.2  1997/05/28 16:18:18  trantq
// Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431
// Revision 2.3.1.1  1997/05/03 00:50:26  trantq
// Add Bt848ImageLoad & Bt848UnLoadImage Bug ID 431
// Revision 2.3  1997/05/03 00:50:26  dtharp
// 848A Merge: from 2.1.1.2
// Revision 2.2  1997/04/16 15:59:39  rudyl
// Graft from 2.1.2.8:
// Added functions to thunk down to capture driver.
// Revision 2.1.2.8  1997/04/15 22:38:42  rudyl
// Removed Initialize() and Disconnect() functions.
// Revision 2.1.2.7  1997/03/27 03:13:51  rudyl
// Modified all fcns in 32 bit dll to thunk to capture driver.
// Revision 2.1.2.6  1997/03/26 18:17:47  rudyl
// Added all functions in capture driver available to Bt848_32.dll using thunking.
// Revision 2.1.2.5  1997/03/21 02:36:22  rudyl
// Added thunk from 32 bitg dll to capture driver.
// Revision 2.1.2.4  1997/03/20 23:32:13  rudyl
// Added thunk.
// Revision 2.1.2.3  1997/03/12 22:57:22  trantq
// - Add SetVideoFormat() and GetVideoFormat().
// Revision 2.1.2.2  1997/03/08 00:25:54  trantq
// - Add 32-bit version of SetSVideo() and GetSVideo().
// Revision 2.1.2.1  1997/03/07 23:07:43  trantq
// - Add 32-bit Version SetSVideo() and GetSVideo().
// Revision 2.1  1996/06/10 20:12:05  ssm
// MarkBeta1AsRev2
// Revision 1.4  1996/05/30 19:08:25  rudyl
// Removed vxd related calls from Bt848api.h to vxdcall.h.
// Moved define of __BT848CLASS & __BT848FUNC to def__.h so both Bt848api.h and vxdCall.h can include it.
// Also added software control of I2C; seems working properly but need to cleanup the codes and add comments.
// Revision 1.3  1996/05/22 21:21:29  rudyl
// Respond to changes in VxDfunc.h that channel notification names changed from I2C... to FN...
// Revision 1.2  1996/05/22 18:29:21  rudyl
// Added call to VxD when channel is about to change.
// Revision 1.1  1996/05/22 00:07:57  rudyl
// Initial revision
// Revision 1.4  1996/04/30 01:11:32  sasha
// Removed DMA related functions.  Added DLLEntryPoint and moved 
// base address initialization there. Added support for thunks
// Revision 1.3  1996/04/29 17:51:32  rudyl
// A few parameter type changes in I2C (thus in API) to make it consistent with GPIO.
// Revision 1.2  1996/04/28 01:25:17  rudyl
// ver 1.00 - both I2C and GPIO are now objects of register class.
// Created a set of API wrapper functions to invoke member functions of the classes.
// Revision 1.1  1996/04/26 23:19:33  rudyl
// Initial revision
// Revision 1.1  1996/04/26 23:12:28  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation. All Rights Reserved.
//
//  Module:
//
//    vxdCall.cpp
//
//  Abstract:
//
//    This file contains a set of function calls to the VxD requesting
//    action from the VxD.
//
/////////////////////////////////////////////////////////////////////////////

#define _BUILD_BT848DLL    // all __BT848FUNC functions are exported

#include "Bt848fcn.h"
#include "vxdfunc.h"

/////////////////////////////////////////////////////////////////////////////
// Public Variable
/////////////////////////////////////////////////////////////////////////////
HANDLE       hVxD;                           // handle to VxD


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848PreChannelChange( int channel )
// Purpose: Notify VxD that channel has been changed
// Input:   int channel - channel will be changed to
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848PreChannelChange( int channel )
{
   DWORD dwDataSize = 0;

   // tell VxD that channel is about to change
   BOOL status = DeviceIoControl( hVxD, FNPreSetChan, (void *) &channel, sizeof( int ),
                                  NULL, NULL, &dwDataSize, NULL );

   return ( ( status == TRUE ) ? Success : Fail );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848ChannelChanged( int channel )
// Purpose: Notify VxD that channel has been changed
// Input:   int channel - channel being changed to
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848ChannelChanged( int channel )
{
   DWORD dwDataSize = 0;

   // tell VxD that channel has been changed successfully
   BOOL status = DeviceIoControl( hVxD, FNSetChan, (void *) &channel, sizeof( int ),
                                  NULL, NULL, &dwDataSize, NULL );

   return ( ( status == TRUE ) ? Success : Fail );
}

//===========================================================================
// Functions thunk down to capture driver
//===========================================================================
extern "C" int   DRV_SetVideoSource( int conn );
extern "C" int   DRV_GetVideoSource( void );
extern "C" int   DRV_SetBrightness( int brightness );
extern "C" int   DRV_GetBrightness( void );
extern "C" int   DRV_SetContrast( int contrast );
extern "C" int   DRV_GetContrast( void );
extern "C" int   DRV_SetHue( int hue );
extern "C" int   DRV_GetHue( void );
extern "C" int   DRV_SetSaturation( int sat );
extern "C" int   DRV_GetSaturation( void );
extern "C" DWORD DRV_GetStatus( void );
extern "C" int   DRV_SetSVideo( int state );
extern "C" int   DRV_GetSVideo( void );
extern "C" int   DRV_SetVideoFormat( int vFormat );
extern "C" int   DRV_GetVideoFormat( void );
extern "C" void  DRV_SetCCCallback( LPVOID cb );
extern "C" int   DRV_SetCCStatus( int status );
extern "C" void  DRV_SetCCFileName( LPSTR name );
extern "C" void  DRV_SetCCAlert( LPSTR token );
extern "C" void  DRV_GetCCFileName( LPSTR name, int cnt );
extern "C" void  DRV_GetCCAlert( LPSTR token, int cnt );
extern "C" int   DRV_GetCCStatus( void );
extern "C" int   DRV_SetImage( LPRECT lpRect, int aFormat );
extern "C" int   DRV_GetImageFormat( int *pColFrmt );
extern "C" void  DRV_GetImageSize( LPRECT lpR );
extern "C" void  DRV_Pause( void );
extern "C" void  DRV_Continue( void );
extern "C" int   DRV_Initialize( void );
extern "C" void  DRV_Disconnect( void );
extern "C" DWORD DRV_GetOverlayFlags( void );
extern "C" DWORD DRV_ImageLoad( HINSTANCE hInst, HWND hWnd, LPSTR lpBitmap );
extern "C" DWORD DRV_UnLoadImage( void );

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetVideoSource( Connector conn )
// Purpose: Request VxD to set video source
// Input:   Connector conn - ConCamera, ConSVideo, ConTuner, ConComposite
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetVideoSource( Connector conn )
{
   return (ErrorCode)DRV_SetVideoSource( (int)conn );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetVideoSource( Connector * conn )
// Purpose: Ask VxD what video source has set to 
// Input:   None
// Output:  Connector * conn - ConCamera, ConSVideo, ConTuner, ConComposite
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetVideoSource( Connector * conn )
{
   *conn = (Connector)DRV_GetVideoSource();
   return( Success );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetBrightness( int brightness )
// Purpose: Request VxD to set video brightness
// Input:   int brightness - brightness value
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetBrightness( int brightness )
{
   if ( (brightness < 0) || (brightness > 255) )
	  return ( Fail );
   return (ErrorCode)DRV_SetBrightness( (int)brightness );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetBrightness( int * brightness )
// Purpose: Ask VxD what brightness value has set to
// Input:   None
// Output:  int * brightness - brightness value
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetBrightness( int * brightness )
{
   *brightness = DRV_GetBrightness();
   if ( (*brightness < 0) || (*brightness > 255) )
	  return ( Fail );
   return( Success );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetContrast( int contrast )
// Purpose: Request VxD to set video contrast
// Input:   int contrast - contrast value
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetContrast( int contrast )
{
   if ( (contrast < 0 ) || (contrast > 255)	)
	  return ( Fail );
   return (ErrorCode)DRV_SetContrast( (int)contrast );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetContrast( int * contrast )
// Purpose: Ask VxD what contrast value has set to
// Input:   None
// Output:  int * contrast - contrast value
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetContrast( int * contrast )
{
   *contrast = DRV_GetContrast();
   if ( (*contrast < 0 ) || (*contrast > 255) )
	  return ( Fail );
   return( Success );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetHue( int hue )
// Purpose: Request VxD to set video hue
// Input:   int hue - hue value
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetHue( int hue )
{
   if ( (hue < 0) || (hue > 255) )
	  return ( Fail );
   return (ErrorCode)DRV_SetHue( (int)hue );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetHue( int * hue )
// Purpose: Ask VxD what hue value has set to
// Input:   None
// Output:  int * hue - hue value
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetHue( int * hue )
{
   *hue = DRV_GetHue();
   if ( (*hue < 0) || (*hue > 255) )
	  return ( Fail );
   return( Success );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetSaturation( int sat )
// Purpose: Request VxD to set video saturation
// Input:   int sat - saturation value
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetSaturation( int sat )
{
   if ( (sat < 0) || (sat > 255) )
	  return ( Fail );
   return (ErrorCode)DRV_SetSaturation( (int)sat );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetSaturation( int * sat )
// Purpose: Ask VxD what saturation value has set to
// Input:   None
// Output:  int * sat - saturation value
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetSaturation( int * sat )
{
   *sat = DRV_GetSaturation();
   if ( (*sat < 0) || (*sat > 255) )
	  return ( Fail );
   return( Success );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  DWORD __BT848FUNC Bt848GetStatus( void )
// Purpose: Obtain STATUS register content
// Input:   None
// Output:  None
// Return:  status register content
/////////////////////////////////////////////////////////////////////////////
DWORD __BT848FUNC Bt848GetStatus( void )
{
   return DRV_GetStatus();
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetSVideo(State s)
// Purpose: Request VxD to set status of SVideo
// Input:   State s - {Off, On}
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetSVideo( State s )
{
   return (ErrorCode)DRV_SetSVideo( (int)s );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetSVideo( State *s)
// Purpose: Request tp VxD to get status of SVideo
// Input:   State *s - A pointer to variable of type State.
// Output:  State *s - {Off,On}
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetSVideo( State *s )
{
   *s = (State)DRV_GetSVideo();
   return( Success );
}



/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848SetVideoFormat(VideoFormat vf)
// Purpose: Request VxD to set status of SVideo
// Input:   VideoFormat vf - { VFormat_AutoDetect, VFormat_NTSC,
//                			   VFormat_NTSC_J,     VFormat_PAL_BDGHI,
//                			   VFormat_PAL_M,      VFormat_PAL_N,
//                			   VFormat_SECAM,      VFormat_PAL_NC }
// Output:  None
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetVideoFormat( VideoFormat vf )
{
   return (ErrorCode)DRV_SetVideoFormat( (int)vf );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode __BT848FUNC Bt848GetVideoFormat ( VideoFormat *vf)
// Purpose: Request tp VxD to get status of SVideo
// Input:   VideoFormat vf - A pointer to variable of type VideoFormat.
// Output:  VideoFormat *vf - { VFormat_AutoDetect, VFormat_NTSC,
//                				VFormat_NTSC_J,     VFormat_PAL_BDGHI,
//                				VFormat_PAL_M,      VFormat_PAL_N,
//                				VFormat_SECAM,      VFormat_PAL_NC }
// Return:  Success or Fail
/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848GetVideoFormat( VideoFormat *vf )
{
   *vf = (VideoFormat)DRV_GetVideoFormat();
   return( Success );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848SetCCCallback( CC_CALLBACK cb )
{
   DRV_SetCCCallback( (LPVOID)cb );
}

/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetCCStatus( int status )
{
   return (ErrorCode)DRV_SetCCStatus( status );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848SetCCFileName( LPCSTR name )
{
   DRV_SetCCFileName( (LPSTR)name );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848SetCCAlert( LPCSTR token )
{
   DRV_SetCCAlert( (LPSTR)token );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848GetCCFileName( LPSTR name, int cnt )
{
   DRV_GetCCFileName( name, cnt );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848GetCCAlert( LPSTR token, int cnt )
{
   DRV_GetCCAlert( token, cnt );
}

/////////////////////////////////////////////////////////////////////////////
int __BT848FUNC Bt848GetCCStatus( void )
{
   return DRV_GetCCStatus();
}

/////////////////////////////////////////////////////////////////////////////
ErrorCode __BT848FUNC Bt848SetImage( LPRECT lpRect, ColFmt aFormat )
{
   return (ErrorCode)DRV_SetImage( lpRect, (int)aFormat );
}

/////////////////////////////////////////////////////////////////////////////
int __BT848FUNC Bt848GetImageFormat( ColFmt *pColFrmt )
{
   return DRV_GetImageFormat( (int *)pColFrmt );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848GetImageSize( LPRECT lpR )
{
   DRV_GetImageSize( lpR );
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848Pause( void )
{
   DRV_Pause();
}

/////////////////////////////////////////////////////////////////////////////
void __BT848FUNC Bt848Continue( void )
{
   DRV_Continue();
}

/////////////////////////////////////////////////////////////////////////////
DWORD __BT848FUNC Bt848GetOverlayFlags( void )
{
   return DRV_GetOverlayFlags();
}

ErrorCode __BT848FUNC Bt848ImageLoad( HINSTANCE hInst, HWND hWnd, LPCSTR szBitmap )
{
    return (ErrorCode)DRV_ImageLoad( hInst, hWnd, (LPSTR)szBitmap );
}

ErrorCode __BT848FUNC Bt848UnLoadImage( void )
{
    return (ErrorCode)DRV_UnLoadImage( );
}

