// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/CapChip/rcs/Gemini.h 1.2 1998/02/27 18:18:26 dtharp Exp $
// $Log: Gemini.h $
// Revision 1.2  1998/02/27 18:18:26  dtharp
// Capture Controler constructor now takes devID as a param.
// Revision 1.1  1997/10/21 00:35:50  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1997 Brooktree Division, Rockwell Semiconductor Systems
//
//  Module:
//
//    Gemini.h
//
//  Abstract:
//
//    Class definition for BtGemini
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __GEMINI_H
#define __GEMINI_H

#ifndef __PISCESP_H
#include "piscesp.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CLASS BtGemini
//
// Description:
//    Class definition for the Gemini capture chip. This class is derived
//    from "BtPiscesPlus" class since the HW is a next genration of the Pisces
//    Plus chip.
//
// Attributes:
//
// Methods:
//    virtual void SetTotalLineCount   ( DWORD value );
//    virtual void GetTotalLineCount   ( PDWORD pData );
//
/////////////////////////////////////////////////////////////////////////////
class BtGemini : public BtPiscesPlus
{
   public:
      // Constructor
      BtGemini(WORD devId) : BtPiscesPlus(devId) {};

      // Destructor
      ~BtGemini() {};

      // Total Line Count group
      virtual void SetTotalLineCount   ( DWORD value );
      virtual void GetTotalLineCount   ( PDWORD pData );
};

#endif  // __GEMINI_H

