// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/CapChip/rcs/PiscesP.cpp 1.2 1998/01/16 21:47:27 rudyl Exp $
// $Log: PiscesP.cpp $
// Revision 1.2  1998/01/16 21:47:27  rudyl
// Gemini Rev D: HSFMT changes from 1 to 2 bits.
// Revision 1.1  1997/02/04 18:20:09  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Division, Rockwell Semiconductor Systems
//
//  Module:
//
//    PiscesP.cpp
//
//  Abstract:
//
//    Class Implementation for BtPiscesPlus
//
/////////////////////////////////////////////////////////////////////////////

#include "PiscesP.h"

/////////////////////////////////////////////////////////////////////////////
// Method: void BtPiscesPlus::SetSignalFormat( DWORD value )
// Purpose: Set video signal format
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetSignalFormat( DWORD value )
{
   GetDecoder().SetVideoSignalFormat( SignalFormat( value ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetSignalFormat( PDWORD pData )
{
   *pData = GetDecoder().GetVideoSignalFormat();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetSyncRef( DWORD value )
{
   GetDecoder().SetSyncVideoRef( SyncVideoRef( value ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetSyncRef( PDWORD pData )
{
   *pData = GetDecoder().GetSyncVideoRef();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetSyncOutput( DWORD value )
{
   GetDecoder().EnableSyncOutput( bool( value ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetSyncOutput( PDWORD pData )
{
   *pData = GetDecoder().IsSyncOutputEnabled();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetHReset( DWORD value )
{
   GetDecoder().SetHReset( value );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetHReset( PDWORD pData )
{
   *pData = GetDecoder().GetHReset();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetVideoInfo( VideoInfo info )
{
   Scaler::SetVideoInfo( info );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetVideoInfo( VideoInfo * pData  )
{
   Scaler::GetVideoInfo( pData );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetPLL( PLLInfo value )
{
   const int MAX_PLL_WAIT = 100;    // max wait is 100ms

   PLL_.SetPLL( (BYTE)value.f_lo, (BYTE)value.f_hi, (BYTE)value.i,
                (bool)value.c, (bool)value.x );

   // After initialized PLL, need to read and clear PLL out of lock bit until
   // it is no longer set (may take ~100ms)
   DWORD dwTickCount = Get_System_Time();
   while ( Get_System_Time() < dwTickCount + MAX_PLL_WAIT )
      if ( GetDecoder().IsPLLOutOfLock() )
         GetDecoder().ResetPLLOutOfLock();
      else
         break;
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetPLL( PLLInfo * pData )
{
   *pData = PLLInfo( PLL_.GetPLL_F_LO(), PLL_.GetPLL_F_HI(), PLL_.GetPLL_I(),
                     PLL_.GetPLL_C(), PLL_.GetPLL_X() );

}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetTimGenLoadByte( PBYTE pData, DWORD dwSize )
{
   TimGen_.LoadSRAM( pData, int( dwSize ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetTimGenLoadByte( PBYTE pData, PDWORD pSize )
{
   *pSize = TimGen_.BytesInSRAM();
   TimGen_.ReadSRAM( pData, *pSize );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetDecInputClock( DWORD pData )
{
   TimGen_.SetDecoderInputClock( DecInputClk( pData ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetDecInputClock( PDWORD pData )
{
   *pData = TimGen_.GetDecoderInputClock();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::SetGPCLKOutputClock( DWORD pData )
{
   TimGen_.SetGPCLKOutputClock( GPCLKOutputClk( pData ) );
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetGPCLKOutputClock( PDWORD pData )
{
   *pData = TimGen_.GetGPCLKOutputClock();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::ResetFieldCounter( void )
{
   FieldCounter_.ResetCounter();
}

/////////////////////////////////////////////////////////////////////////////
// Method:
// Purpose:
// Input:
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void BtPiscesPlus::GetFieldCounter( PDWORD pData )
{
   *pData = FieldCounter_.GetCounter();
}


