// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/CapChip/rcs/PiscesP.h 1.2 1998/02/27 18:18:28 dtharp Exp $
// $Log: PiscesP.h $
// Revision 1.2  1998/02/27 18:18:28  dtharp
// Capture Controler constructor now takes devID as a param.
// Revision 1.1  1997/02/04 18:20:10  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Division, Rockwell Semiconductor Systems
//
//  Module:
//
//    PiscesP.h
//
//  Abstract:
//
//    Class definition for BtPiscesPlus
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __PISCESP_H
#define __PISCESP_H

#ifndef __PISCES_H
#include "pisces.h"
#endif

#ifndef __PLL_H
#include "pll.h"
#endif

#ifndef __TIMGEN_H
#include "timgen.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CLASS BtPiscesPlus
//
// Description:
//    Class definition for the Pisces+ capture chip. This class is derived
//    from "BtPisces" class since the HW is a second genration of the Pisces
//    chip.
//
// Attributes:
//    PLL_     : instance of PLL
//    TimGen_  : instance of the timing generator block
//
// Methods:
//
/////////////////////////////////////////////////////////////////////////////
class BtPiscesPlus : public BtPisces
{
   public:
      // Constructor
      BtPiscesPlus(WORD devId) : BtPisces (devId) {};

      // Destructor
      ~BtPiscesPlus() {};

      // Decoder group
      virtual void SetSignalFormat     ( DWORD value );
      virtual void SetSyncRef          ( DWORD value );
      virtual void SetSyncOutput       ( DWORD value );
      virtual void SetHReset           ( DWORD value );
      virtual void GetSignalFormat     ( PDWORD pData );
      virtual void GetSyncRef          ( PDWORD pData );
      virtual void GetSyncOutput       ( PDWORD pData );
      virtual void GetHReset           ( PDWORD pData );

      // Scaler group
      virtual void SetVideoInfo        ( VideoInfo info );
      virtual void GetVideoInfo        ( VideoInfo * pData );

      // PLL group
      virtual void SetPLL              ( PLLInfo value );
      virtual void GetPLL              ( PLLInfo * pData );

      // Timing generator group
      virtual void SetTimGenLoadByte   ( PBYTE pData, DWORD dwSize );
      virtual void SetDecInputClock    ( DWORD pData );
      virtual void SetGPCLKOutputClock ( DWORD pData );
      virtual void GetTimGenLoadByte   ( PBYTE pData, PDWORD pSize );
      virtual void GetDecInputClock    ( PDWORD pData );
      virtual void GetGPCLKOutputClock ( PDWORD pData );

      // Field Counter group
      virtual void ResetFieldCounter   ( void );
      virtual void GetFieldCounter     ( PDWORD pData );

   protected:
      // new components in Pisces+ chip
      PLL          PLL_;
      TimGen       TimGen_;
      FieldCounter FieldCounter_;

};

#endif  // __PISCESP_H
