/* File: Callback.cpp
 * Purpose: Contains implementation of the various callbacks for various events
 * Author: sasha
 * $Log: callback.cpp $
 * Revision 1.2  1997/09/04 22:45:06  dtharp
 * Merged VSYNC Callback changes
 * Revision 1.1.1.1  1997/08/21 01:40:49  dtharp
 * Branch for vsync callback
 * Revision 1.1  1996/10/02 04:50:43  sasha
 * Initial revision
 */

#include "pisces.h"

// this injects opcode for the call eax; this saves push ebp/pop ebp which is not really needed
#define CALL_EAX  asm { db 0xFF; db 0xD0; }

/* Method: BtPisces::CallbackI2C
 * Purpose: Calls back a client when I2C interrupt occurs
 */
void BtPisces::CallbackI2C()
{
   _EAX = I2C_CB_;
   CALL_EAX;
}

/* Method: BtPisces::CallbackVSYNC
 * Purpose: Calls back a client when VSYNC interrupt occurs
 */
void BtPisces::CallbackVSYNC()
{
   _EAX = VSYNC_CB_;
   CALL_EAX;
}

/* Method: BtPisces::CallbackGPIO
 * Purpose: Calls back a client when GPIO interrupt occurs
 */
void BtPisces::CallbackGPIO()
{
   _EAX = GPIO_CB_;
   CALL_EAX;
}

/* Method: BtPisces::InterruptEventProc
 * Purpose
 */
void BtPisces::InterruptEventProc( DWORD, PVOID pTag )
{
   ( (BtPisces *)pTag )->ProcessRISCIntr();
}

/* Method: BtPisces::InterruptNotifyProc
 * Purpose
 */
void BtPisces::InterruptNotifyProc( DWORD, PVOID )
{
   if ( NotifyEvent_ )
      VWIN32_SetWin32Event( NotifyEvent_ );
}
