/* File: Api.h
 * Purpose: Function prototypes
 
 * $Log: API.H $
 * Revision 2.14  1998/03/28 01:27:09  rudyl
 * Graft from 2.13.1.1: Moved QuartzSight init to vxd.
 * Revision 2.13.1.1  1998/03/24 01:54:34  rudyl
 * Moved QuartzSight init to vxd.
 * Revision 2.13  1998/02/24 19:47:03  rudyl
 * Graft from 2.12.1.3.
 * Revision 2.12.1.3  1998/02/24 19:46:33  rudyl
 * Removed unused functions.
 * Revision 2.12.1.2  1998/02/24 19:38:15  rudyl
 * Added VVL's VPAEC interface.
 * Revision 2.12.1.1  1998/01/16 21:53:16  rudyl
 * Duplicate revision
 * Revision 2.11  1997/12/13 01:49:19  rudyl
 * Graft from 2.10.1.1. Added SRAM API.
 * Revision 2.10.1.1  1997/11/27 03:11:13  rudyl
 * Moved SRAM table to dialogs.dll.
 * Revision 2.10  1997/11/26 06:29:41  rudyl
 * Added support of Scotch.
 * Revision 2.9  1997/10/29 18:41:00  dtharp
 * Merged TrueView branch.
 * Revision 2.8.1.2  1997/10/29 02:19:29  rudyl
 * Added trueview.
 * Revision 2.8.1.1  1997/10/29 00:07:00  dtharp
 * TrueView Branch
 * Revision 2.8  1997/10/21 02:01:18  rudyl
 * Added support to expected total line count by decoder.
 * Revision 2.7  1997/07/31 10:46:38  dtharp
 * Cleaned up multiple CC_CALLBACK definitions.
 * Revision 2.6  1997/05/28 16:57:28  trantq
 * Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431
 * Revision 2.5.1.2  1997/05/28 15:47:50  trantq
 * Add Bt848ImageLoad & Bt848UnLoadImage.  Bug ID 431
 * Revision 2.5.1.1  1997/05/05 17:40:58  trantq
 * Add feature LoadImage of DD Surface.  Bug ID 431
 * Revision 2.5  1997/05/05 17:40:58  dtharp
 * 848A Merge: from 2.4.1.4
 * Revision 2.4.1.4  1997/02/14 23:40:09  rudyl
 * Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.
 * Revision 2.4.1.3  1997/02/11 23:52:24  rudyl
 * Added PCI check for Bt848A existence.
 * Revision 2.4.1.2  1997/02/03 23:39:11  rudyl
 * First Pisces+ check in.
 * Revision 2.4.1.1  1996/11/08 19:09:59  rudyl
 * Start Pisces+ work.
 * Revision 2.4  1996/10/02 04:26:23  sasha
 * Added CC_CALLBACK typedef and SetCCCallback() API.
 * Revision 2.3  1996/06/26 21:27:09  sasha
 * Added GetOverlayFlags() API
 * Revision 2.2  1996/06/26 19:07:28  sasha
 * Added Pause() and Continue() functions that freeze/unfreeze Pisces
 * Revision 2.1  1996/06/10 20:12:55  ssm
 * MarkBeta1AsRev2
 * Revision 1.10  1996/06/05 19:51:26  sasha
 * Added functions for getting the CC file name and alert token
 * Revision 1.9  1996/06/05 18:20:13  sasha
 * Added CC file name and alert functions
 * Revision 1.8  1996/06/05 00:26:52  ssm
 * added CUT HERE token for awk processing
 
 * Initial revision
 */

/* CUT_HERE */

/* File: Api.h */

#ifndef __API_H
#define __API_H

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __RETCODE_H
#include "retcode.h"
#endif

#include "dcdrvals.h"

#ifdef __cplusplus
extern "C" {
#endif

#define LimitRange( Val, Low, Hi ) ( max( Low,( min( Val,Hi ) ) ) )


#ifndef __VIDDEFS_H
#include "viddefs.h"
#endif

#ifndef __COLFRMAT_H
#include "colfrmat.h"
#endif

#include "common.h"

void WINAPI SetCCCallback( CC_CALLBACK );
  
// external video in channel
ErrorCode WINAPI SetConnector( Connector AConn, BOOL ApplyImm );
ErrorCode WINAPI SetSVideo( State aState );
ErrorCode WINAPI SetBrightness( int percentOfFullScale );
ErrorCode WINAPI SetContrast( int percentOfFullScale );
ErrorCode WINAPI SetHue( int degrees );
ErrorCode WINAPI SetSaturation( int percentOfFullScale );
ErrorCode WINAPI SetVideoFormat( VideoFormat aFormat );
ErrorCode WINAPI SetCCStatus( int );
void      WINAPI SetCCFileName( LPCSTR name );
void      WINAPI SetCCAlert( LPCSTR token );
void      WINAPI GetCCFileName( LPSTR name, int cnt );
void      WINAPI GetCCAlert( LPSTR token, int cnt );
DWORD     WINAPI GetStatus();
// video in channel
ErrorCode WINAPI SetImage( LPRECT lpRect, ColFmt aFormat );

// 'get' group
Connector   WINAPI GetConnector( void );
State       WINAPI GetSVideo( void );
VideoFormat WINAPI GetVideoFormat( void );
int         WINAPI GetBrightness( void );
int         WINAPI GetContrast( void );
int         WINAPI GetHue( void );
int         WINAPI GetSaturation( void );
int         WINAPI GetImageFormat( ColFmt *pColFrmt );
void        WINAPI GetImageSize( LPRECT lpR );
int         WINAPI GetCCStatus( void );

void WINAPI _export Pause();
void WINAPI _export Continue();

ErrorCode   WINAPI Initialize( void );
void        WINAPI Disconnect( void );
DWORD       WINAPI GetOverlayFlags( void );

// 'set' group
ErrorCode      WINAPI SetSignalFormat( SignalFormat sFormat );
ErrorCode      WINAPI SetSyncVideoRef( SyncVideoRef syncRef );
ErrorCode      WINAPI SetDecInputClock( DecInputClk iClk );
ErrorCode      WINAPI SetOutputClock( GPCLKOutputClk oClk );
ErrorCode      WINAPI SetEnableSyncOutput( State state );
ErrorCode      WINAPI SetTimGenByte( BYTE * tgb, int size );
ErrorCode      WINAPI SetHReset( int clk );
ErrorCode      WINAPI SetPLL( PLLFreq pll );
ErrorCode      WINAPI SetVideoInfo( VSIZEPARMS vSize );
ErrorCode      WINAPI SetTotalLineCount( int lines );
ErrorCode      WINAPI SetInterlaceMode( int mode );
ErrorCode      WINAPI SetQuartzSightMode( BOOL state ) ;
ErrorCode      WINAPI SetQuartzSightParam( BYTE param, BYTE value );

// 'get' group
SignalFormat   WINAPI GetSignalFormat( void );
SyncVideoRef   WINAPI GetSyncVideoRef( void );
DecInputClk    WINAPI GetDecInputClock( void );
GPCLKOutputClk WINAPI GetOutputClock( void );
State          WINAPI GetEnableSyncOutput( void );
ErrorCode      WINAPI GetTimGenByte( BYTE * tgb, int * size );
int            WINAPI GetHReset( void );
PLLFreq        WINAPI GetPLL( void );
ErrorCode      WINAPI GetVideoInfo( VSIZEPARMS * vsize );
int            WINAPI GetTotalLineCount( void );
int            WINAPI GetInterlaceMode( void );
BOOL           WINAPI GetQuartzSightMode( void ) ;
ErrorCode      WINAPI GetQuartzSightParam( BYTE param, BYTE * pValue );

ErrorCode      WINAPI ResetFieldCounter( void );
int            WINAPI GetFieldCounter( void );

int            WINAPI GetHWRevisionID( void );
BOOL           WINAPI IsABt848A( void );
BOOL           WINAPI IsBt878Family( void );

ErrorCode   WINAPI ImageLoad( HINSTANCE hInst, HWND hWnd, LPCSTR szBitmap );
ErrorCode   WINAPI UnLoadImage( void );


#ifdef __cplusplus
}
#endif

#endif
