/* File: ResDef.h
 * $Log: ResDef.h $
 * Revision 1.6  1998/03/28 01:32:25  rudyl
 * Graft from 1.5.1.1: Moved QuartzSight init to vxd.
 * Revision 1.5.1.1  1998/03/24 01:34:08  rudyl
 * Perform VVL init in vxd. Removed from capdrv.
 * Revision 1.5  1997/12/13 01:52:33  rudyl
 * Graft from 1.4.1.1. Added SRAM API.
 * Revision 1.4.1.1  1997/11/27 03:12:35  rudyl
 * Moved SRAM table to dialogs.dll.
 * Revision 1.4  1997/11/26 06:30:11  rudyl
 * Added support of Scotch.
 * Revision 1.3  1997/10/20 21:26:50  rudyl
 * The SRAM table for the QuartzSight camera is for 392 lines.
 * Revision 1.2  1997/09/15 18:40:57  rudyl
 * Added support to "Rockwell QuartzSight PCI 1.0" camera.
 * Revision 1.1  1997/02/04 18:21:24  rudyl
 * Initial revision
 */

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Division, Rockwell Semiconductor Systems
//
//  Module:
//
//    ResDef.h
//
//  Abstract:
//
//     Contains defines for resources in RCDATA section of capture driver
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __RESDEF_H
#define __RESDEF_H

#define RC_PLL_BASE        400            // NOPLL uses this ID
#define RC_PLL_14MHZ_BASE  RC_PLL_BASE+10 // allow 10 entries per ref freq
#define RC_PLL_28MHZ_BASE  RC_PLL_BASE+20 // if more than 10 frequencies are to
#define RC_PLL_35MHZ_BASE  RC_PLL_BASE+30 // be synthesized, increase this gap.
#define RC_PLL_NOPLL       0              // Only 1 NOPLL exists at RC_PLL_BASE
#define RC_PLL_28636KHZ    1              // These defines MUST have same
#define RC_PLL_35469KHZ    2              // enum values as typedef PLLFreq
#define RC_PLL_27000KHZ    3              // in viddefs.h in order to compile
#define RC_PLL_24545KHZ    4              // clean.
#define RC_PLL_29500KHZ    5
#define RC_PLL_19636KHZ    6

#endif   // __RESDEF_H