/* File: Vxdiface.h
 * Purpose: Declaration of the VxDIface class
 * Author: sasha
 * $Log: VXDIFACE.H $
 * Revision 2.1  1996/06/10 20:13:12  ssm
 * MarkBeta1AsRev2
 * Revision 1.4  1996/02/18 05:26:19  sasha
 * Removed argument name from Load and Unload functions ( to prevent warnings )
 * Revision 1.3  1996/01/22 20:36:12  sasha
 * Changed calls to VxD ( added an arument )
 * Revision 1.2  1996/01/04 23:21:26  sasha
 * First real check-in. Too many changes since previous version
 * Revision 1.1  1995/09/07 06:11:56  sasha
 * Initial revision
 */

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __VXDFUNC_H
#include "vxdfunc.h"
#endif

#ifndef __MYTYPES_H
#include "mytypes.h"
#endif

#define Not_VxD
#pragma option -C- // stupid file has a bunch of mismatched comments
#include "vmm.h"
#pragma option -C.

#include "vxdid.h"

typedef void ( FAR *VXD_ENTRY )();

/* Class: VxDIface
 * Purpose: This class performs communications between the ring3 capture driver
 *   and the VxD portion
 * Attributes: PiscesVxD: pointer to a far function
 * Operations:
 *    void LoadVxD( LPCSTR VxDName );
 *    void UnloadVxD( LPCSTR VxDName );
 *    bool IsInited();
 *    void CallVxD( FuncNumber, LPVOID lpData );
 * Note: right now the class does not have a constructor to unload
 *   VxD automatically
 */
class VxDIface
{
   private:
      VXD_ENTRY   PiscesVxD_;
      VXD_ENTRY   GetVxDEntry( const int id );
   public:
      void LoadVxD();
      void UnloadVxD();
      bool IsInited() { return bool( PiscesVxD_ != NULL ); }
      ErrorCode CallVxD( FuncNumber func, LPVOID pData = NULL, DWORD dwData = NULL,
         DWORD hChannel = NULL );
//      ErrorCode CallVxD( FuncNumber func, LPVOID lpData, DWORD hChannel = NULL )
//         { return CallVxD( func, (DWORD)lpData, hChannel ); }
      VxDIface() : PiscesVxD_( NULL ) {}
};

