/* $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/capdrv/rcs/cc_api.cpp 1.6 1997/08/30 00:06:42 dtharp Released $ */
/****************************************************************************/
/***** Copyright (c) Brooktree Corporation, 1996. All Rights Reserved *******/
/****************************************************************************/
/*                                                                          */
/*                      BROOKTREE CONFIDENTIAL                              */
/*                                                                          */
/* Filename:    CC_API.CPP                                                  */
/*                                                                          */
/* Description: This module contains the driver side interface to the       */
/* cc.dll API.                                                              */
/*                                                                          */
/* Author:      Dave Tharp                                                  */
/*                                                                          */
/****************************************************************************/

/* 
 * $Log: cc_api.cpp $
 * Revision 1.6  1997/08/30 00:06:42  dtharp
 * Changed name of CC dll from bt84xcc.dll to btcc.dll
 * Revision 1.5  1997/06/02 21:51:18  dtharp
 * Bug id 628: flashing pink box every 5 sec in preview. CC display
 * watchdog timer is now shut down when CC is paused.
 * Revision 1.4  1996/10/10 17:27:25  dtharp
 * Removed reference to api_cc.h
 * Revision 1.3  1996/10/04 15:34:45  dtharp
 * Changed name of closed caption dll from cc.dll to Bt84xcc.dll.
 * Revision 1.2  1996/10/04 15:03:49  dtharp
 * Changes required for new CC dll API function names.
 * Revision 1.1  1996/10/03 22:38:34  dtharp
 * Initial revision
 */


#include "cc_api.h"

//
// CC Decode dll API Pointers
//
static INITDISPLAY_t   pCCINITDISPLAY  = NULL;
static KILLWATCHDOG_t  pCCKILLWATCHDOG = NULL;
static SETCCFILENAME_t pSETCCFILENAME  = NULL;
static SETCCALERT_t    pSETCCALERT     = NULL;
static GETCCFILENAME_t pGETCCFILENAME  = NULL;
static GETCCALERT_t    pGETCCALERT     = NULL;
static PROCESS_t       pCCPROCESS      = NULL;
static DISPLAY_t       pCCDISPLAY      = NULL;
static CREATEFONTS_t   pCC_CREATEFONTS = NULL;
static ERASE_t         pCCERASE        = NULL;
static SETCHANNEL_t    pCCSETCHANNEL   = NULL;
static GETCHANNEL_t    pCCGETCHANNEL   = NULL;
static ERASEDISPLAY_t  pCCERASEDISPLAY = NULL;
static INITDECODE_t    pCCINITDECODE   = NULL;
static DECODE_t        pCCDECODE       = NULL;

HINSTANCE InitCcApi(void)
{
   HINSTANCE hCCDll = LoadLibrary( "Btcc.dll" );
   if ( hCCDll > HINSTANCE_ERROR ) {
      pCCINITDISPLAY  = (INITDISPLAY_t)   GetProcAddress(hCCDll,"CC_INITDISPLAY" ) ;
      pCCKILLWATCHDOG = (KILLWATCHDOG_t)  GetProcAddress(hCCDll,"CC_KILLWATCHDOG") ;
      pSETCCFILENAME  = (SETCCFILENAME_t) GetProcAddress(hCCDll,"CC_SETFILENAME" ) ;
      pSETCCALERT     = (SETCCALERT_t)    GetProcAddress(hCCDll,"CC_SETALERT"    ) ;
      pGETCCFILENAME  = (GETCCFILENAME_t) GetProcAddress(hCCDll,"CC_GETFILENAME" ) ;
      pGETCCALERT     = (GETCCALERT_t)    GetProcAddress(hCCDll,"CC_GETALERT"    ) ;
      pCCPROCESS      = (PROCESS_t)       GetProcAddress(hCCDll,"CC_PROCESS"     ) ;
      pCCDISPLAY      = (DISPLAY_t)       GetProcAddress(hCCDll,"CC_DISPLAY"     ) ;
      pCC_CREATEFONTS = (CREATEFONTS_t)   GetProcAddress(hCCDll,"CC_CREATEFONTS" ) ;
      pCCERASE        = (ERASE_t)         GetProcAddress(hCCDll,"CC_ERASE"       ) ;
      pCCSETCHANNEL   = (SETCHANNEL_t)    GetProcAddress(hCCDll,"CC_SETCHANNEL"  ) ;
      pCCGETCHANNEL   = (GETCHANNEL_t)    GetProcAddress(hCCDll,"CC_GETCHANNEL"  ) ;
      pCCERASEDISPLAY = (ERASEDISPLAY_t)  GetProcAddress(hCCDll,"CC_ERASEDISPLAY") ;
      pCCINITDECODE   = (INITDECODE_t)    GetProcAddress(hCCDll,"CC_INITDECODE"  ) ;
      pCCDECODE       = (DECODE_t)        GetProcAddress(hCCDll,"CC_DECODE"      ) ;
   }
   return hCCDll ;
}

// void CC_InitDisplay ( HWND win )
INITDISPLAY_f CC_InitDisplay 
{
   if (pCCINITDISPLAY)
      pCCINITDISPLAY ( win ) ;
}

// void CC_KillWatchdog ( void )
KILLWATCHDOG_f CC_KillWatchdog 
{
   if (pCCKILLWATCHDOG)
      pCCKILLWATCHDOG (  ) ;
}

// void CC_SetFileName ( LPCSTR name )
SETCCFILENAME_f CC_SetFileName
{
   if ( pSETCCFILENAME )
      pSETCCFILENAME ( name ) ;
}

// void CC_SetAlert ( LPCSTR token )
SETCCALERT_f CC_SetAlert
{
   if ( pSETCCALERT )
      pSETCCALERT ( token ) ;
}

// void CC_GetFileName ( LPSTR name, int cnt )
GETCCFILENAME_f CC_GetFileName
{
   if ( pGETCCFILENAME )
      pGETCCFILENAME ( name, cnt ) ;
}

// void CC_GetAlert ( LPSTR name, int cnt )
GETCCALERT_f CC_GetAlert
{
   if ( pGETCCALERT )
      pGETCCALERT ( name, cnt ) ;
}

// void CC_Process ( LPBYTE data, int len )
PROCESS_f CC_Process
{
   if ( pCCPROCESS )
      pCCPROCESS ( data, len ) ;
}

// void CC_Display ( )
DISPLAY_f CC_Display
{
   if ( pCCDISPLAY )
      pCCDISPLAY ( ) ;
}

// void CC_CreateFonts ( )
CREATEFONTS_f CC_CreateFonts
{
   if ( pCC_CREATEFONTS )
      pCC_CREATEFONTS ( ) ;
}

// void CC_Erase ( )
ERASE_f CC_Erase
{
   if ( pCCERASE )
      pCCERASE ( ) ;
}

// void CC_SetChannel ( int ch )
SETCHANNEL_f CC_SetChannel
{
   if ( pCCSETCHANNEL )
      pCCSETCHANNEL ( ch ) ;
}

// int CC_GetChannel ( )
GETCHANNEL_f CC_GetChannel
{
   return ( pCCGETCHANNEL ) ? pCCGETCHANNEL ( ) : -1 ;
}

// void CC_EraseDisplay ( )
ERASEDISPLAY_f CC_EraseDisplay
{
   if ( pCCERASEDISPLAY )
      pCCERASEDISPLAY ( ) ;
}

//
// Decoder API
//


// int CC_InitDecode ( int samplesLen, 
//                     int horizResolution, 
//                     unsigned long decodeMode )
INITDECODE_f CC_InitDecode
{
   return ( pCCINITDECODE ) ? pCCINITDECODE ( samplesLen, 
                                              horizResolution, 
                                              decodeMode ) : -1 ;
}

// int CC_Decode ( const BYTE far* samples,
//                 int   lines,
//                 const BYTE far* decodedData,
//                 int   far * decodedDataLen )
DECODE_f CC_Decode
{
   return ( pCCDECODE ) ? pCCDECODE ( samples, 
                                      lines, 
                                      decodedData, 
                                      decodedDataLen ) : -1 ;
}

