// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/capdrv/rcs/dlkVid16.cpp 1.3 1998/04/22 11:55:59 trang Exp $
// $Log: dlkVid16.cpp $
// Revision 1.3  1998/04/22 11:55:59  trang
// Modified to compile under MSVC 1.52.
// Revision 1.2  1998/04/22 11:23:07  trang
// Make the Dialogs DLL to dynamic link with BtVid_16.dll.
// Revision 1.1  1998/04/22 10:53:48  trang
// Initial revision

// CUT_HERE

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1998 Brooktree Corporation
//
//  Module:
//
//    dlkVid16.cpp
//
//  Abstract:
//
//    Provides typesafe dynamic linkage to BtVid_16 exports
//
/////////////////////////////////////////////////////////////////////////////

#include "msvccomp.h"
#include "Bt848api.h"
#include "dlkVid16.h"

#define LIB_NAME "BtVid_16.Dll"

// typedefs for function pointers into the dll. Provides type safe access

// from Bt848api.h
typedef void      ( WINAPI *SetGPOE_f )               ( DWORD value )      ;
typedef ErrorCode ( WINAPI *SetGPDATABits_f )         ( int fromBit, int toBit, DWORD value, int offset );
typedef ErrorCode ( WINAPI *SetGPIE_f )               ( DWORD value )      ;
typedef ErrorCode ( WINAPI *GetGPDATABits_f )         ( int fromBit, int toBit, DWORD * value, int offset );
typedef BOOL      ( WINAPI *IsBt878Family_f )         ( void )             ;

SetGPOE_f	        pSetGPOE		    = NULL;
SetGPDATABits_f		pSetGPDATABits		= NULL;
SetGPIE_f	        pSetGPIE		    = NULL;
GetGPDATABits_f		pGetGPDATABits		= NULL;
IsBt878Family_f		pIsBt878Family		= NULL;


//
//  Initialization function
//
HINSTANCE InitDynLnkVid16(BOOL & bOk)
{
   bOk = FALSE ;

   HINSTANCE hVid16Dll = LoadLibrary( LIB_NAME );

   if ( hVid16Dll > (HINSTANCE) HINSTANCE_ERROR ) {

      pSetGPOE             = (SetGPOE_f)             GetProcAddress( hVid16Dll, "SetGPOE" );
      pSetGPDATABits       = (SetGPDATABits_f)       GetProcAddress( hVid16Dll, "SetGPDATABits" );
      pSetGPIE             = (SetGPIE_f)             GetProcAddress( hVid16Dll, "SetGPIE" );
      pGetGPDATABits       = (GetGPDATABits_f)       GetProcAddress( hVid16Dll, "GetGPDATABits" );
      pIsBt878Family       = (IsBt878Family_f)       GetProcAddress( hVid16Dll, "IsBt878Family" );

   }
   bOk = TRUE ;
   return hVid16Dll ;
}

// from Bt848api.h

void      DlkSetGPOE( DWORD value )
{
   if (pSetGPOE)  pSetGPOE(value) ;
}

ErrorCode DlkSetGPDATABits( int fromBit, int toBit,
                                     DWORD value, int offset )
{
   return (pSetGPDATABits) ? pSetGPDATABits(fromBit, toBit, value, offset): Fail ;
}

ErrorCode DlkSetGPIE( DWORD value )
{
   return (pSetGPIE) ? pSetGPIE(value): Fail ;
}

ErrorCode DlkGetGPDATABits( int fromBit, int toBit,
                                     DWORD * value, int offset )
{
   return (pGetGPDATABits) ? pGetGPDATABits(fromBit, toBit, value, offset): Fail ;
}

BOOL      DlkIsBt878Family( void )
{
   return (pIsBt878Family) ? pIsBt878Family(): FALSE ;
}

// eof
