/* $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/CC/rcs/api.cpp 1.5 1997/12/03 21:48:04 peter Released $ */
/****************************************************************************/
/***** Copyright (c) Brooktree Corporation, 1996. All Rights Reserved *******/
/****************************************************************************/
/*                                                                          */
/*                      BROOKTREE CONFIDENTIAL                              */
/*                                                                          */
/* Filename:    API.CPP                                                     */
/*                                                                          */
/* Description: API for CC.DLL. The api is designed to be utilized in an    */
/* explicitly loaded environment. The file 'cc_api.h' contains the typedefs */
/* used to define the api functions.                                        */
/*                                                                          */
/*                                                                          */
/* Author:      Dave Tharp                                                  */
/*                                                                          */
/****************************************************************************/
/* 
 * $Log: api.cpp $
 * Revision 1.5  1997/12/03 21:48:04  peter
 * Fixed regutil 16/32-bit incompatibility.
 * Revision 1.4  1997/06/02 21:50:44  dtharp
 * Bug id 628: flashing pink box every 5 sec in preview. CC display
 * watchdog timer is now shut down when CC is paused.
 * Revision 1.3  1996/10/04 15:00:21  dtharp
 * Changed API function names to have a CC_ prefix.
 * Revision 1.2  1996/10/03 22:32:46  dtharp
 * Changed name from cc_api.cpp to api.cpp
 * Revision 1.1  1996/10/03 22:29:48  dtharp
 * Initial revision
 * Revision 1.2  1996/10/03 16:36:00  dtharp
 * API functions are now defined with typedefs from cc_api.h.
 * Also added module header and brief function headers.
 */

#include <windows.h>
#include <stdio.h>
#include "ccdispl.h"
#include "ccdec.h"
#include "cc_api.h"

static HINSTANCE ghModule = NULL ;

static CCDisplay Display_;
static CCDecoder Dec_( 768 * 2 * 2, 768 * 2 * 2 );

HINSTANCE GetOurInstance ( void ) { return ghModule ; }

/* Function: LibMain
 * Purpose: DLL entry point
 */
extern "C" int FAR PASCAL LibMain ( HINSTANCE hInst, WORD, WORD, LPSTR )
{
   ghModule = hInst;
   return 1;
}

/////////////////////////////////////////////////////////
// API Follows
//

//
// Display API
//


#include "..\include\regutil.cpp"


// void CC_InitDisplay ( HWND win )
INITDISPLAY_f CC_InitDisplay 
{
  Display_.Init( win) ;
}

// void CC_KillWatchdog ( void )
KILLWATCHDOG_f CC_KillWatchdog 
{
  Display_.KillWatchdog( ) ;
}

// void CC_SetFileName ( LPCSTR name )
SETCCFILENAME_f CC_SetFileName
{
  Display_.SetCCFileName ( name ) ;
}

// void CC_SetAlert ( LPCSTR token )
SETCCALERT_f CC_SetAlert
{
  Display_.SetCCAlert ( token ) ;
}

// void CC_GetCCFileName ( LPSTR name, int cnt )
GETCCFILENAME_f CC_GetFileName
{
  Display_.GetCCFileName ( name, cnt ) ;
}

// void CC_GetAlert ( LPSTR name, int cnt )
GETCCALERT_f CC_GetAlert
{
  Display_.GetCCAlert ( name, cnt ) ;
}

// void CC_Process ( LPBYTE data, int len )
PROCESS_f CC_Process
{
  Display_.Process ( data, len ) ;
}

// void CC_Display ( )
DISPLAY_f CC_Display
{
  Display_.Display ( ) ;
}

// void CC_CreateFonts ( )
CREATEFONTS_f CC_CreateFonts
{
  Display_.CreateFonts ( ) ;
}

// void CC_Erase ( )
ERASE_f CC_Erase
{
  Display_.Erase ( ) ;
}

// void CC_SetChannel ( int ch )
SETCHANNEL_f CC_SetChannel
{
  Display_.SetChannel ( ch ) ;
}

// int CC_GetChannel ( )
GETCHANNEL_f CC_GetChannel
{
  return Display_.GetChannel ( ) ;
}

// void CC_EraseDisplay ( )
ERASEDISPLAY_f CC_EraseDisplay
{
  Display_.EraseDisplay ( ) ;
}

//
// Decoder API
//


// int CC_InitDecode ( int samplesLen, 
//                  int horizResolution, 
//                  unsigned long decodeMode )
INITDECODE_f CC_InitDecode
{
  return Dec_.Init ( samplesLen, horizResolution, decodeMode ) ;
}

// int CC_Decode ( const BYTE far* samples,
//              int   lines,
//              const BYTE far* decodedData,
//              int   far * decodedDataLen )
DECODE_f CC_Decode
{
  return Dec_.Decode ( samples, lines, decodedData, decodedDataLen ) ;
}

//EOF
