/* File: CCchannel.h
 * Purpose: Defines the CC channel class
 * Author: sasha
 * Copyright  1996 Brooktree Corporation
 * $Log: ccChan.h $
 * Revision 2.5  1998/04/02 21:37:31  dtharp
 * Merge DT_VIDEOHDR branch. Implements a new buffer 
 * management scheme.
 * Revision 2.4.2.1  1998/03/18 19:33:53  dtharp
 * Branch for passing videoheaders around
 * Revision 2.4  1997/07/31 10:48:00  dtharp
 * Cleaned up multiple CC_CALLBACK definitions.
 * Revision 2.3  1997/01/17 13:57:35  ssm
 * men ccchannel ccChan
 * Revision 2.2  1997/01/17 19:20:21  ssm
 * no changes, trying to fix rcs problem
 * Revision 2.1  1996/06/10 20:12:11  ssm
 * MarkBeta1AsRev2
 * Revision 1.2  1996/05/30 23:11:53  sasha
 * Just next version.
 * Revision 1.1  1996/05/29 17:26:23  sasha
 * Initial revision
 */


#ifndef __CCCHANNEL_H
#define __CCCHANNEL_H

#ifndef __VFWCHAN_H
#include "vfwchan.h"
#endif

#include "common.h"

class CCChannel;

/* Class:
 CCChannel
 Purpose: Defines the class for CC data transport
*/
class CCChannel : private VfWChannel
{
public:
   VideoStream ThisStream_;

   LPVIDEOHDR VideoHdr1_;
   LPVIDEOHDR VideoHdr2_;

   DWORD  Buf1Base_;
   DWORD  Buf2Base_;
   
   CC_CALLBACK  ParentCB_;

   static bool Started_;

   static  void WINAPI CapVxDCallback( CCChannel * );
   void CCChannel::AddBuffers();
   void CCChannel::RemoveBuffers();

public:
   CCChannel( VideoStream aStream ) : VfWChannel(), ThisStream_( aStream ),
      VideoHdr1_( NULL ), VideoHdr2_( NULL ), ParentCB_( 0 ) {}

   ErrorCode OpenChannel();
   void      CloseChannel();

   ErrorCode Start();
   void      Stop();

   void SetParentCallback( CC_CALLBACK cb ) { ParentCB_ = cb; }
   ~CCChannel();
};

#endif
