/* $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/CC/rcs/cc_api.cpp 1.2 1996/10/03 16:36:00 dtharp Released $ */
/****************************************************************************/
/***** Copyright (c) Brooktree Corporation, 1996. All Rights Reserved *******/
/****************************************************************************/
/*                                                                          */
/*                      BROOKTREE CONFIDENTIAL                              */
/*                                                                          */
/* Filename:    CC_API.CPP                                                  */
/*                                                                          */
/* Description: API for CC.DLL. The api is designed to be utilized in an    */
/* explicitly loaded environment. The file 'cc_api.h' contains the typedefs */
/* used to define the api functions.                                        */
/*                                                                          */
/*                                                                          */
/* Author:      Dave Tharp                                                  */
/*                                                                          */
/****************************************************************************/
/* 
 * $Log: cc_api.cpp $
 * Revision 1.2  1996/10/03 16:36:00  dtharp
 * API functions are now defined with typedefs from cc_api.h.
 * Also added module header and brief function headers.
 */

#include <windows.h>
#include <stdio.h>
#include "ccdispl.h"
#include "ccdec.h"

#define CC_API_CPP

#include "cc_api.h"

static HINSTANCE ghModule = NULL ;

static CCDisplay Display_;
static CCDecoder Dec_( 768 * 2 * 2, 768 * 2 * 2 );

HINSTANCE GetOurInstance ( void ) { return ghModule ; }

/* Function: LibMain
 * Purpose: DLL entry point
 */
extern "C" int FAR PASCAL LibMain ( HINSTANCE hInst, WORD, WORD, LPSTR )
{
   ghModule = hInst;
   return 1;
}

/////////////////////////////////////////////////////////
// API Follows
//
extern "C" {

//
// Display API
//

// void InitDisplay ( HWND win )
INITDISPLAY_f InitDisplay 
{
  Display_.Init( win) ;
}

// void SetCCFileName ( LPCSTR name )
SETCCFILENAME_f SetCCFileName
{
  Display_.SetCCFileName ( name ) ;
}

// void SetCCAlert ( LPCSTR token )
SETCCALERT_f SetCCAlert
{
  Display_.SetCCAlert ( token ) ;
}

// void GetCCFileName ( LPSTR name, int cnt )
GETCCFILENAME_f GetCCFileName
{
  Display_.GetCCFileName ( name, cnt ) ;
}

// void GetCCAlert ( LPSTR name, int cnt )
GETCCALERT_f GetCCAlert
{
  Display_.GetCCAlert ( name, cnt ) ;
}

// void Process ( LPBYTE data, int len )
PROCESS_f Process
{
  Display_.Process ( data, len ) ;
}

// void Display ( )
DISPLAY_f Display
{
  Display_.Display ( ) ;
}

// void CreateFonts ( )
CREATEFONTS_f CreateFonts
{
  Display_.CreateFonts ( ) ;
}

// void Erase ( )
ERASE_f Erase
{
  Display_.Erase ( ) ;
}

// void SetChannel ( int ch )
SETCHANNEL_f SetChannel
{
  Display_.SetChannel ( ch ) ;
}

// int GetChannel ( )
GETCHANNEL_f GetChannel
{
  return Display_.GetChannel ( ) ;
}

// void EraseDisplay ( )
ERASEDISPLAY_f EraseDisplay
{
  Display_.EraseDisplay ( ) ;
}

//
// Decoder API
//


// int InitDecode ( int samplesLen, 
//                  int horizResolution, 
//                  unsigned long decodeMode )
INITDECODE_f InitDecode
{
  return Dec_.Init ( samplesLen, horizResolution, decodeMode ) ;
}

// int Decode ( const BYTE far* samples,
//              int   lines,
//              const BYTE far* decodedData,
//              int   far * decodedDataLen )
DECODE_f Decode
{
  return Dec_.Decode ( samples, lines, decodedData, decodedDataLen ) ;
}


} // extern "C"

//EOF
