/* File: PsColSpc.h
 * Purpose: Defines PsColorSpace class
 * Author: sasha
 * $Log: pscolspc.h $
 * Revision 2.1  1996/06/10 20:12:18  ssm
 * MarkBeta1AsRev2
 * Revision 1.5  1996/04/09 23:43:04  sasha
 * Removed reference to the allregs.h
 * Revision 1.4  1996/03/18 20:34:26  sasha
 * Added 2 more registers to control byte and word swapping
 * Revision 1.3  1996/01/06 02:05:13  sasha
 * Changed ColorFormat to ColFmt
 * Revision 1.2  1995/10/10 03:03:20  sasha
 * First major check-in for testing
 * Revision 1.1  1995/10/09 19:03:20  sasha
 * Initial revision
 */

#ifndef __PSCOSPC_H
#define __PSCOLSPC_H

#ifndef __COMPREG_H
#include "compreg.h"
#endif

#ifndef __COLSPACE_H
#include "colspace.h"
#endif


/* Class: PsColorSpace
 * Purpose: This class interfaces to the Pisces HW. That is the only difference
 *    from its base class ColorSpace. Such division was created so ring3 capture
 *    driver can utilize ColorSpace's functionality
 * Attributes: Format_: Register & - reference to the color format register
 * Operations:
 *      void SetColorFormat( ColorFormat aColor );
 */
class PsColorSpace : public ColorSpace
{
   private:
      RegBase &Format_;
      RegBase &WordSwap_;
      RegBase &ByteSwap_;
   public:
      void SetColorFormat( ColFmt aColor );

      PsColorSpace( ColFmt aColForm, RegBase &aFormatReg, RegBase &WS,
         RegBase &BS ) :
         ColorSpace( aColForm ), Format_( aFormatReg ), WordSwap_( WS ),
            ByteSwap_( BS ) {}
};

#endif