/* File: Ddi.cpp
 * Purpose: Implementation of the DDI class
 * Author: sasha
 * $Log: DDI.CPP $
 * Revision 2.42  1998/01/09 17:27:55  peter
 * Graft Trident fixes to tip.
 * Revision 2.41.1.1  1997/12/10 01:35:50  peter
 * Merged TRIDENT code.
 * Revision 2.41  1997/12/09 17:49:22  peter
 * Removed excess debugging code.
 * Revision 2.40  1997/12/03 21:47:33  peter
 * Fixed regutil 16/32-bit incompatibility.
 * Revision 2.39  1997/11/26 00:41:33  peter
 * Graft reg key move to tip.
 * Revision 2.38.2.3  1997/11/24 21:58:05  peter
 * Revision 2.38.2.2  1997/11/24 20:35:52  peter
 * Revision 2.38.2.1  1997/11/20 22:45:12  peter
 * Changes to move registry subkey to HKEY_LOCAL_MACHINE.
 * Revision 2.38  1997/09/16 20:09:24  dtharp
 * Changes requrired for BtPciVid.drv name change to BtVid.drv.
 * Revision 2.37  1997/09/04 15:48:55  dtharp
 * Mods required to change Bt848ddi.dll to BtDDI.DLL.
 * Revision 2.36  1997/09/03 17:53:33  dtharp
 * Mods required for name change of Bt848.drv to BtPciVid.drv.
 * Revision 2.35  1997/07/17 23:27:22  trantq
 * Clean up thunk function for LoadImage for better compile results.
 * Revision 2.34.2.2  1997/06/26 23:59:12  trantq
 * Previous branch is messed up with old code.  Fix for bug 635.
 * Revision 2.34  1997/05/29 18:21:52  trantq
 * - Add additional checks for where surfaces JUST cannot be created
 * Revision 2.32  1997/05/29 17:37:04  trantq
 * Merge in fix for Bug 616 & 617.
 * Revision 2.31.1.2  1997/05/29 17:27:24  trantq
 * -Fix bug 616 and 617 dealing with creating overlay surface with 
 * certain maximum stretch threshold values.
 * Revision 2.31.1.1  1997/05/20 21:44:32  trantq
 * - Fix Bug ID 617 and 618.
 * Revision 2.31  1997/05/20 21:44:32  trantq
 * - Merged in fix for GetOverlayFlag function.  Bug ID 565
 * Revision 2.30.1.2  1997/05/20 21:44:32  trantq
 * - Fix GetOverlayFlag function.  Bug ID 565
 * Revision 2.30  1997/05/05 23:14:56  dtharp
 * 848A Merge: from 2.25.1.2
 * Revision 2.29  1997/04/30 22:42:55  dtharp
 * Merged in fix for Bug Id 439 from 2.26.1.2,( Maximum stretch threshold.)
 * Revision 2.28  1997/04/28 21:17:19  dtharp
 * Graft CC Primary Surface branch from 2.26.2.1 Bug ID 475
 * Revision 2.27.1.1  1997/04/25 23:54:04  dtharp
 * Added support for Bt848\Display registry key.
 * Revision 2.26  1997/03/18 19:44:05  rudyl
 * Graft from 2.25.2.2. Now PAL uses 288 lines per field.
 * Revision 2.25.2.2  1997/03/08 02:48:08  rudyl
 * Now PAL uses 288 lines per field.
 * Revision 2.25.2.1  1997/03/08 02:33:21  rudyl
 * Use 288 lines for PAL.
 * Revision 2.25  1997/02/04 22:25:30  dtharp
 * Grafted branch 2.24.2: S3 DX Scaling fix.
 * Revision 2.24.2.3  1997/02/04 22:24:45  dtharp
 * Increased SCALE_INCREMENT from 4 to 16. Should help performance.
 * Revision 2.24.2.2  1997/02/04 22:20:18  dtharp
 * Now reinits ddsd struuct on every attempt to create overlay surface.
 * Also removed old dead code.
 * Revision 2.24.2.1  1997/01/28 01:10:15  dtharp
 * Branch for S3 Virge DX Fix.
 * Revision 2.24.1.4  1997/02/20 01:54:12  rudyl
 * Changed DDI_SetVidFormat() to DDI_SetVidSize().
 * Revision 2.24.1.3  1997/02/14 23:46:56  rudyl
 * Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.
 * Revision 2.24.1.2  1997/02/03 23:43:56  rudyl
 * First Pisces+ check in.
 * Revision 2.24.1.1  1996/12/21 02:16:04  rudyl
 * Start Pisces+ work.
 * Revision 2.24  1996/12/07 00:04:12  rudyl
 * Merged with branch 2.22.1.2: Added NTSC-Japan, PAL-M & PAL-N formats.
 * Revision 2.23  1996/12/06 22:09:49  sasha
 * Simple copy of the 2.22.2.2 to propagate the changes for DD3.
 * Revision 2.22.2.2  1996/11/21 21:04:01  sasha
 * Changes for DD3.
 * Changed CreatePrimSurface() so it returns if prim. surface exists instead
 * of releasing and recreating the surface. Simplified DDI_GetData()
 * ( function does not try to recreate the prim. surface in order to repaint
 * the desktop ).
 * Revision 2.22.2.1  1996/11/21 19:33:53  sasha
 * Branch for the DD3 changes
 * Revision 2.22  1996/08/15 07:52:15  sasha
 * Increased the size of the clip buffer. Always set dwScale member of
 * Surface to zero in primary surface mode. Now check return value of the
 * GetClipList()
 * Revision 2.21  1996/08/07 23:03:47  sasha
 * Added  DDI_SetVidFormat() API. In CreateOverlay() check for the current video
 * format when calculating size of the surface
 * Revision 2.20  1996/07/29 21:53:13  sasha
 * Added code to round-down the width of an overlay surface to be 
 * DWORD-aligned
 * Revision 2.19  1996/07/24 04:20:32  sasha
 * Put  IsOverlaying_ = false; to take forced primary mode into account
 * NEEDS TESTING ! ( by CEI )
 * Revision 2.18  1996/07/17 03:04:11  sasha
 * changed registry key meaning of "Virge"
 * 0=not virge, 1=virge
 * Revision 2.17  1996/07/17 02:10:42  sasha
 * Added checking for "Virge" key in registry. If 1, no bankswitched checking is performed.
 * Revision 2.16  1996/07/16 20:51:53  rudyl
 * Added registry keys "Force Primary" and "Bankswitch".
 * Revision 2.15  1996/07/15 20:44:52  sasha
 * Changed CheckPossibleOverlays() such that only full screen resolution
 * is checked - we can do all other sizes ourselves
 * Revision 2.14  1996/07/14 01:51:57  sasha
 * Added function to check possible overlay sizes. Changed CreateOverlay()'s
 * parameters and code to support the above function.
 * Revision 2.13  1996/07/13 22:41:07  sasha
 * Changed how source rectangle is changed when video window is moved
 * beyond edges of the screen. Changed how values are assigned to the
 * Clip member to control when overlay channel is restarted.
 * Revision 2.12  1996/07/13 02:04:20  sasha
 * Do not downscale vertically. Fixed beyond the screen problem with S3
 * Revision 2.11  1996/07/10 20:03:28  sasha
 * Added code for updating registry keys for the Intercast.
 * Revision 2.10  1996/07/10 01:31:04  sasha
 * Hardcoded 1000 as minimum scale thing to have a base release
 * Revision 2.9  1996/07/08 22:36:00  sasha
 * Use minimum scale overlay information when creating overlay surfaces
 * This is mainly for S3 bandwidth problem.
 * Revision 2.8  1996/06/21 00:31:33  sasha
 * Release overlay surface in CreateOverlay() if existed before.
 * Revision 2.7  1996/06/20 00:46:26  sasha
 * Added support for the RGB 565 primary surface
 * Revision 2.6  1996/06/15 01:21:55  sasha
 * Added code to the DoColorKey() to handle lost surfaces.
 * Revision 2.5  1996/06/15 00:15:48  sasha
 * Increased size of the clip memory
 * Revision 2.4  1996/06/14 18:02:29  sasha
 * Reorganized QueryClip(). Moved OldWidth and OldHeight into the
 * DDI class from DoColorKey(). Modified DDI_GetData(). Added
 * DDI_DoPalette(). All these for reducing flashing and 8bpp mode support
 * Revision 2.3  1996/06/12 01:20:15  sasha
 * Do not create palette if already exists
 * Revision 2.2  1996/06/12 00:41:42  sasha
 * Improved palette support and handling of the cases when overlay gets
 * disabled and we are falling back on primary surface
 * Revision 2.1  1996/06/10 20:13:23  ssm
 * MarkBeta1AsRev2
 * Revision 1.25  1996/04/30 16:31:57  sasha
 * Changed names in the thunking call
 * Revision 1.24  1996/04/04 00:05:10  sasha
 * Now check for the maximum size of overlay to be created. Limit it to 640x480
 * for now. Changed DoColorOverlay() to support image stretching.
 * +++++ NEEDS EXTENSIVE TESTING+++++++
 * Revision 1.23  1996/03/30 02:52:20  sasha
 * Removed painting code from DoColorKey(). This is done by the VfW driver
 * Revision 1.22  1996/03/27 23:50:44  sasha
 * Added COLORREF argument to the DDI::CreatePrimSurface().
 * In the DDI::DoColorKey() moved painting code into the if ( changed ) {}
 * Revision 1.21  1996/03/22 23:09:26  sasha
 * Added Y41P FOURCC (BtV). Added some code to detect the resolution
 * change, but it does not seem to do what I need. Probably a gonner.
 * Revision 1.20  1996/03/20 00:16:58  sasha
 * Added code to the DoColorKey() and DDI_GetData(). First avoids image
 * flicker by supplying surface rectangles and by removing call to 
 * SetOverlayPosition(). Second prevents start/stop action when in overlay 
 * mode and window is moved
 * Revision 1.19  1996/03/19 19:41:08  sasha
 * Modified the client rect in the call to UpdateOverlay() in DoColorKey() to
 * use the screen coordinates.
 * Revision 1.18  1996/03/19 00:14:44  sasha
 * Moved CreateClipper() out of switch() to prevent faults later on when some
 * changes cause overlay re-creation failure. #ifdef'ed enumeration code.
 * Added a loop through different FOURCC codes when creating overlay
 * Revision 1.17  1996/03/14 19:18:26  sasha
 * Added checks to DDI_CreateSurface()
 * Revision 1.16  1996/03/14 02:19:52  sasha
 * Use black as the key color. Moved IsOverlaying_ = true; into CreateOverlay()
 * Added some extra error checking to the DDI_GetData() for cases when
 * CreateOverlay() fails in DoKeyColor()
 * Revision 1.15  1996/03/11 20:16:34  sasha
 * Added _declspec to the thunking function for MS compilation
 * Revision 1.14  1996/03/07 20:14:18  sasha
 * Moved IsOverlaying_ = false into CreateOverlay(). Added checking to the
 * DDI_GetData().
 * Revision 1.13  1996/03/06 21:54:13  rudyl
 * Added WINAPI to DDI_SetColorKey() and DDI_GetFlags.
 * Revision 1.12  1996/03/06 21:36:52  sasha
 * Changed many things. Fixed case when overlay surface creation failed
 * fall-back to primary was used.
 * Revision 1.11  1996/03/05 20:27:50  sasha
 * Added support for hiding overlay surface when overlay channel is stopped
 * Revision 1.10  1996/02/27 01:52:22  sasha
 * Added two more functions to get current mode and key color. Added
 * code to enumerate surfaces. Added checking for error codes. Changed
 * CreatePrimarySurface() to fall back if overlay creation fails
 * Revision 1.9  1996/02/24 03:55:42  sasha
 * Added support for changing window size in overlay mode
 * Revision 1.8  1996/02/24 02:47:30  sasha
 * Added support for the overlay surfaces
 * Revision 1.7  1996/02/14 20:54:41  rudyl
 * Converted to Miscrosoft Visual C++ 4.0. Added #ifdef for different compiler.
 * Revision 1.6  1996/02/14 20:19:13  sasha
 * Added palette support. Added argument to DDI_CreateSurface
 * Revision 1.5  1996/01/27 22:40:09  sasha
 * Zero out Clip_ member of the SURF_DATA structure when DDI_GetData
 *  is called
 * Revision 1.4  1996/01/08 22:27:51  sasha
 * Changed DDI::Init so it would not return if called when DDI object was
 * already created
 */
#include "ddi.h"
#include "dbgprint.h"
#include <mmsystem.h>

#define DIM( a ) ( sizeof( a ) / sizeof( a [0] ) )
#define MAX(a,b) ((a) > (b)) ? (a) : (b) 

// Max and Min value for stretch threshold
#define DEFAULT_MIN_THRESHOLD		1000
#define DEFAULT_MAX_THRESHOLD		3500

#define SCALE_INCREMENT 			16


DDI Lame;
const ClipSize = 4000;
DWORD NewClip [ClipSize];
DWORD OldClip [ClipSize];
const COLORREF ColorKey = RGB( 0x80, 0, 0x80 );

const char *IcastKey = "Intercast.Display";
const char *SurfName = "Surface";
const char *BitMask  = "DisplayBitMask";

const char *ForcePrimaryKey = "ForcePrimary";
const char *VirgeKey        = "Virge";
const char *MaximumStretchKey = "MaximumStretchThreshold";


#include "..\include\regutil.cpp"


/* Function: UpdateRegistry
 * Purpose: Updates various registry keys
 */
void UpdateRegistry( LPCSTR SubKey, LPCSTR ValName, LPCSTR value )
{
   HKEY hKey;
   char	szKeyName[ MAX_PATH +  1 ];
   sprintf( szKeyName, "%s\\%s", BT_VIDEO_REG_SUBKEY, SubKey );
   RegCreateKey( HKEY_LOCAL_MACHINE, szKeyName, &hKey );
   RegSetValueEx( hKey, ValName, 0, REG_SZ, ( CONST BYTE *)value, strlen( value ) );
   RegCloseKey( hKey );
}

void UpdateSurfKey(LPCSTR value)
{
	 UpdateRegistry( IcastKey, SurfName, value );   // update "Surface" value

   // update [BT_VIDEO_REG_SUBKEY]\Surface so 16 dll (cc) can see the value
   HKEY hKey;
   RegCreateKey( HKEY_LOCAL_MACHINE, BT_VIDEO_REG_SUBKEY, &hKey );
   RegSetValue( hKey, "Surface", REG_SZ, ( CONST BYTE *)value, strlen( value ) );
   RegCloseKey( hKey );
}

ErrorCode DDI::CheckCaps()
{
   PS_DDCAPS DrvCaps, HELCaps;

   DWORD st = pDirectDrawObj_->GetCaps( &DrvCaps, &HELCaps );
   if ( st != DD_OK ) {
      DebugPrint((0,"CheckCaps Failure: GetCaps() = 0x%x  (%d)\n",st,st)) ;
      return Fail;
   }

   // no luck in this town
   if ( DrvCaps.dwCaps & DDCAPS_NOHARDWARE )
   {
      DebugPrint((0,"CheckCaps Failure: DDCAPS_NOHARDWARE\n")) ;
      return Fail;
   }

   if ( DrvCaps.dwCaps & DDCAPS_OVERLAY ) {
      CanOverlay_ = true;
      OverlayCanStretch_ = bool( DrvCaps.dwCaps & DDCAPS_OVERLAYSTRETCH );
      return Success;
   }

   // get Virge flag from registry
   RegUtil virgeKey( BT_VIDEO_REG_SUBKEY );	// default is HKEY_CLASSES_ROOT
   DWORD virge;

   // if no entry in registry, default is not Virge chip, i.e. check for bankswitched
   if ( virgeKey.GetValue( &virge, VirgeKey ) == Fail )
      virge = 0;

	// check bankswitch only if bankswitch is 1 in registry
   if ( virge == 0 )
   {
	   if ( DrvCaps.dwCaps & DDCAPS_BANKSWITCHED	)
	   {
	      DebugPrint((0,"CheckCaps Failure: DDCAPS_BANKSWITCHED\n")) ;
	   	 return Fail;
	   }
   }
	

   PS_DDSURFACEDESC ddsd;
   // figure out what display mode we are in now
   if ( pDirectDrawObj_->GetDisplayMode( &ddsd ) != DD_OK )
   {
      DebugPrint((0,"CheckCaps Failure: GetDisplayMode()\n")) ;
      return Fail;
   }

   // make sure we're in  a 8-bit mode
   if ( ddsd.ddpfPixelFormat.dwRGBBitCount < 8 )
   {
      DebugPrint((0,"CheckCaps Failure: ddsd.ddpfPixelFormat.dwRGBBitCount < 8 \n")) ;
      return Fail;
   }
   return Success;
}

/* Method: DDI::Init
 * Purpose: Attaches to the DDI and gets all the relevant info from it
 * Input: None
 * Output: ErrorCode
 */
ErrorCode DDI::Init()
{
   // init our direct draw stuff
   if ( !pDirectDrawObj_ && DirectDrawCreate( NULL, &pDirectDrawObj_, NULL ) != DD_OK )
   {
      DebugPrint((0,"DDI Init failure: (%x) && directDrawCreate()\n")) ;
      return Fail;
   }

   if ( CheckCaps() != Success )
   {
      DebugPrint((0,"DDI Init failure: CheckCaps()\n")) ;
      return Fail;
   }
#if ENUM_WORKS
   // enumerate all surfaces and look for overlay ones
   PS_DDSURFACEDESC ddsd;

   ddsd.dwFlags = DDSD_CAPS;// | DDSD_CKDESTOVERLAY;
   ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;//DDSCAPS_OVERLAY | DDSCAPS_LIVEVIDEO | DDSCAPS_VIDEOMEMORY;
   pDirectDrawObj_->EnumSurfaces( DDENUMSURFACES_CANBECREATED,
//   DDENUMSURFACES_MATCH | DDENUMSURFACES_ALL | DDENUMSURFACES_CANBECREATED,
       &ddsd, this, SurfEnumCallback );
#endif
   return Success;
}
#if ENUM_WORKS
HRESULT FAR PASCAL DDI::SurfEnumCallback( LPDIRECTDRAWSURFACE,
   LPDDSURFACEDESC lpDDSurfDesc, LPVOID lpContext )
{
   if ( lpDDSurfDesc->dwFlags & DDSD_CKDESTOVERLAY )
      OutputDebugString( "enum+CKDESTOVLY\n" );

   if ( lpDDSurfDesc->ddsCaps.dwCaps & DDSCAPS_OVERLAY )
      OutputDebugString( "enum+overlay\n" );

   if ( lpDDSurfDesc->ddsCaps.dwCaps & DDSCAPS_LIVEVIDEO )
      OutputDebugString( "enum+livevideo\n" );
   return DDENUMRET_OK;
}
#endif

/* Method: DDI::CreatePrimSurface
 * Purpose: Creates a primary surface
 */
ErrorCode DDI::CreatePrimSurface( COLORREF KeyColor )
{

   if ( pOnScreenBuf_ )
      return Success;

   PS_DDSURFACEDESC ddsd;

   ddsd.dwFlags = DDSD_CAPS;
   ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

   // Tell the world we love it and want to share
   if ( pDirectDrawObj_->SetCooperativeLevel( hWin_, DDSCL_NORMAL ) != DD_OK )
      return Fail;
   // create our primary surface.
   if ( pDirectDrawObj_->CreateSurface( &ddsd, &pOnScreenBuf_, NULL ) != DD_OK )
      return Fail;
   if ( !pClipper_ && pDirectDrawObj_->CreateClipper( 0, &pClipper_, NULL ) != DD_OK )
      return Fail;

   pOnScreenBuf_->GetSurfaceDesc( &ddsd );

   if ( ! ( ddsd.ddsCaps.dwCaps & DDSCAPS_VIDEOMEMORY ) )
      return Fail;

   if ( pOnScreenBuf_->SetClipper( pClipper_ ) != DD_OK )
      return Fail;
   pClipper_->SetHWnd( 0, hWin_ );

   OnScreenWidth_ = ddsd.dwWidth;
   OnScreenHeight_ = ddsd.dwHeight;

   LPDIRECTDRAWSURFACE pSurf;

   // if Force Primary = 1 then don't even try to create overlay surface
   // get force primary flag from registry
   RegUtil forcePrimaryKey( BT_VIDEO_REG_SUBKEY );	
   DWORD forcePrimary;

   // if no entry in registry, default is NOT force primary (i.e. = 0)
   if ( forcePrimaryKey.GetValue( &forcePrimary, ForcePrimaryKey ) == Fail )
      forcePrimary = 0;

   switch ( CanOverlay_ ) {
   case true:
   	// if force primary flag is false, then try to create overlay
      if ( !forcePrimary ) {
         if ( pDirectDrawObj_->SetCooperativeLevel( hWin_, DDSCL_NORMAL | DDSCL_FULLSCREEN ) != DD_OK )
            return Fail;

         DDCOLORKEY ddck;
         ddck.dwColorSpaceLowValue =
         ddck.dwColorSpaceHighValue = ColorKey_ = KeyColor;
         pOnScreenBuf_->SetColorKey( DDCKEY_DESTOVERLAY, &ddck );

         CheckPossibleOverlays();

         if ( CreateOverlay() == Success ) {
            SURF_DATA tmp;
            DoColorKey( &tmp );
         	if ( IsOverlaying_ ) {
               pSurf = pOverlaySurf_;
               break;
            }
         }
      }
      // tell Intercast full-screen size is not available
      UpdateRegistry( IcastKey, BitMask, "7" );

      // make sure this flag is set correctly in case primary is forced
      IsOverlaying_ = false;

      // intentional fall-through
   default:
		// update registry to say NOT using overlay, thus using primary surface
		UpdateSurfKey( "1" );

      if ( pDirectDrawObj_->SetCooperativeLevel( hWin_, DDSCL_NORMAL ) != DD_OK )
         return Fail;
      pSurf = pOnScreenBuf_;
      if ( pOnScreenBuf_->SetClipper( pClipper_ ) != DD_OK )
         return Fail;
      pClipper_->SetHWnd( 0, hWin_ );
   }
   return GetSurfacePtr( pSurf, ddsd );
}

/* Method: DDI::GetSurfacePtr
 * Purpose: Obtains pointer to the surface memory
*/
ErrorCode DDI::GetSurfacePtr( LPDIRECTDRAWSURFACE pSurf, DDSURFACEDESC &ddsd )
{
   pSurf->GetSurfaceDesc( &ddsd );
   if ( ! ( ddsd.ddsCaps.dwCaps & DDSCAPS_VIDEOMEMORY ) )
      return Fail;
   if ( pSurf->Lock( NULL, &ddsd, DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR, NULL ) != DD_OK )
      return Fail;

   if ( ddsd.lPitch && ddsd.dwWidth && ddsd.dwHeight && ddsd.lpSurface ) {

      if ( ddsd.ddpfPixelFormat.dwFlags & DDPF_FOURCC ) {
         FourCC_ = ddsd.ddpfPixelFormat.dwFourCC;
         dwBpp_ = ddsd.ddpfPixelFormat.dwYUVBitCount / 8;
      } else {
         // check for the 565 surface
         if ( ( ddsd.ddpfPixelFormat.dwGBitMask & 0x7E0 ) == 0x7E0 )
            FourCC_ = BI_BITFIELDS;
         else
            FourCC_ = BI_RGB;
         dwBpp_ = ddsd.ddpfPixelFormat.dwRGBBitCount / 8;
      }
      dwPitch_ = ddsd.lPitch;
      // store the address
      dwSurfAddr_ = (DWORD)ddsd.lpSurface;
   }
   pSurf->Unlock( ddsd.lpSurface );
   return Success;
}

#ifdef DEBUG
#pragma message *
#pragma message * Debug Build
#pragma message *
void printCreateSurfStat(HRESULT stat)
{
  switch (stat)
  {
    case DDERR_INCOMPATIBLEPRIMARY:
      OutputDebugString("---->CreateSurf failed: DDERR_INCOMPATIBLEPRIMAR\n") ;
      break ;
    case DDERR_INVALIDCAPS :
      OutputDebugString("---->CreateSurf failed: DDERR_INVALIDCAPS\n") ;
      break ;
    case DDERR_INVALIDOBJECT :
      OutputDebugString("---->CreateSurf failed: DDERR_INVALIDOBJECT\n") ;
      break ;
    case DDERR_INVALIDPARAMS :
      OutputDebugString("---->CreateSurf failed: DDERR_INVALIDPARAMS\n") ;
      break ;
    case DDERR_INVALIDPIXELFORMAT :
      OutputDebugString("---->CreateSurf failed: DDERR_INVALIDPIXELFORMAT\n") ;
      break ;
    case DDERR_NOALPHAHW :
      OutputDebugString("---->CreateSurf failed: DDERR_NOALPHAHW\n") ;
      break ;
    case DDERR_NOCOOPERATIVELEVELSET :
      OutputDebugString("---->CreateSurf failed: DDERR_NOCOOPERATIVELEVELSET\n") ;
      break ;
    case DDERR_NODIRECTDRAWHW :
      OutputDebugString("---->CreateSurf failed: DDERR_NODIRECTDRAWHW\n") ;
      break ;
    case DDERR_NOEMULATION :
      OutputDebugString("---->CreateSurf failed: DDERR_NOEMULATION\n") ;
      break ;
    case DDERR_NOEXCLUSIVEMODE :
      OutputDebugString("---->CreateSurf failed: DDERR_NOEXCLUSIVEMODE... error?\n") ;
      break ;
    case DDERR_NOFLIPHW :
      OutputDebugString("---->CreateSurf failed: DDERR_NOFLIPHW\n") ;
      break ;
    //case DDERR_NOMIPMAPHW :
    //  OutputDebugString("---->CreateSurf failed: DDERR_NOMIPMAPHW\n") ;
    //  break ;
    case DDERR_NOZBUFFERHW :
      OutputDebugString("---->CreateSurf failed: DDERR_NOZBUFFERHW\n") ;
      break ;
    case DDERR_OUTOFMEMORY :
      OutputDebugString("---->CreateSurf failed: DDERR_OUTOFMEMORY\n") ;
      break ;
    case DDERR_OUTOFVIDEOMEMORY :
      OutputDebugString("---->CreateSurf failed: DDERR_OUTOFVIDEOMEMORY\n") ;
      break ;
    case DDERR_PRIMARYSURFACEALREADYEXISTS :
      OutputDebugString("---->CreateSurf failed: DDERR_PRIMARYSURFACEALREADYEXISTS\n") ;
      break ;
    case DDERR_UNSUPPORTEDMODE       :
      OutputDebugString("---->CreateSurf failed: DDERR_UNSUPPORTEDMODE      \n") ;
      break ;

	default:
	{
	  char buf[128];
	  sprintf(buf,"----->stat = HEX(%x) DEC(%li)  \n",stat, stat);
	  OutputDebugString(buf);
	  OutputDebugString("---->Create Overlay Surface failed!  Unknown error   \n");
	}
	break;
  }
}
#endif

void DDI::InitSurfaceDesc(PS_DDSURFACEDESC &ddsd, TRect &Client, DWORD dwScaleFactor)
{
  
   ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT |
                  DDSD_CKDESTOVERLAY;
   ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY | DDSCAPS_LIVEVIDEO | DDSCAPS_VIDEOMEMORY;
   ddsd.ddckCKDestOverlay.dwColorSpaceLowValue = ColorKey;
   ddsd.ddckCKDestOverlay.dwColorSpaceHighValue = ColorKey;

   // have to make sure our overlay surface is not bigger then mix size supported
   // by Pisces
   ddsd.dwHeight = min( (DWORD)Client.Height(), CurVidHeight_ );
   ddsd.dwWidth  = min( (DWORD)Client.Width(),  CurVidWidth_ );

   ddsd.dwWidth *= 1000;
   ddsd.dwWidth /= dwScaleFactor;

   // now make sure the width is DWORD-aligned
   ddsd.dwWidth &= ~3;

   ClearMem( ddsd.ddpfPixelFormat );

   // set fourcc YUY2
   ddsd.ddpfPixelFormat.dwSize = sizeof( DDPIXELFORMAT );
   ddsd.ddpfPixelFormat.dwFlags = DDPF_FOURCC | DDPF_YUV;
   ddsd.ddpfPixelFormat.dwYUVBitCount = DDBD_16;

   ddsd.ddpfPixelFormat.dwYBitMask = 0x7C00;
   ddsd.ddpfPixelFormat.dwUBitMask = 0x03E0;
   ddsd.ddpfPixelFormat.dwVBitMask = 0x001F;
   ddsd.ddpfPixelFormat.dwYUVAlphaBitMask = 0x8000;
}


/* Method: DDI::CreateOverlay
 * Purpose: Attempts to create an overlay surface
 */
ErrorCode DDI::CreateOverlay( bool test, int width, int height )
{
   PS_DDSURFACEDESC ddsd;
   PS_DDCAPS DrvCaps, HELCaps;

   // assume that creation of overlay fails
   UpdateSurfKey( "1" );

   // make sure we do not loose surfaces
   if ( pOverlaySurf_ ) {
      pOverlaySurf_->Release();
      pOverlaySurf_ = NULL;
   }

   if ( pDirectDrawObj_->GetCaps( &DrvCaps, &HELCaps ) != DD_OK )
      return Fail;

   RegUtil MaximumStretchThreshold( BT_VIDEO_REG_SUBKEY );
   DWORD dwMaximumStretchValue;

   // Check if the key exists in the Registry, if not, set to the default value. TT
   if ( MaximumStretchThreshold.GetValue( &dwMaximumStretchValue, MaximumStretchKey ) == Fail )
   {
		// It's not set, so we set it to a default value to use
		// adaptive scaling
		dwMaximumStretchValue=DEFAULT_MIN_THRESHOLD; 
   		// Update the registry of the Maximum Stretch threshold value.  TT
   		MaximumStretchThreshold.SetValue(dwMaximumStretchValue,MaximumStretchKey);
   }

   // Assume that the value for maximum threshold will be set higher than
   // our default value DEFAULT_MAX_THRESHOLD (i.e., 3500).
   bool bUseAdaptiveScaling = false;

   // If the value set if less then the default maximum, 
   // use adaptive scaling to insure that an overlay surface is 
   // successfully created.  TT
   if (dwMaximumStretchValue < DEFAULT_MAX_THRESHOLD)
		bUseAdaptiveScaling = true;

   if ( DrvCaps.dwMinOverlayStretch )
   		dwMinScale_ = MAX(DrvCaps.dwMinOverlayStretch,1000UL) ; // Trident 975 reports 900: very bad
   else
       	dwMinScale_ = DEFAULT_MIN_THRESHOLD;
   

   TRect Client;
   if ( !test ) 
      GetClientRect( hWin_, &Client );
   else {
      Client.left = Client.top = 0;
      Client.right = width;
      Client.bottom = height;
   }


   InitSurfaceDesc(ddsd,Client,dwMinScale_) ;

   IsOverlaying_ = false;

   DWORD FourCCs [] = {
      mmioFOURCC( 'Y', '4', '1', 'P' ),
      mmioFOURCC( 'U', 'Y', 'V', 'Y' ),
      mmioFOURCC( 'Y', 'U', 'Y', '2' )
   };

   HRESULT stat ;
   int i;
   bool bCreateSuccessful = false ;


   do {
	  // Loop through all pixel formats until a surface is created.
      for ( i = 0; i < DIM( FourCCs ); i++ ) 
      {
      	 ddsd.ddpfPixelFormat.dwFourCC = FourCCs [i]; //mmioFOURCC( 'Y', 'U', 'Y', '2' );
		
		 // If successful, exit loop
         if ( ( stat = pDirectDrawObj_->CreateSurface( &ddsd, &pOverlaySurf_, NULL )) == DD_OK )
	    {
         	bCreateSuccessful = true;
         	break;
	    }
#ifdef DEBUG
      	 printCreateSurfStat(stat) ;
#endif
      	 	//printCreateSurfStat(stat) ;
      }
     

	  // If it fails to create the surface for the 3 pixel format, increment the 
	  // scaling size and try again.
      if (stat != DD_OK)
      {
      	 char dBuf[180] ;
      	 dwMinScale_ += SCALE_INCREMENT ;
         InitSurfaceDesc(ddsd,Client,dwMinScale_) ;
      	 //sprintf(dBuf,"Scaling to %d\n",dwMinScale_) ;
      	 //OutputDebugString(dBuf) ;
      }
   	  
	  // If Adaptive Scaling is used, don't break out until
	  // a successful surface is created
	  // We don't have to worry about overrun in this loop
	  // because the only reason adaptive scaling is used
	  // is when the max. threshold is lesser than 3500
   	  if ( !bUseAdaptiveScaling && (dwMinScale_ >= dwMaximumStretchValue) && (stat != DD_OK ) )
		 break;				  

   } while (stat != DD_OK && (dwMinScale_ < DEFAULT_MAX_THRESHOLD)) ; 


   //if ( i >= DIM( FourCCs ) )
   if ( !bCreateSuccessful ) 
   {
      DebugPrint((0,">>>>> CreateOverlay returns FAIL (no create) \n")) ;
      return Fail;
   }

   DWORD st = pOverlaySurf_->UpdateOverlay( NULL, pOnScreenBuf_, &Client,
                                            DDOVER_KEYDEST | DDOVER_SHOW, NULL ) ;
   if (st != DD_OK)   
   {
      DebugPrint((0,"UpdateOverlay status:\n")) ;
      switch (st) {
        case DDERR_GENERIC :            DebugPrint((0,"   DDERR_GENERIC\n")) ;   break;
        case DDERR_HEIGHTALIGN :        DebugPrint((0,"   DDERR_HEIGHTALIGN\n")) ;   break;
        case DDERR_INVALIDOBJECT :      DebugPrint((0,"   DDERR_INVALIDOBJECT\n")) ;   break;
        case DDERR_INVALIDPARAMS :      DebugPrint((0,"   DDERR_INVALIDPARAMS\n")) ;   break;
        case DDERR_INVALIDRECT :        DebugPrint((0,"   DDERR_INVALIDRECT\n")) ;   break;
//        case DDERR_INVALIDSURFACETYPE : DebugPrint((0,"   DDERR_INVALIDSURFACETYPE\n")) ;   break;
        case DDERR_NOSTRETCHHW :        DebugPrint((0,"   DDERR_NOSTRETCHHW\n")) ;   break;
        case DDERR_NOTAOVERLAYSURFACE : DebugPrint((0,"   DDERR_NOTAOVERLAYSURFACE\n")) ;   break;
        case DDERR_SURFACELOST :        DebugPrint((0,"   DDERR_SURFACELOST\n")) ;   break;
        case DDERR_UNSUPPORTED :        DebugPrint((0,"   DDERR_UNSUPPORTED\n")) ;   break;
        case DDERR_XALIGN :             DebugPrint((0,"   DDERR_XALIGN\n")) ;   break;
        default :                       DebugPrint((0,"  ?? \n")) ; break;
      } ;

      DebugPrint((0,">>>>> CreateOverlay returns FAIL (no UpdateOverlay) \n")) ;
      return Fail;
   }



   // All conditions are fine, 
   IsOverlaying_ = true;

   // Update Registry of the current value of stretch threshold
   if (	bUseAdaptiveScaling )
   {
   	   if ( dwMinScale_ > dwMaximumStretchValue )
	   {
   		  MaximumStretchThreshold.SetValue(dwMinScale_,MaximumStretchKey);
	   }
   }

   // here overlay is alive and well, indicate it in registry
   UpdateSurfKey( "0" );

   DebugPrint((0,">>>>> CreateOverlay returns Success\n")) ;
   return Success;
}

void DDI::CreatePalette( LPPALETTEENTRY lpPal )
{
   if ( pPal_ )
      return;
   pDirectDrawObj_->CreatePalette( DDPCAPS_8BIT | DDPCAPS_INITIALIZE | DDPCAPS_ALLOW256 , lpPal, &pPal_, NULL );
   pOnScreenBuf_->SetPalette( pPal_ );
}

/* Method: DDI::QueryClip
 * Purpose: Obtains the cliplist information
 * Input: None
 * Output: bool: true if new clip list exists, false otherwise
 */
bool DDI::QueryClip()
{
   if ( !pClipper_ || IsOverlaying_ )
      return false;

   DWORD dwClipSize = sizeof( NewClip );
   if ( pClipper_->GetClipList( NULL, (LPRGNDATA)NewClip, &dwClipSize ) != DD_OK )
      return false;

   if ( ! ((LPRGNDATA)NewClip)->rdh.nCount )
      return false;

   int rNo;
   TRect rClientR;
   GetClientRect( hWin_, &rClientR );
   TPoint LeftTop = rClientR.TopLeft();
   ClientToScreen( hWin_, &LeftTop );
   for ( rNo = 0; rNo < ((LPRGNDATA)NewClip)->rdh.nCount; rNo++ ) {
      TRect *r = (TRect *)((LPRGNDATA)NewClip)->Buffer + rNo;
      *r = r->OffsetBy( -LeftTop.x, -LeftTop.y );
   }
   if ( !memcmp( OldClip, NewClip, sizeof( NewClip ) ) )
      return false;

   memcpy( OldClip, NewClip, dwClipSize );
   return true;
}

/* Method: DDI::DoColorKey
 * Purpose:
 * Input: None
 * Output: None
 */
void DDI::DoColorKey( SURF_DATA *const Data )
{

   if ( !pOverlaySurf_ )
      return;

   PS_DDSURFACEDESC ddsd;
   pOverlaySurf_->GetSurfaceDesc( &ddsd );

   PS_DDSURFACEDESC OnScreenDdsd;
   pOnScreenBuf_->GetSurfaceDesc( &OnScreenDdsd );

   TRect Client;
   GetClientRect( hWin_, &Client );


   if ( ddsd.dwHeight != Client.Height() || ddsd.dwWidth != Client.Width() ) {

      int w, h;
      if ( ( w = Client.Width() )  != OldWidth_ ||
           ( h = Client.Height() ) != OldHeight_ ) {

         // client window has changed its size. Recreate overlay surface
         OldWidth_  = w;
         OldHeight_ = h;

         pOverlaySurf_->Release();
         pOverlaySurf_ = NULL;

         if ( CreateOverlay() != Success ) {
            OldWidth_  = 0;
            OldHeight_ = 0;
            return;
         }

         GetSurfacePtr( pOverlaySurf_, ddsd );
         if ( Data )
            Data->Clip = 2; // indicate to DoDDI() things have changed
      }
   }
   // Data is NULL when called from StopOverlay
   if ( Data ) {
      if ( Data->Clip ) {
         TPoint LeftTop = Client.TopLeft();
         ClientToScreen( hWin_, &LeftTop );

         // figure out where the destination is
         TPoint BotRight = Client.BottomRight();
         ClientToScreen( hWin_, &BotRight );

         // this will not be larger then 640x480 - see CreateOverlay()
         TRect SrcRect( 0, 0, ddsd.dwWidth, ddsd.dwHeight );

         if ( LeftTop.x < 0 ) {
            SrcRect.left = -LeftTop.x * 1000 / dwMinScale_;
            LeftTop.x = 0;
         }
         if ( LeftTop.y < 0 ) {
            SrcRect.top = -LeftTop.y;
            LeftTop.y = 0;
         }
         // adjust both src and dst if going beyond the right edge
         if ( BotRight.x > OnScreenWidth_ ) {
            SrcRect.right *= Client.Width() - ( BotRight.x - OnScreenWidth_ );
            SrcRect.right /= Client.Width();
            BotRight.x = OnScreenWidth_;
         }
         if ( BotRight.y > OnScreenHeight_ ) {
            SrcRect.bottom -= BotRight.y - OnScreenHeight_;
            BotRight.y = OnScreenHeight_;
         }
         // if can not stretch will have color key border around the image
         if ( !OverlayCanStretch_ )
            Client = TRect( LeftTop, TSize( SrcRect.Width(), SrcRect.Height() ) );
         else
            Client = TRect( LeftTop, BotRight );//TSize( Client.Width(), Client.Height() ) );

         HRESULT hR = pOverlaySurf_->UpdateOverlay( &SrcRect, pOnScreenBuf_, &Client,
            DDOVER_KEYDEST | DDOVER_SHOW, NULL );

         switch ( hR ) {
         case DDERR_SURFACELOST:
            pOnScreenBuf_->Restore();
            pOverlaySurf_->Restore();
            if ( pOverlaySurf_->UpdateOverlay( &SrcRect, pOnScreenBuf_, &Client,
               DDOVER_KEYDEST | DDOVER_SHOW, NULL ) == DD_OK )
               break;  // break only if success
         default:
            Lame.IsOverlaying_ = false;
            break;
         case DD_OK:
            break;
         }
         if ( Data->Clip != 2 ) // did we recreate the overlay surface ?
            Data->Clip = 0;     // no, no need to do anything
      }
   } else {
      pOverlaySurf_->UpdateOverlay( NULL, pOnScreenBuf_, &Client,
         DDOVER_KEYDEST | DDOVER_HIDE, NULL );
   }
}

/* Method: DDI::GetData
 * Purpose:
 * Input: Data: SURF_DATA &
 * Output: None
 */
void DDI::GetData( SURF_DATA &Data )
{
   TRect rClientR;
   GetClientRect( hWin_, &rClientR );
   TPoint LeftTop = rClientR.TopLeft();
   ClientToScreen( hWin_, &LeftTop );

   Data.dwbpp = dwBpp_ * 8;

   if ( IsOverlaying_ )
      Data.dwAddress = dwSurfAddr_;
   else
      Data.dwAddress = dwSurfAddr_ + LeftTop.y * dwPitch_ + LeftTop.x * dwBpp_;

   Data.dwPitch = dwPitch_;
   Data.FourCC = FourCC_;
}

extern "C" DWORD  WINAPI DDI_GetData( LPSURF_DATA lpData )
{
   if ( !Lame.pOnScreenBuf_ )
      return Fail;

   if ( Lame.IsOverlaying_ ) {
      Lame.DoColorKey( lpData );
      if ( lpData ) {
         Lame.GetData( *lpData );
         lpData->dwScale = Lame.dwMinScale_;
      }
   }
   if ( Lame.IsOverlaying_ || !lpData ) {
    // called from StopOverlay to hide overlay surface with NULL ptr or
    // DoColorKey() above did not have any failures
      return Success;
   }
   // take care of cases when a window was moved
   if ( lpData->Clip )
      *OldClip = 0;
   if ( Lame.QueryClip() ) {
      Lame.GetData( *lpData );
      lpData->Clip = (DWORD)(LPVOID)NewClip;
   }
   lpData->dwScale = 0;
   return Success;
}

/* API: DDI_CreateSurface
 * Purpose: Creates a DDI surface ( primary and overlay ) used for displaying video
 * Input: hWin: HWND, handle of the video window
 *   KeyColor: COLORREF, key color
 *   lpPal: LPVOID, array of palette entries
 * Output: ErrorCode
 */
extern "C" DWORD  WINAPI DDI_CreateSurface( HWND hWin, COLORREF KeyColor, LPVOID lpPal )
{
   if ( !Lame.pDirectDrawObj_ )
      return Fail;

   Lame.AttachWindow( hWin );
   if ( Lame.CreatePrimSurface( KeyColor ) == Success ) {
      if ( lpPal )
         Lame.CreatePalette( (LPPALETTEENTRY)lpPal );
      return Success;
   }
   return Fail;
}

extern "C" DWORD  WINAPI DDI_IsClipListChanged()
{
   return false;
}

/* API: DDI_Init
 * Purpose: Initializes DDI objects
 */
extern "C" DWORD  WINAPI DDI_Init()
{
   if ( Lame.Init() != Success )
      return Fail;
   return Success;
}

/* API: DDI_Close
 * Purpose: Finishes off with the DDI
 */
extern "C" DWORD  WINAPI DDI_Close()
{
   Lame.Release();
   return Success;
}

/* API: DDI_GetFlags
 * Purpose: Reports back current settings
 */
extern "C" DWORD WINAPI DDI_GetFlags()
{
   RegUtil Surface( BT_VIDEO_REG_SUBKEY );
   DWORD dwLevel=0;
   
   if ( Surface.GetValue( &dwLevel, SurfName) != Success )
   {
        if ( Lame.IsOverlaying_ )
            UpdateSurfKey("0");
        if ( Lame.pOnScreenBuf_ )
            UpdateSurfKey("1");
   }
   
   RegUtil ForcePrimary( BT_VIDEO_REG_SUBKEY );
   DWORD dwForcePrimary;   
        
   if ( ForcePrimary.GetValue( &dwForcePrimary, ForcePrimaryKey ) != Success )
   {
        dwForcePrimary = 0;
        if ( Lame.IsOverlaying_ && (dwLevel==0))
            ForcePrimary.SetValue( dwForcePrimary, ForcePrimaryKey );
   }
   // Previous version of this function ignores the state of the Registry which is the
   // true state when surfaces are created or force primary is used. The following
   // dictates that this function follows the truth table for the Registry keys
   // Force Primary and Surface.  If surface == 0, then it is in Overlay, else primary
   // surface.  The force primary has higher priority since it is evaluated first to
   // determine which surface is to be created.  If Force Primary == 0, then we will
   // try to create the overlay surface, else we will be force to create a primary surface.
   // TT
   //
   // Truth table:  Surface     Force Primary       State
   //                 0               0             Overlay Surface
   //                 0               1             Primary Surface
   //                 1               0             Overlay Surface ( Surface is irrevelant )
   //                 1               1             Primary Surface
   
   if ( Lame.IsOverlaying_ || Lame.pOverlaySurf_ && ((dwLevel==0) && (dwForcePrimary==0)))
      return USE_OVERLAY;
   if ( Lame.pOverlaySurf_ || ((dwLevel==0) && (dwForcePrimary==0)))
      return USE_OVERLAY;
   if ( Lame.pOnScreenBuf_ || ((dwLevel==0) && (dwForcePrimary==1)))
      return USE_PRIMARY;
   if ( Lame.pOnScreenBuf_ || ((dwLevel==1) && (dwForcePrimary==0)) )
      return USE_OVERLAY;
   if ( Lame.pOnScreenBuf_ || ((dwLevel==1) && (dwForcePrimary==1)) )
      return USE_PRIMARY;
   return 0;
}

/* API: DDI_SetKeyColor
 * Purpose: Assigns key color for the color keying
 * Input: dwCol: DWORD, key color
 */
extern "C" DWORD WINAPI DDI_SetKeyColor( DWORD dwCol )
{
   DDCOLORKEY ddck;
   if ( !Lame.pOnScreenBuf_ )
      return 0;

   Lame.pOnScreenBuf_->GetColorKey( DDCKEY_DESTOVERLAY, &ddck );

   DWORD dwRetVal = ddck.dwColorSpaceLowValue;

   if ( dwCol ) {
      ddck.dwColorSpaceLowValue = dwCol;
      Lame.pOnScreenBuf_->SetColorKey( DDCKEY_DESTOVERLAY, &ddck );
   }
   return dwRetVal;
}

/* API: DDI_DoPalette
 * Purpose: Selects palette
 */
extern "C" void WINAPI DDI_DoPalette()
{
   if ( Lame.pPal_ )
      Lame.pOnScreenBuf_->SetPalette( Lame.pPal_ );
}

/* Method: DDI::Release
 * Purpose: Releases all DDI objects
 */
void DDI::Release()
{
   if ( pOnScreenBuf_ ) pOnScreenBuf_->Release();
   if ( pClipper_     ) pClipper_->Release();
   if ( pPal_         ) pPal_->Release();
   if ( pOverlaySurf_ ) pOverlaySurf_->Release();
   if ( pDirectDrawObj_ ) pDirectDrawObj_->Release();

   pOverlaySurf_ = NULL;
   pOnScreenBuf_ = NULL;
   pClipper_     = NULL;
   pPal_         = NULL;
   pDirectDrawObj_ = NULL;
}

DDI::~DDI()
{
   Release();
}

/* Function:  CheckPossibleOverlays()
 * Purpose: attempts to create overlay surfaces of various sizes to set
 * the bitmask key
 * Input: None
 * Output: None
 */
void DDI::CheckPossibleOverlays()
{
   int flags = 7; // can do 160x120, 320x240, 640x480 without overlay support
   TRect DeskR;
   // can support full screen ?
   GetWindowRect( GetDesktopWindow(), &DeskR );

   if ( CreateOverlay( true, DeskR.Width(), DeskR.Height() ) == Success )
      flags |= 8;
   char mask [3];
   wsprintf( mask, "%x", flags );

   UpdateRegistry( IcastKey, BitMask, mask );

}

extern "C" void WINAPI DDI_SetVidSize( DWORD dwWidth, DWORD dwHeight )
{
   Lame.SetVidSize( dwWidth, dwHeight );
}


extern "C" DWORD WINAPI LoadBitmapImage( HINSTANCE hInst, LPCSTR szBitmap )
{
   HBITMAP             hbm;
   
   if (!szBitmap)
	  return Fail;
   
   //
   //  try to load the bitmap as a resource, if that fails, try it as a file
   //
   hbm = (HBITMAP)LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);

   if (hbm == NULL)
      hbm = (HBITMAP)LoadImage(hInst, szBitmap, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);

   if (hbm == NULL)
      return (DWORD)NULL;

   return (DWORD)hbm;
}



#ifdef __BORLANDC__
extern "C" BOOL CAP_ThunkConnect32( LPCSTR, LPCSTR, HINSTANCE hInst, DWORD dwReason );
#else  // Microsoft
extern "C" BOOL _stdcall _declspec(dllexport) CAP_ThunkConnect32( LPCSTR, LPCSTR, HINSTANCE hInst, DWORD dwReason );
#endif

/* Function:
 * Purpose:
 */
#ifdef __BORLANDC__
int PASCAL DllEntryPoint( HINSTANCE hInst, DWORD dwReason, LPVOID )
#else  // Microsoft
int PASCAL DllMain( HINSTANCE hInst, DWORD dwReason, LPVOID )
#endif
{
   if ( !CAP_ThunkConnect32( "btVid.drv", "btddi.dll", hInst, dwReason ) )
      return FALSE;

   return TRUE;
}



