// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Decoder/rcs/CONSTR.H 2.8 1998/02/24 22:15:31 rudyl Exp $
// $Log: CONSTR.H $
// Revision 2.8  1998/02/24 22:15:31  rudyl
// Added VSFLDALIGH reg field.
// Revision 2.7  1998/01/16 21:58:02  rudyl
// Gemini Rev D: HSFMT changes from 1 to 2 bits.
// Revision 2.6  1997/08/14 19:01:03  rudyl
// Graft from 2.5.1.2. Added Gemini support.
// Revision 2.5.1.2  1997/07/24 00:36:22  rudyl
// Added VTOTAL register.
// Revision 2.5.1.1  1997/05/02 23:05:52  rudyl
// Duplicate revision
// Revision 2.4  1997/04/16 17:38:28  rudyl
// Graft from 2.3.2.2:
// Removed reg names.
// Revision 2.3.2.2  1996/12/17 21:54:59  rudyl
// Removed reg names.
// Revision 2.3.2.1  1996/12/17 21:44:50  rudyl
// remove reg names
// Revision 2.3  1996/08/12 22:30:10  rudyl
// Bt848 has white crush up and down regs. Added them temporarily long time ago. Now officiallly in our decoder set.
// Revision 2.2  1996/06/25 22:42:13  rudyl
// Removed ACCEL since it doesn't exist. Also removed functions related to HACTIVE and HSFMT since they should always be 0.
// Revision 2.1  1996/06/10 20:12:20  ssm
// MarkBeta1AsRev2
// Revision 1.12  1996/04/17 19:32:09  rudyl
// No more Decoder base class. Bt848 has its own decoder class not derived from any other class.

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    Constr.h
//
//  Abstract:
//
//    Construct register and register fields for Bt848 decoder class API
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __CONSTR_H
#define __CONSTR_H

#define CONSTRUCT_REGISTERS \
decRegSTATUS ( ( (0x00 + 0) * 4) + 0, RW ) ,\
decFieldPRES( decRegSTATUS, 7, 1, RW) ,\
decFieldHLOC( decRegSTATUS, 6, 1, RW) ,\
decFieldEVENFIELD( decRegSTATUS, 5, 1, RW) ,\
decFieldNUML( decRegSTATUS, 4, 1, RW) ,\
decFieldCSEL( decRegSTATUS, 3, 1, RW) ,\
decFieldSTATUS_RES( decRegSTATUS, 2, 1, RW) ,\
decFieldLOF( decRegSTATUS, 1, 1, RW) ,\
decFieldCOF( decRegSTATUS, 0, 1, RW) ,\
decRegIFORM ( ( (0x01 + 0) * 4) + 0, RW ) ,\
decFieldHACTIVE( decRegIFORM, 7, 1, RW) ,\
decFieldMUXSEL( decRegIFORM, 5, 2, RW) ,\
decFieldXTSEL( decRegIFORM, 3, 2, RW) ,\
decFieldFORMAT( decRegIFORM, 0, 3, RW) ,\
decRegTDEC ( ( (0x02 + 0) * 4) + 0, RW ) ,\
decFieldDEC_FIELD( decRegTDEC, 7, 1, RW) ,\
decFieldDEC_FIELDALIGN( decRegTDEC, 6, 1, RW) ,\
decFieldDEC_RAT( decRegTDEC, 0, 6, RW) ,\
decRegBRIGHT ( ( (0x0A + 0) * 4) + 0, RW ) ,\
decRegMISCCONTROL ( ( (0x0B + 0) * 4) + 0, RW ) ,\
decFieldLNOTCH( decRegMISCCONTROL, 7, 1, RW) ,\
decFieldCOMP( decRegMISCCONTROL, 6, 1, RW) ,\
decFieldLDEC( decRegMISCCONTROL, 5, 1, RW) ,\
decFieldCBSENSE( decRegMISCCONTROL, 4, 1, RW) ,\
decFieldMISCCONTROL_RES( decRegMISCCONTROL, 3, 1, RW) ,\
decFieldCON_MSB( decRegMISCCONTROL, 2, 1, RW) ,\
decFieldSAT_U_MSB( decRegMISCCONTROL, 1, 1, RW) ,\
decFieldSAT_V_MSB( decRegMISCCONTROL, 0, 1, RW) ,\
decRegCONTRAST_LO ( ( (0x0C + 0) * 4) + 0, RW ) ,\
decRegSAT_U_LO ( ( (0x0D + 0) * 4) + 0, RW ) ,\
decRegSAT_V_LO ( ( (0x0E + 0) * 4) + 0, RW ) ,\
decRegHUE ( ( (0x0F + 0) * 4) + 0, RW ) ,\
decRegSCLOOP ( ( (0x10 + 0) * 4) + 0, RW ) ,\
decFieldCAGC( decRegSCLOOP, 6, 1, RW) ,\
decFieldCKILL( decRegSCLOOP, 5, 1, RW) ,\
decFieldHFILT( decRegSCLOOP, 3, 2, RW) ,\
decRegWC_UP( ( (0x11 + 0) * 4) + 0, RW ) ,\
decRegOFORM ( ( (0x12 + 0) * 4) + 0, RW ) ,\
decFieldRANGE( decRegOFORM, 7, 1, RW) ,\
decFieldCORE( decRegOFORM, 5, 2, RW) ,\
decRegVSCALE_HI ( ( (0x13 + 0) * 4) + 0, RW ) ,\
decFieldYCOMB( decRegVSCALE_HI, 7, 1, RW) ,\
decFieldCOMB( decRegVSCALE_HI, 6, 1, RW) ,\
decFieldINT( decRegVSCALE_HI, 5, 1, RW) ,\
decRegTEST ( ( (0x15 + 0) * 4) + 0, RW ) ,\
decRegADELAY ( ( (0x18 + 0) * 4) + 0, RW ) ,\
decRegBDELAY ( ( (0x19 + 0) * 4) + 0, RW ) ,\
decRegADC ( ( (0x1A + 0) * 4) + 0, RW ) ,\
decFieldSYNC_T( decRegADC, 5, 1, RW) ,\
decFieldAGC_EN( decRegADC, 4, 1, RW) ,\
decFieldCLK_SLEEP( decRegADC, 3, 1, RW) ,\
decFieldY_SLEEP( decRegADC, 2, 1, RW) ,\
decFieldC_SLEEP( decRegADC, 1, 1, RW) ,\
decFieldCRUSH( decRegADC, 0, 1, RW), \
decRegVTC ( ( (0x1B + 0) * 4) + 0, RW ) ,\
decFieldHSFMT( decRegVTC, 7, 1, RW) ,\
decRegWC_DN( ( (0x1E + 0) * 4) + 0, RW ) ,\
decRegSRESET ( ( (0x1F + 0) * 4) + 0, RW ) ,\
decRegODD_MISCCONTROL ( ( (0x0B + -0x03) * 4) + 0x8C, RW ) ,\
decFieldODD_LNOTCH( decRegODD_MISCCONTROL, 7, 1, RW) ,\
decFieldODD_COMP( decRegODD_MISCCONTROL, 6, 1, RW) ,\
decFieldODD_LDEC( decRegODD_MISCCONTROL, 5, 1, RW) ,\
decFieldODD_CBSENSE( decRegODD_MISCCONTROL, 4, 1, RW) ,\
decFieldODD_MISCCONTROL_RES( decRegODD_MISCCONTROL, 3, 1, RW) ,\
decFieldODD_CON_MSB( decRegODD_MISCCONTROL, 2, 1, RW) ,\
decFieldODD_SAT_U_MSB( decRegODD_MISCCONTROL, 1, 1, RW) ,\
decFieldODD_SAT_V_MSB( decRegODD_MISCCONTROL, 0, 1, RW) ,\
decRegODD_SCLOOP ( ( (0x10 + -0x03) * 4) + 0x8C, RW ) ,\
decFieldODD_CAGC( decRegODD_SCLOOP, 6, 1, RW) ,\
decFieldODD_CKILL( decRegODD_SCLOOP, 5, 1, RW) ,\
decFieldODD_HFILT( decRegODD_SCLOOP, 3, 2, RW) ,\
decRegODD_VSCALE_HI ( ( (0x13 + -0x03) * 4) + 0x8C, RW ) ,\
decFieldODD_YCOMB( decRegODD_VSCALE_HI, 7, 1, RW) ,\
decFieldODD_COMB( decRegODD_VSCALE_HI, 6, 1, RW) ,\
decFieldODD_INT( decRegODD_VSCALE_HI, 5, 1, RW) ,\
decRegODD_VTC ( ( (0x1B + -0x03) * 4) + 0x8C, RW ) ,\
decFieldODD_HSFMT( decRegODD_VTC, 7, 1, RW)

#define CONSTRUCT_REGISTERS_2 \
   decFieldPLOCK( decRegSTATUS, 2, 1, RW),\
   decFieldPEAK( decRegSCLOOP, 7, 1, RW),\
   decFieldVertEn( decRegWC_DN, 7, 1, RW),\
   decFieldODD_PEAK( decRegODD_SCLOOP, 7, 1, RW),\
   decRegDVSIF ( ( (0x3F + 0) * 4) + 0, RW) ,\
   decFieldGPX_EN( decRegDVSIF, 7, 1, RW) ,\
   decFieldVSIF_BCF( decRegDVSIF, 6, 1, RW) ,\
   decFieldVSIF_ESO( decRegDVSIF, 5, 1, RW) ,\
   decFieldSVREF( decRegDVSIF, 3, 2, RW) ,\
   decFieldVSFMT( decRegDVSIF, 0, 3, RW)

#define CONSTRUCT_REGISTERS_GEMINI \
   decRegVTOTAL_LO ( 0xB0, RW) ,\
   decRegVTOTAL_HI ( 0xB4, RW) ,\
   decFieldVTOTAL_HI( decRegVTOTAL_HI, 0, 2, RW),\
   decRegVTOTAL( decRegVTOTAL_LO, 8, decFieldVTOTAL_HI, RW ),\
   decFieldHSFMT2( decRegVTC, 6, 2, RW) ,\
   decFieldODD_HSFMT2( decRegODD_VTC, 6, 2, RW),\
   decFieldVSFLDALIGN( decRegVSCALE_HI, 7, 1, RW) ,\
   decFieldODD_VSFLDALIGN( decRegODD_VSCALE_HI, 7, 1, RW)

#endif   // __CONSTR_H


