// $header$
// $Log: DECLARE.H $
// Revision 2.7  1998/02/24 22:15:32  rudyl
// Added VSFLDALIGH reg field.
// Revision 2.6  1998/01/16 21:58:04  rudyl
// Gemini Rev D: HSFMT changes from 1 to 2 bits.
// Revision 2.5  1997/08/14 19:01:29  rudyl
// Graft from 2.4.1.2. Added Gemini support.
// Revision 2.4.1.2  1997/07/24 00:36:52  rudyl
// Added VTOTAL register.
// Revision 2.4.1.1  1997/05/05 17:20:18  rudyl
// Duplicate revision
// Revision 2.3.1.3  1997/02/14 23:44:58  rudyl
// Removed all #ifdef BT848A. Use same binary files for both Bt848 and Bt848A.
// Revision 2.3.1.2  1997/02/03 23:44:35  rudyl
// First Pisces+ check in.
// Revision 2.3.1.1  1996/11/01 22:19:02  rudyl
// Start Pisces+ work.
// Revision 2.3  1996/08/12 22:30:10  rudyl
// Bt848 has white crush up and down regs. Added them temporarily long time ago. Now officiallly in our decoder set.
// Revision 2.2  1996/06/25 22:42:13  rudyl
// Removed ACCEL since it doesn't exist. Also removed functions related to HACTIVE and HSFMT since they should always be 0.
// Revision 2.1  1996/06/10 20:12:20  ssm
// MarkBeta1AsRev2
// Revision 1.12  1996/04/17 19:32:09  rudyl
// No more Decoder base class. Bt848 has its own decoder class not derived from any other class.

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    Declare.h
//
//  Abstract:
//
//    Bt848 Decoder Class Register and Register Fields Declaration Header File
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __DECLARE_H
#define __DECLARE_H

RegisterB decRegSTATUS;
RegField  decFieldPRES;
RegField  decFieldHLOC;
RegField  decFieldEVENFIELD;
RegField  decFieldNUML;
RegField  decFieldCSEL;
RegField  decFieldSTATUS_RES;
RegField  decFieldPLOCK;  // replaces decFieldSTATUS_RES in Status bit2
RegField  decFieldLOF;
RegField  decFieldCOF;
RegisterB decRegIFORM;
RegField  decFieldHACTIVE;
RegField  decFieldMUXSEL;
RegField  decFieldXTSEL;
RegField  decFieldFORMAT;
RegisterB decRegTDEC;
RegField  decFieldDEC_FIELD;
RegField  decFieldDEC_FIELDALIGN;
RegField  decFieldDEC_RAT;
RegisterB decRegBRIGHT;
RegisterB decRegMISCCONTROL;
RegField  decFieldLNOTCH;
RegField  decFieldCOMP;
RegField  decFieldLDEC;
RegField  decFieldCBSENSE;
RegField  decFieldMISCCONTROL_RES;
RegField  decFieldCON_MSB;
RegField  decFieldSAT_U_MSB;
RegField  decFieldSAT_V_MSB;
RegisterB decRegCONTRAST_LO;
RegisterB decRegSAT_U_LO;
RegisterB decRegSAT_V_LO;
RegisterB decRegHUE;
RegisterB decRegSCLOOP;
RegField  decFieldPEAK;
RegField  decFieldCAGC;
RegField  decFieldCKILL;
RegField  decFieldHFILT;
RegisterB decRegWC_UP;
RegisterB decRegOFORM;
RegField  decFieldRANGE;
RegField  decFieldCORE;
RegisterB decRegVSCALE_HI;
RegField  decFieldYCOMB;
RegField  decFieldVSFLDALIGN;
RegField  decFieldCOMB;
RegField  decFieldINT;
RegisterB decRegTEST;
RegisterB decRegADELAY;
RegisterB decRegBDELAY;
RegisterB decRegADC;
RegField  decFieldSYNC_T;
RegField  decFieldAGC_EN;
RegField  decFieldCLK_SLEEP;
RegField  decFieldY_SLEEP;
RegField  decFieldC_SLEEP;
RegField  decFieldCRUSH;
RegisterB decRegVTC;
RegField  decFieldHSFMT;
RegisterB decRegWC_DN;
RegField  decFieldVertEn;
RegisterB decRegSRESET;
RegisterB decRegODD_MISCCONTROL;
RegField  decFieldODD_LNOTCH;
RegField  decFieldODD_COMP;
RegField  decFieldODD_LDEC;
RegField  decFieldODD_CBSENSE;
RegField  decFieldODD_MISCCONTROL_RES;
RegField  decFieldODD_CON_MSB;
RegField  decFieldODD_SAT_U_MSB;
RegField  decFieldODD_SAT_V_MSB;
RegisterB decRegODD_SCLOOP;
RegField  decFieldODD_PEAK;
RegField  decFieldODD_CAGC;
RegField  decFieldODD_CKILL;
RegField  decFieldODD_HFILT;
RegisterB decRegODD_VSCALE_HI;
RegField  decFieldODD_YCOMB;
RegField  decFieldODD_VSFLDALIGN;
RegField  decFieldODD_COMB;
RegField  decFieldODD_INT;
RegisterB decRegODD_VTC;
RegField  decFieldODD_HSFMT;
RegisterB decRegDVSIF;
RegField  decFieldGPX_EN;
RegField  decFieldVSIF_BCF;
RegField  decFieldVSIF_ESO;
RegField  decFieldSVREF;
RegField  decFieldVSFMT;
RegisterB decRegVTOTAL_LO;       // new for Gemini
RegisterB decRegVTOTAL_HI;
RegField  decFieldVTOTAL_HI;
CompositeReg decRegVTOTAL;
RegField  decFieldHSFMT2;        // Gemini Rev D: expanded HSFMT to 2 bits - VTC[7:6]
RegField  decFieldODD_HSFMT2;    // Gemini Rev D: expanded HSFMT to 2 bits - VTC[7:6]


#endif   // __DECLARE_H


