// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Decoder/rcs/DECODER.CPP 2.15 1998/02/24 22:15:33 rudyl Exp $
/////////////////////////////////////////////////////////////////////////////
// $Log: DECODER.CPP $
// Revision 2.15  1998/02/24 22:15:33  rudyl
// Added VSFLDALIGH reg field.
// Revision 2.14  1998/01/16 21:58:06  rudyl
// Gemini Rev D: HSFMT changes from 1 to 2 bits.
// Revision 2.13  1997/11/26 00:17:36  peter
// Graft reg key move to tip.
// Revision 2.12.1.1  1997/11/25 17:32:20  peter
// Revision 2.12  1997/10/28 22:41:08  dtharp
// Disabled gemini AGC hack since we have new Si which supposedly
// works now.
// Revision 2.11  1997/09/27 02:43:24  dtharp
// Temporary fix for gemini AGC problem.
// Revision 2.10  1997/08/14 19:02:14  rudyl
// Graft from 2.9.1.3. Added Gemini support.
// Revision 2.9.1.3  1997/07/24 00:38:25  rudyl
// ADELAY def to 0x70 for NTSC.
// No contrast adjustment for Gemini.
// Added interfaces to VTOTAL register.
// Revision 2.9.1.2  1997/07/23 22:08:48  rudyl
// Respond to GPX_EN deletion for Gemini.
// Revision 2.9.1.1  1997/07/23 02:01:44  rudyl
// Add Gemini support.
// Revision 2.9  1997/05/02 22:55:54  dtharp
// 848A Merge: from 2.5.1.5
// Revision 2.8  1996/12/11 20:50:22  rudyl
// Use "Bt848" as registry main key.
// Revision 2.7  1996/12/06 22:53:24  meierdw
// Re-grafting 2.5.1 into trunk. 2.6 was premature; NTSC-Japan support added.
// Revision 2.5.1.3  1996/12/06 22:53:24  rudyl
// Changed registry key to "AltContrast".
// Revision 2.5.1.2  1996/11/05 19:32:48  rudyl
// Added support for NTSC-JAPAN, PAL-M & PAL-N.
// Revision 2.5.1.1  1996/10/11 01:23:58  rudyl
// Bug #: 351
// Problem: hardware / driver incorrectly implements contrast
// Solution: Adjust brightness when changing contrast to compensate the undesirable effect on brightness.
// Added "AdjustContrast" registry key to enable this adjustment; =0 no adjustment (default), =1 enable adjustment
// 
// Also added some Pisces+ codes. Still incomplete. Added #ifdef BT849 around all pisces+ codes.
// Revision 2.4  1996/08/12 22:30:11  rudyl
// Bt848 has white crush up and down regs. Added them temporarily long time ago. Now officiallly in our decoder set.
// Revision 2.3  1996/08/08 01:12:04  rudyl
// changed nominal SECAM U value to 0x87 and V to 0x85.
// Revision 2.2  1996/06/25 22:42:14  rudyl
// Removed ACCEL since it doesn't exist. Also removed functions related to HACTIVE and HSFMT since they should always be 0.
// Revision 2.1  1996/06/10 20:12:22  ssm
// MarkBeta1AsRev2
// Revision 1.25  1996/06/07 21:06:45  rudyl
// Look for registry key is in HKEY_CLASSES_ROOT.
// Revision 1.24  1996/06/06 18:32:23  rudyl
// changed registry key from Bt848 or APisces --> Software\Brooktree\Bt848
// Revision 1.23  1996/06/06 01:33:28  rudyl
// Added SelectCrystal() to determine which crystal to select when video format changes.
// Revision 1.22  1996/05/23 22:44:28  rudyl
// Modified calculation of U & V values in SetSaturation. Values were too small compared to default.
// Now also support SECAM. NTSC/PAL have the same U & V values. SECAM's are different.
// Revision 1.21  1996/05/21 22:23:37  rudyl
// Expects dialog to pass in PAL_BDGHI as default PAL
// Revision 1.20  1996/05/20 23:44:20  rudyl
// Added support of SECAM except Chroma U & V values need to be changed.
// Not calling Scaler::Set525Lines() but calling Scaler::VideoFormatChanged() in SetVideoFormat().
// Revision 1.19  1996/05/18 01:53:44  rudyl
// Calls Scaler::Set525Lines( bool Is525Lines ) in SetVideoFormat() so scaler can set up correct values.
// Always set crystal to XT0 assuming there is only one on the board and is a correct one.
// Revision 1.18  1996/05/14 00:16:56  sasha
// Fixed GetVideoFormat() function.
// Revision 1.17  1996/05/09 00:58:16  rudyl
// Didn't quite fix it last time. Now it works.
// Revision 1.16  1996/05/09 00:09:56  rudyl
// Passed wrong value to SetCompositeVideo() when changing video source.
// Revision 1.15  1996/05/02 16:58:31  rudyl
// Removed scaler related registers/codes.
// Revision 1.14  1996/04/18 21:27:40  sasha
// Disable chroma crush by default
// Revision 1.13  1996/04/18 19:06:00  sasha
// Added two white crush related registers. And write them 2 !
// Revision 1.12  1996/04/17 19:32:10  rudyl
// No more Decoder base class. Bt848 has its own decoder class not derived from any other class.
// Revision 1.11  1996/01/29 02:36:28  sasha
// Added writes to the odd misc. control register
// Revision 1.10  1996/01/29 00:10:01  ssm
// recode SetVideoSource to support 3 muxes and use type Connector
// Revision 1.9  1996/01/19 22:06:17  sasha
// Changed one symbol
// Revision 1.8  1996/01/19 21:49:24  ssm
// replaced < DECREGARRAY_NULL with <=
// Revision 1.7  1996/01/19 21:40:26  ssm
// increased size of ptrDecoderRegisters array to fix page fault problems
// Revision 1.6  1996/01/11 23:45:23  sasha
// Added .h file with decoder constants
// Revision 1.5  1996/01/06 00:55:49  ssm
// 1st compile with scaler
// Revision 1.4  1996/01/05 19:45:50  ssm
// removed asserts to make vtoolsd happy
// Revision 1.3  1996/01/05 18:07:54  ssm
// replace floats with dword in SetSaturation
// Revision 1.1  1996/01/05 18:01:20  ssm
// Initial revision
// Revision 1.2  1996/01/05 01:06:12  ssm
// 1st successful compile
// Revision 1.1  1996/01/04 21:37:14  ssm
// Initial revision
// Revision 1.6  1995/11/22 03:45:25  ssm
// 1st successfull build with decoder & 2 scalers using Registers
// class.  No testing done !!!
// Revision 1.5  1995/11/21 22:38:50  ssm
// 1st port to pisces register class
// Revision 1.4  1995/11/20 18:24:49  ssm
// ci prior to trying port to pisces Registers class
// Revision 1.3  1995/11/14 17:37:03  ssm
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    Decoder.cpp
//
//  Abstract:
//
//    Bt848 Decoder Class API
//
//  REQUIREMENTS
//
//    1- contains decoder functions except for scaling and clipping
//    2- codes are compiled under BC++ 4.52
//
//  DESIGN NOTES
//
//    1- all Decoder registers are abstracted by the Register class
//    2- fields within registers are abstracted by the RegField class
//
/////////////////////////////////////////////////////////////////////////////

#include "Scaler.h"
#include "decoder.h"
#include "constr.h"
#include "dcdrvals.h"
#include "regstr.h"
#include "vregkey.h"
#include "device.h"

#define nGEMINI_AGC_FIX

//===========================================================================
// Local function prototypes
//===========================================================================
bool IsGeminiFamily( void );

//===========================================================================
// Bt848 Decoder Class Implementation
//===========================================================================

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////
Decoder::Decoder( void ) :
   // init register min, max, default
   m_regHue( HueMin, HueMax, HueDef ),
   m_regSaturationNTSC( SatMinNTSC, SatMaxNTSC, SatDefNTSC ),
   m_regSaturationSECAM( SatMinSECAM, SatMaxSECAM, SatDefSECAM ),
   m_regContrast( ConMin, ConMax, ConDef ),
   m_regBrightness( BrtMin, BrtMax, BrtDef ),
   m_param( ParamMin, ParamMax, ParamDef ),
   m_regSaturationDig( SatMinDig, SatMaxDig, SatDefDig ),
   CONSTRUCT_REGISTERS,
   CONSTRUCT_REGISTERS_2,
   CONSTRUCT_REGISTERS_GEMINI
{
   // need to set this to 0x4F
   decRegWC_UP = 0x4F;
   // and this one to 0x7F to make sure CRUSH bit works
   decRegWC_DN = 0x7F;

   // HACTIVE should always be 0
   decFieldHACTIVE = 0;

   // HSFMT (odd and even) default to 0
   decFieldHSFMT2 = decFieldODD_HSFMT2 = 0;  // HSFMT2 (2 bits) covers HSFMT (1 bit)

   // Instead of using default values, set some registers fields to optimum values
   SetLumaDecimation( true );
   SetChromaAGC( true );
   SetLowColorAutoRemoval( true );
   SetAdaptiveAGC( false );

   // for contrast adjustment purpose
   regBright = 0x00;     // brightness register value before adjustment
   regContrast = 0xD8;   // contrast register value before adjustment
};

/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
Decoder::~Decoder()
{
}


//===== Device Status register ==============================================

/////////////////////////////////////////////////////////////////////////////
// Method:  BYTE Decoder::GetDeviceStatusReg( void )
// Purpose: Obtain device status register value
// Input:   None
// Output:  None
// Return:  value of status register in BYTE
/////////////////////////////////////////////////////////////////////////////
BYTE Decoder::GetDeviceStatusReg( void )
{
	BYTE status = decRegSTATUS;
	decRegSTATUS = 0x00;
   return status;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsVideoPresent( void )
// Purpose: Detect if video is present
// Input:   None
// Output:  None
// Return:  true if video present; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsVideoPresent( void )
{
  return (bool) (decFieldPRES == 1);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsDeviceInHLock( void )
// Purpose: Detect if device is in H-lock
// Input:   None
// Output:  None
// Return:  true if device in H-lock; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsDeviceInHLock( void )
{
  return (bool) (decFieldHLOC == 1);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsEvenField( void )
// Purpose: Reflect whether an even or odd field is being decoded
// Input:   None
// Output:  None
// Return:  true if even field; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsEvenField( void )
{
  return (bool) (decFieldEVENFIELD == 1);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::Is525LinesVideo( void )
// Purpose: Check to see if we are dealing with 525 lines video signal
// Input:   None
// Output:  None
// Return:  true if 525 lines detected; else false (assume 625 lines)
/////////////////////////////////////////////////////////////////////////////
bool Decoder::Is525LinesVideo( void )
{
  return (bool) (decFieldNUML == 0);  //525
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsCrystal0Selected( void )
// Purpose: Reflect whether XTAL0 or XTAL1 is selected
// Input:   None
// Output:  None
// Return:  true if XTAL0 selected; else false (XTAL1 selected)
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsCrystal0Selected( void )
{
  return (bool) (decFieldCSEL == 0);
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsPLLOutOfLock( void )
// Purpose: Indicates if PLL is out of lock
// Input:   None
// Output:  None
// Return:  true if PLL is out of lock; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsPLLOutOfLock( void )
{
  return (bool) (decFieldPLOCK == 1);
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::ResetPLLOutOfLock( void )
// Purpose: Reset PLL out of lock bit
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::ResetPLLOutOfLock( void )
{
  decFieldPLOCK = 0;  // write to it will reset the bit
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLumaOverflow( void )
// Purpose: Indicates if luma ADC overflow
// Input:   None
// Output:  None
// Return:  true if luma ADC overflow; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLumaOverflow( void )
{
  return (bool) (decFieldLOF == 1);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::ResetLumaOverflow( void )
// Purpose: Reset luma ADC overflow bit
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::ResetLumaOverflow( void )
{
  decFieldLOF = 0;  // write to it will reset the bit
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsChromaOverflow( void )
// Purpose: Indicates if chroma ADC overflow
// Input:   None
// Output:  None
// Return:  true if chroma ADC overflow; else false
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsChromaOverflow( void )
{
  return (bool) (decFieldCOF == 1);
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::ResetChromaOverflow( void )
// Purpose: Reset chroma ADC overflow bit
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::ResetChromaOverflow( void )
{
  decFieldCOF = 0;  // write to it will reset the bit
}


//===== Input Format register ===============================================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetVideoInput( Connector source )
// Purpose: Select which connector as input
// Input:   Connector source - SVideo, Tuner, Composite
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetVideoInput( Connector source )
{
  if ( source > ConComposite )
    return Fail;

  decFieldMUXSEL = source;

  // set to composite or Y/C component video depends on video source
  SetCompositeVideo( ( source == ConSVideo ) ? false : true );
  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetVideoInput( void )
// Purpose: Get which connector is input
// Input:   None
// Output:  None
// Return:  Video source - SVideo, Tuner, Composite
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetVideoInput( void )
{
  return ((int)decFieldMUXSEL);
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetCrystal( Crystal crystalNo )
// Purpose: Select which crystal as input
// Input:   Crystal crystalNo:
//            XT0         - Crystal_XT0
//            XT1         - Crystal_XT1
//            Auto select - Crystal_AutoSelect
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetCrystal( Crystal crystalNo )
{
  if ( ( crystalNo < Crystal_XT0 ) || ( crystalNo >  Crystal_AutoSelect ) )
    return Fail;

  decFieldXTSEL = crystalNo;
  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetCrystal( void )
// Purpose: Get which crystal is input
// Input:   None
// Output:  None
// Return:   Crystal Number:
//            XT0         - Crystal_XT0
//            XT1         - Crystal_XT1
//            Auto select - Crystal_AutoSelect
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetCrystal( void )
{
  return ((int)decFieldXTSEL);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetVideoFormat( VideoFormat format )
// Purpose: Set video format
// Input:   Video format -
//            Auto format:          VFormat_AutoDetect
//            NTSC (M):             VFormat_NTSC
//            NTSC (J):             VFormat_NTSC_J
//            PAL (B, D, G, H, I):  VFormat_PAL_BDGHI
//            PAL (M):              VFormat_PAL_M
//            PAL(N):               VFormat_PAL_N
//            SECAM:                VFormat_SECAM
// Output:  None
// Return:  Fail if error in parameter, else Success
// Notes:   Available video formats are: NTSC, NTSC(J), PAL(B, D, G, H, I), PAL(M),
//                                       PAL(N), SECAM
//          This function also sets the AGCDelay (ADELAY) and BrustDelay
//          (BDELAY) registers
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetVideoFormat( VideoFormat format )
{
  if ( (format <  VFormat_AutoDetect)  ||
       (format >  VFormat_PAL_NC) )
    return Fail;

  switch (format)
  {
    case VFormat_NTSC:
    case VFormat_NTSC_J:
    case VFormat_PAL_M:
    case VFormat_PAL_NC:
      decFieldFORMAT = format;
  		decRegADELAY = ( IsGeminiFamily() ? 0x70 : 0x68 );
  		decRegBDELAY = 0x5D;
      SetChromaComb( true );        // enable chroma comb
      SelectCrystal( 'N' );         // select NTSC crystal
      Scaler::VideoFormatChanged( format );
      break;

    case VFormat_PAL_BDGHI:
    case VFormat_PAL_N:
      decFieldFORMAT = format;
      decRegADELAY = 0x7F;
      decRegBDELAY = 0x72;
      SetChromaComb( true );        // enable chroma comb
      SelectCrystal( 'P' );         // select PAL crystal
      Scaler::VideoFormatChanged( format );
      break;

    case VFormat_SECAM:
      decFieldFORMAT = format;
      decRegADELAY = 0x7F;
      decRegBDELAY = 0xA0;
      SetChromaComb( false );       // disable chroma comb
      SelectCrystal( 'P' );         // select PAL crystal
      Scaler::VideoFormatChanged( format );
      break;

    default: // VFormat_AutoDetect
      // auto format detect by examining the number of lines
      if ( Decoder::Is525LinesVideo() ) // lines == 525 -> NTSC
        Decoder::SetVideoFormat( VFormat_NTSC );
      else  // lines == 625 -> PAL/SECAM
        Decoder::SetVideoFormat( VFormat_PAL_BDGHI );    // PAL_BDGHI covers most areas
  }

  SetSaturation( m_satParam );
  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetVideoFormat( void )
// Purpose: Obtain video format
// Input:   None
// Output:  None
// Return:  Video format
//            Auto format:          VFormat_AutoDetect
//            NTSC (M):             VFormat_NTSC
//            PAL (B, D, G, H, I):  VFormat_PAL_BDGHI
//            PAL (M):              VFormat_PAL_M
//            PAL(N):               VFormat_PAL_N
//            SECAM:                VFormat_SECAM
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetVideoFormat( void )
{
   BYTE bFormat = decFieldFORMAT;
   if ( !bFormat ) // autodetection enabled
      return Is525LinesVideo() ? VFormat_NTSC : VFormat_PAL_BDGHI;
   else
     return bFormat;
}


//===== Temporal Decimation register ========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetRate( bool fields, VidField even, int rate )
// Purpose: Set frames or fields rate
// Input:   bool fields   - true for fields, false for frames
//          VidField even - true to start decimation with even field, false odd
//          int  rate     - decimation rate: frames (1-50/60); fields(1-25/30)
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetRate( bool fields, VidField vf, int rate )
{
  int nMax;
  if ( Is525LinesVideo() == true )
    nMax = 30;  // NTSC
  else
    nMax = 25;  // PAL/SECAM

  // if setting frame rate, double the max value
  if ( fields == false )
    nMax *= 2;

  if ( rate < 0 || rate > nMax )
    return Fail;

  decFieldDEC_FIELD = (fields == false) ? Off : On;
  decFieldDEC_FIELDALIGN = (vf == VF_Even) ? On : Off;
  int nDrop = (BYTE) nMax - rate;
  decFieldDEC_RAT = (BYTE) (fields == false) ? nDrop : nDrop * 2;

  return Success;
}


//===== Brightness Control register =========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetBrightness( int param )
// Purpose: Set video brightness
// Input:   int param - parameter value (0-255; default 128)
// Output:  None
// Return:  Fail if error in parameter, else Success
// Note:    See IsAdjustContrast() for detailed description of the contrast
//          adjustment calculation
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetBrightness( int param )
{
  if( m_param.OutOfRange( param ) )
    return Fail;

  // perform mapping to our range
  int mapped;
  if ( Mapping( param, m_param, &mapped, m_regBrightness ) == Fail )
    return Fail;

  m_briParam = (WORD)param;

  // calculate brightness value
  int value = (128 * mapped) / m_regBrightness.Max() ;

  // need to limit the value to 0x7F (+50%) because 0x80 is -50%!
  if (( mapped > 0 ) && ( value == 0x80 ))
    value = 0x7F;

  // perform adjustment of brightness register if adjustment is needed
  //
  if ( !IsGeminiFamily() && IsAdjustContrast() )
  {
    regBright = value;   // brightness value before adjustment
    value = RecalcBrightness();
  }

  decRegBRIGHT = (BYTE)value;
  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetBrightness( void )
// Purpose: Obtain brightness value
// Input:   None
// Output:  None
// Return:  Brightness parameter (0-255)
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetBrightness( void )
{
  return m_briParam;
}


//===== Miscellaneous Control register (E_CONTROL, O_CONTROL) ===============

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetLumaNotchFilter( bool mode )
// Purpose: Enable/Disable luma notch filter
// Input:   bool mode - true = Enable; false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetLumaNotchFilter( bool mode )
{
  decFieldLNOTCH = decFieldODD_LNOTCH = (mode == false) ? On : Off;  // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLumaNotchFilter( void )
// Purpose: Check if luma notch filter is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable; false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLumaNotchFilter( void )
{
  return (decFieldLNOTCH == Off) ? true : false;  // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetCompositeVideo( bool mode )
// Purpose: Select composite or Y/C component video
// Input:   bool mode - true = Composite; false = Y/C Component
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetCompositeVideo( bool mode )
{
  if ( mode == true )
  {
    // composite video
    decFieldCOMP = decFieldODD_COMP = Off;
    Decoder::SetChromaADC( false );  // disable chroma ADC
    Decoder::SetLumaNotchFilter( true );  // enable luma notch filter
  }
  else
  {
    // Y/C Component video
    decFieldCOMP = decFieldODD_COMP = On;
    Decoder::SetChromaADC( true );  // enable chroma ADC
    Decoder::SetLumaNotchFilter( false );  // disable luma notch filter
  }
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsCompositeVideo( void )
// Purpose: Check if selected composite or Y/C component video
// Input:   None
// Output:  None
// Return:  true = Composite; false = Y/C Component
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsCompositeVideo( void )
{
  return (decFieldCOMP == Off) ? true : false;  // reverse
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetLumaDecimation( bool mode )
// Purpose: Enable/Disable luma decimation filter
// Input:   bool mode - true = Enable; false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetLumaDecimation( bool mode )
{
   // value of 0 turns the decimation on
   decFieldLDEC = decFieldODD_LDEC = (mode == true) ? 0 : 1;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLumaDecimation( void )
// Purpose: Check if luma decimation filter is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable; false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLumaDecimation( void )
{
  return (decFieldLDEC == Off) ? true : false;  // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetCbFirst( bool mode )
// Purpose: Control whether the first pixel of a line is a Cb or Cr pixel
// Input:   bool mode - true = Normal Cb, Cr order, false = Invert Cb, Cr order
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetCbFirst( bool mode )
{
  decFieldCBSENSE = decFieldODD_CBSENSE = (mode == false) ? On : Off;  // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsCbFirst( void )
// Purpose: Check if the first pixel of a line is a Cb or Cr pixel
// Input:   None
// Output:  None
// Return:  true = Normal Cb, Cr order, false = Invert Cb, Cr order
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsCbFirst( void )
{
  return (decFieldCBSENSE == Off) ? true : false;  // reverse
}


//===== Luma Gain register (CON_MSB, CONTRAST_LO) ===========================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetContrast( int param )
// Purpose: Set video contrast
// Input:   int param - parameter value (0-255; default 128)
// Output:  None
// Return:  Fail if error in parameter, else Success
// Note:    See IsAdjustContrast() for detailed description of the contrast
//          adjustment calculation
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetContrast( int param )
{
  if( m_param.OutOfRange( param ) )
    return Fail;

  bool adjustContrast = bool( !IsGeminiFamily() && IsAdjustContrast() ); // is contrast need to be adjusted

  // if adjust contrast is needed, make sure contrast reg value != 0
  if ( adjustContrast )
    m_regContrast = CRegInfo( 1, m_regContrast.Max(), m_regContrast.Default() );

  // perform mapping to our range
  int mapped;
  if ( Mapping( param, m_param, &mapped, m_regContrast ) == Fail )
    return Fail;

  m_conParam = (WORD)param;

  // calculate contrast
  DWORD value =  (DWORD)0x1FF * (DWORD)mapped;
  value /= (DWORD)m_regContrast.Max();
  if ( value > 0x1FF )
    value = 0x1FF;

  // contrast is set by a 9 bit value; set LSB first
  decRegCONTRAST_LO = value;

  // now set the Miscellaneous Control Register CON_V_MSB to the 9th bit value
  decFieldCON_MSB = decFieldODD_CON_MSB = ( (value & 0x0100) ? On : Off );

  // perform adjustment of brightness register if adjustment is needed
  if ( adjustContrast )
  {
    regContrast = (WORD)value;    // contrast value
    decRegBRIGHT = RecalcBrightness();
  }

  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetContrast( void )
// Purpose: Obtain contrast value
// Input:   None
// Output:  None
// Return:  Contrast parameter (0-255)
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetContrast( void )
{
  return m_conParam;
}


//===== Chroma Gain register (SAT_U_MSB, SAT_V_MSB, SAT_U_LO, SAT_V_LO) =====

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetSaturation( int param )
// Purpose: Set color saturation by modifying U and V values
// Input:   int param - parameter value (0-255; default 128)
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetSaturation( int param )
{
  if( m_param.OutOfRange( param ) )
    return Fail;

  // color saturation is controlled by two nine bit values:
  // ChromaU & ChromaV
  // To maintain normal color balance, the ratio between the 2 register
  // values should be kept at the power-up default ratio

  // Note that U & V values for NTSC and PAL are the same, SECAM is different

  WORD nominalNTSC_U = 0xFE;     // nominal value (i.e. 100%) for NTSC/PAL
  WORD nominalNTSC_V = 0xB4;
  WORD nominalSECAM_U = 0x87;    // nominal value (i.e. 100%) for SECAM
  WORD nominalSECAM_V = 0x85;

  CRegInfo regSat;               // selected saturation register; NTSC/PAL or SECAM
  WORD nominal_U, nominal_V;     // selected nominal U and V value; NTSC/PAL or SECAM

  WORD nominalDig = SatDefDig;  // nominal value (i.e. 100%) for digital

  if ( IsDigitalSignal() )
  {
     nominal_U = nominal_V = nominalDig;
     regSat = m_regSaturationDig;
  }
  else
  // select U & V values of either NTSC/PAL or SECAM to be used for calculation
  if ( GetVideoFormat() == VFormat_SECAM )
  {
    nominal_U = nominalSECAM_U;
    nominal_V = nominalSECAM_V;
    regSat = m_regSaturationSECAM;
  }
  else
  {
    nominal_U = nominalNTSC_U;
    nominal_V = nominalNTSC_V;
    regSat = m_regSaturationNTSC;
  }

  // perform mapping to our range
  int mapped;
  if ( Mapping( param, m_param, &mapped, regSat ) == Fail )
    return Fail;

  m_satParam = (WORD)param;

  WORD max_nominal = max( nominal_U, nominal_V );

  // calculate U and V values
  WORD Uvalue = (WORD) ( (DWORD)mapped * (DWORD)nominal_U / (DWORD)max_nominal );
  WORD Vvalue = (WORD) ( (DWORD)mapped * (DWORD)nominal_V / (DWORD)max_nominal );

  // set U
  decRegSAT_U_LO = Uvalue;

  // now set the Miscellaneous Control Register SAT_U_MSB to the 9th bit value
  decFieldSAT_U_MSB = decFieldODD_SAT_U_MSB = ( (Uvalue & 0x0100) ? On : Off );

  // set V
  decRegSAT_V_LO = Vvalue;

  // now set the Miscellaneous Control Register SAT_V_MSB to the 9th bit value
  decFieldSAT_V_MSB = decFieldODD_SAT_V_MSB = ( (Vvalue & 0x0100) ? On : Off );

  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetSaturation( void )
// Purpose: Obtain saturation value
// Input:   None
// Output:  None
// Return:  Saturation parameter (0-255)
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetSaturation( void )
{
  return m_satParam;
}


//===== Hue Control register (HUE) ==========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetHue( int param )
// Purpose: Set video hue
// Input:   int param - parameter value (0-255; default 128)
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetHue( int param )
{
  if( m_param.OutOfRange( param ) )
    return Fail;

  // perform mapping to our range
  int mapped;
  if ( Mapping( param, m_param, &mapped, m_regHue ) == Fail )
    return Fail;

  m_hueParam = (WORD)param;

  int value = (-128 * mapped) / m_regHue.Max();

  if (value > 127)
    value = 127;
  else if (value < -128)
    value = -128;

  decRegHUE = value;

  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetHue( void )
// Purpose: Obtain hue value
// Input:   None
// Output:  None
// Return:  Hue parameter (0-255)
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetHue( void )
{
  return m_hueParam;
}


//===== SC Loop Control register (E_SCLOOP, O_SCLOOP) =======================


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetChromaAGC( bool mode )
// Purpose: Enable/Disable Chroma AGC compensation
// Input:   bool mode - true = Enable, false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetChromaAGC( bool mode )
{
#ifdef GEMINI_AGC_FIX 
   if (IsGeminiFamily())
     decFieldCAGC = decFieldODD_CAGC = Off ;
   else
#endif
     decFieldCAGC = decFieldODD_CAGC = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsChromaAGC( void )
// Purpose: Check if Chroma AGC compensation is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsChromaAGC( void )
{
  return (decFieldCAGC == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetLowColorAutoRemoval( bool mode )
// Purpose: Enable/Disable low color detection and removal
// Input:   bool mode - true = Enable, false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetLowColorAutoRemoval( bool mode )
{
#ifdef GEMINI_AGC_FIX 
   if (IsGeminiFamily())
      decFieldCKILL = decFieldODD_CKILL = Off ;
   else
#endif
      decFieldCKILL = decFieldODD_CKILL = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLowColorAutoRemoval( void )
// Purpose: Check if low color detection and removal is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLowColorAutoRemoval( void )
{
  return (decFieldCKILL == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetHorizontalFilter( HorizFilter hFilter )
// Purpose: Control the configuration of the optional 6-tap Horizontal Low-Pass filter
// Input:   HoriFilter hFilter:
//            Auto Format - HFilter_AutoFormat
//            CIF         - HFilter_CIF
//            QCIF        - HFilter_QCIF
//            ICON        - HFilter_ICON
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetHorizontalFilter( HorizFilter hFilter )
{
  if ( (hFilter < HFilter_AutoFormat) ||
       (hFilter > HFilter_ICON) )
    return Fail;

#ifdef GEMINI_AGC_FIX 
   if (IsGeminiFamily())
      decFieldHFILT = decFieldODD_HFILT = 0 ;
   else
#endif
      decFieldHFILT = decFieldODD_HFILT = hFilter;

  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetHorizontalFilter( void )
// Purpose: Get the configuration of the optional 6-tap Horizontal Low-Pass filter
// Input:   None
// Output:  None
// Return:  Which filter is using:
//            Auto Format - HFilter_AutoFormat
//            CIF         - HFilter_CIF
//            QCIF        - HFilter_QCIF
//            ICON        - HFilter_ICON
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetHorizontalFilter( void )
{
  return ((int)decFieldHFILT);
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetLumaLowPassFilter( bool mode )
// Purpose: Select using normal luma low pass or luma peaking filter
// Input:   bool mode - true = peaking filter, false = normal low pass filter
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetLumaLowPassFilter( bool mode )
{
  decFieldPEAK = decFieldODD_PEAK = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLumaLowPassFilter( void )
// Purpose: Check if peaking filters is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLumaLowPassFilter( void )
{
  return (decFieldPEAK == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetPeakFilter( PeakFilter peak )
// Purpose: Select peaking filter
// Input:   PeakFilter peak:
//             PeakFilter_Min - minimum peaking
//             PeakFilter_Med - medium peaking
//             PeakFilter_Max - maximum peaking
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetPeakFilter( PeakFilter peak )
{
#ifdef GEMINI_AGC_FIX 
   if (IsGeminiFamily())
      decFieldHFILT = decFieldODD_HFILT = 0 ;
   else
#endif
      decFieldHFILT = decFieldODD_HFILT = peak;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetPeakFilter( void )
// Purpose: Return which peaking filter is selected
// Input:   None
// Output:  None
// Return:  PeakFilter peak:
//             PeakFilter_Min - minimum peaking
//             PeakFilter_Med - medium peaking
//             PeakFilter_Max - maximum peaking
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetPeakFilter( void )
{
  return ((int)decFieldHFILT);
}


//===== Output Format register (OFORM) ======================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetFullOutputRange( bool mode )
// Purpose: Enable/Disable full output range
// Input:   bool mode - true = Enable, false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetFullOutputRange( bool mode )
{
  decFieldRANGE = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsFullOutputRange( void )
// Purpose: Check if full output range is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsFullOutputRange( void )
{
  return (decFieldRANGE == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetLumaCoring( CoringLevel cLevel )
// Purpose: Set luminance level such that luminance signal is truncated to zero
//          if below this level
// Input:   CoringLevel cLevel -
//            Coring_None: no coring
//            Coring_8:    8
//            Coring_16:   16
//            Coring_32:   32
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetLumaCoring( CoringLevel cLevel )
{
  if ( ( cLevel < Coring_None) || ( cLevel > Coring_32 ) )
    return Fail;

  decFieldCORE = cLevel;
  return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetLumaCoring( void )
// Purpose: Get luminance level such that luminance signal is truncated to zero
//          if below this level
// Input:   None
// Output:  None
// Return:  Luma coring level -
//            Coring_None: no coring
//            Coring_8:    8
//            Coring_16:   16
//            Coring_32:   32
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetLumaCoring( void )
{
  return ((int)decFieldCORE);
}


//===== Vertical Scaling register (E_VSCALE_HI, O_VSCALE_HI) ================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetChromaComb( bool mode )
// Purpose: Enable/Disable chroma comb
// Input:   bool mode - true = Enable, false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetChromaComb( bool mode )
{
  decFieldCOMB = (mode == false) ? Off : On;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsChromaComb( void )
// Purpose: Check if chroma comb is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsChromaComb( void )
{
  return (decFieldCOMB == On) ? true : false;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetVScaleMode( int VSMode )
// Purpose: Select vertical scaling mode
// Input:   int VSMode - 0 = non-interlace
//                       1 = interlace
//                       2 = field aligned (Gemini family only)
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetVScaleMode( int VSMode )
{
   if ( !IsGeminiFamily() )
      decFieldINT = decFieldODD_INT = ( VSMode == 0 ) ? 0 : 1;
   else
   {
      decFieldVSFLDALIGN = decFieldODD_VSFLDALIGN = ( VSMode == 2 ) ? 1 : 0;
      decFieldINT        = decFieldODD_INT        = ( VSMode == 1 ) ? 1 : 0;
   }
}

/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetVScaleMode( void )
// Purpose: Get vertical scaling mode
// Input:   None
// Output:  None
// Return:  int VSMode - 0 = non-interlace
//                       1 = interlace
//                       2 = field aligned (Gemini family only)
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetVScaleMode( void )
{
   if ( !IsGeminiFamily() )
      return( decFieldINT );
   else
      return ( decFieldINT ? 1 : ( decFieldVSFLDALIGN << 1 ) );
}
   
//===== AGC Delay register (ADELAY) =========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetAGCDelay( BYTE value )
// Purpose: Set AGC Delay register
// Input:   Value to be set to
// Output:  None
// Return:  None
// NOTE:    This function set the AGC Delay register to the specified value.
//          No calculation is involved.
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetAGCDelay( BYTE value )
{
  decRegADELAY = value;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetAGCDelay( void )
// Purpose: Get AGC Delay register
// Input:   None
// Output:  None
// Return:  Register value
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetAGCDelay( void )
{
  return ((int)decRegADELAY);
}


//===== Burst Delay register (BDELAY) =========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetBurstDelay( BYTE value )
// Purpose: Set Burst Delay register
// Input:   Value to be set to
// Output:  None
// Return:  None
// NOTE:    This function set the Burst Delay register to the specified value.
//          No calculation is involved.
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetBurstDelay( BYTE value )
{
  decRegBDELAY = value;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetBurstDelay( void )
// Purpose: Get Burst Delay register
// Input:   None
// Output:  None
// Return:  Register value
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetBurstDelay( void )
{
  return ((int)decRegBDELAY);
}


//===== ADC Interface register (ADC) =========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetAnalogThresholdLow( bool mode )
// Purpose: Define high/low threshold level below which SYNC signal can be detected
// Input:   bool mode - true = low threshold (~75mV), false = high threshold (~125mV)
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetAnalogThresholdLow( bool mode )
{
  decFieldSYNC_T = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsAnalogThresholdLow( void )
// Purpose: Check if high or low threshold level below which SYNC signal can be detected
// Input:   None
// Output:  None
// Return:  true = low threshold (~75mV), false = high threshold (~125mV)
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsAnalogThresholdLow( void )
{
  return (decFieldSYNC_T == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetAGCFunction( bool mode )
// Purpose: Enable/Disable AGC function
// Input:   bool mode - true = Enable, false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetAGCFunction( bool mode )
{
  decFieldAGC_EN = (mode == false) ? On : Off; // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsAGCFunction( void )
// Purpose: Check if AGC function is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable, false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsAGCFunction( void )
{
  return (decFieldAGC_EN == Off) ? true : false;   // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::PowerDown( bool mode )
// Purpose: Select normal or shut down clock operation
// Input:   bool mode - true = shut down, false = normal operation
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::PowerDown( bool mode )
{
  decFieldCLK_SLEEP = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsPowerDown( void )
// Purpose: Check if clock operation has been shut down
// Input:   None
// Output:  None
// Return:  true = shut down, false = normal operation
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsPowerDown( void )
{
  return (decFieldCLK_SLEEP == On) ? true : false;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetLumaADC( bool mode )
// Purpose: Select normal or sleep Y ADC operation
// Input:   bool mode - true = normal, false = sleep
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetLumaADC( bool mode )
{
  decFieldY_SLEEP = (mode == false) ? On : Off; // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsLumaADC( void )
// Purpose: Check if Y ADC operation is in normal operation or sleeping
// Input:   None
// Output:  None
// Return:  true = normal, false = sleep
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsLumaADC( void )
{
  return (decFieldY_SLEEP == Off) ? true : false;  // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetChromaADC( bool mode )
// Purpose: Select normal or sleep C ADC operation
// Input:   bool mode - true = normal, false = sleep
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetChromaADC( bool mode )
{
  decFieldC_SLEEP = (mode == false) ? On : Off; // reverse
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsChromaADC( void )
// Purpose: Check if C ADC operation is in normal operation or sleeping
// Input:   None
// Output:  None
// Return:  true = normal, false = sleep
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsChromaADC( void )
{
  return (decFieldC_SLEEP == Off) ? true : false; // reverse
}


/*^^////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetAdaptiveAGC( bool mode )
// Purpose: Set adaptive or non-adaptive AGC operation
// Input:   bool mode - true = Adaptive, false = Non-adaptive
// Output:  None
// Return:  None
*////////////////////////////////////////////////////////////////////////////
void Decoder::SetAdaptiveAGC( bool mode )
{
   decFieldCRUSH = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsAdaptiveAGC( void )
// Purpose: Check if adaptive or non-adaptive AGC operation is selected
// Input:   None
// Output:  None
// Return:  true = Adaptive, false = Non-adaptive
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsAdaptiveAGC( void )
{
  return (decFieldCRUSH == On) ? true : false;
}


//===== White Crush Down Count (WC_DN) ======================================

/////////////////////////////////////////////////////////////////////////////
// Method:  Decoder::SetVerticalDetect( bool mode )
// Purpose: Select additional video detect algorithm
// Input:   bool mode - true = ???, false = ???
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetVerticalDetect( bool mode )
{
   decFieldVertEn = (mode == false) ? Off : On;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::GetVerticalDetect( void )
// Purpose: Check which video detect algorithm is used
// Input:   None
// Output:  None
// Return:  true = ???, false = ???
/////////////////////////////////////////////////////////////////////////////
bool Decoder::GetVerticalDetect( void )
{
  return (decFieldVertEn == On) ? true : false;
}


//===== Software Reset register (SRESET) ====================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SoftwareReset( void )
// Purpose: Perform software reset; all registers set to default values
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SoftwareReset( void )
{
  decRegSRESET = 0x00;  // write any value will do
}


//===== Test Control register (TEST) ========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::AdjustInertialDampener( bool mode )
// Purpose: for factory diagnostics only
// Input:   true or false
// Output:  None
// Return:  None
// NOTE:    For factory diagnostics only!!!!!!!
//          John Welch's dirty little secret
/////////////////////////////////////////////////////////////////////////////
void Decoder::AdjustInertialDampener( bool mode )
{
#pragma message ("FOR TEST DIAGNOSTICS ONLY!  ")
  decRegTEST = (mode == false) ? 0x00 : 0x01;
}


//===== Video Signal Interface Format (VSIF) ================================

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetVideoSignalFormat( VideoSignalFormat vsf )
// Purpose: Set video signal format
// Input:   Video signal formats:
//            Signal_Analog         - Analog
//            Signal_CCIR656        - CCIR 656
//            Signal_ByteStream     - ByteStream
//            Signal_ExtHSYNC_VSYNC - External HSYNC, VSYNC
//            Signal_ExtHSYNC_FIELD - External HSYNC, FIELD
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetVideoSignalFormat( SignalFormat format )
{
   if ( ( format <  Signal_Analog )         ||
        ( format >  Signal_ExtHSYNC_FIELD ) ||
        ( format == Signal_Reserved3 ) )
      return Fail;

   switch (format)
   {
      case Signal_CCIR656:
      case Signal_ByteStream:
      case Signal_ExtHSYNC_VSYNC:
      case Signal_ExtHSYNC_FIELD:
         m_regContrast = CRegInfo( ConMinDig, ConMaxDig, ConDefDig );

         // GPX_EN has been deleted in Gemini family
         if ( !IsGeminiFamily() )
            RemapGPDATA( true );
         break;

      case Signal_Analog:
         m_regContrast = CRegInfo( ConMin, ConMax, ConDef );

         // GPX_EN has been deleted in Gemini family
         if ( !IsGeminiFamily() )
            RemapGPDATA( true );
         break;

      default:
         return Fail;
   }

   decFieldVSFMT = format;
   SetContrast( m_conParam );
   SetSaturation( m_satParam );
   Scaler::SignalFormatChanged( format );
   return Success;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetVideoSignalFormat( void )
// Purpose: Obtain video signal format
// Input:   None
// Output:  None
// Return:  Video signal format:
//            Signal_Analog         - Analog
//            Signal_CCIR656        - CCIR 656
//            Signal_ByteStream     - ByteStream
//            Signal_ExtHSYNC_VSYNC - External HSYNC, VSYNC
//            Signal_ExtHSYNC_FIELD - External HSYNC, FIELD
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetVideoSignalFormat( void )
{
   return decFieldVSFMT;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetSyncVideoRef( SyncVideoRef ref )
// Purpose: Set sync video reference
// Input:   Sync video reference:
//            VRef_alignedCb - HS/VS aligned with Cb
//            VRef_alignedY0 - HS/VS aligned with Y0
//            VRef_alignedCr - HS/VS aligned with Cr
//            VRef_alignedY1 - HS/VS aligned with Y1
// Output:  None
// Return:  Fail if error in parameter, else Success
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetSyncVideoRef( SyncVideoRef ref )
{
   if ( ( ref < VRef_alignedCb ) ||
        ( ref > VRef_alignedY1 ) )
      return Fail;

   decFieldSVREF = ref;
   return Success;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetSyncVideoRef( void )
// Purpose: Obtain sync video reference
// Input:   None
// Output:  None
// Return:  Sync video reference:
//            VRef_alignedCb - HS/VS aligned with Cb
//            VRef_alignedY0 - HS/VS aligned with Y0
//            VRef_alignedCr - HS/VS aligned with Cr
//            VRef_alignedY1 - HS/VS aligned with Y1
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetSyncVideoRef( void )
{
   return decFieldVSFMT;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::EnableSyncOutput( bool mode )
// Purpose: Enable/Disable syncs output for synchronizing video input
// Input:   bool mode - true = Enable; false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::EnableSyncOutput( bool mode )
{
  decFieldVSIF_ESO = (mode == false) ? 0 : 1;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsSyncOutputEnabled( void )
// Purpose: Check if syncs output for synchronizing video input is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable; false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsSyncOutputEnabled( void )
{
  return (decFieldVSIF_ESO == On) ? true : false;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::EnableChromaFilterBypass( bool mode )
// Purpose: Enable/Disable bypass of chroma filters
// Input:   bool mode - true = Enable; false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::EnableChromaFilterBypass( bool mode )
{
  decFieldVSIF_BCF = (mode == false) ? 0 : 1;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsChromaFilterBypassEnabled( void )
// Purpose: Check if bypass of chroma filters is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable; false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsChromaFilterBypassEnabled( void )
{
  return (decFieldVSIF_BCF == On) ? true : false;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::RemapGPDATA( bool mode )
// Purpose: Enable/Disable remapping of GPDATA[5:0] inputs from GPIO[5:0] to GPx[5:0]
// Input:   bool mode - true = Enable; false = Disable
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::RemapGPDATA( bool mode )
{
  decFieldGPX_EN = (mode == false) ? 0 : 1;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsGPDATARemapped( void )
// Purpose: Check if remapping of GPDATA[5:0] inputs from GPIO[5:0] to GPx[5:0]
//          is enable or disable
// Input:   None
// Output:  None
// Return:  true = Enable; false = Disable
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsGPDATARemapped( void )
{
  return (decFieldGPX_EN == On) ? true : false;
}

//===== Video Timing Control (VTC) ==========================================

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SetHReset( int clk )
// Purpose: Set HRESET length (HSFMT)
// Input:   int clk - 64, 48, 32 or 16 pixels (default is 64)
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Decoder::SetHReset( int clk )
{
   WORD revID = (WORD)PsDevice::GetPsDevice()->getPciCfgHdr()->RevisionID;

   if ( IsGeminiFamily() && ( revID >= 0x02 ) )  // Gemini and at least Rev D
   {
      switch ( clk )
      {
         case 48: decFieldHSFMT2 = decFieldODD_HSFMT2 = 1; break;
         case 32: decFieldHSFMT2 = decFieldODD_HSFMT2 = 2; break;
         case 16: decFieldHSFMT2 = decFieldODD_HSFMT2 = 3; break;
         default: decFieldHSFMT2 = decFieldODD_HSFMT2 = 0; break;
      }
   }
   else
      decFieldHSFMT = decFieldODD_HSFMT = ( clk == 32 );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetHReset( void )
// Purpose: Get HRESET length (HSFMT)
// Input:   None
// Output:  None
// Return:  HRESET length - 64, 48, 32 or 16 pixels 
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetHReset( void )
{
   WORD revID = (WORD)PsDevice::GetPsDevice()->getPciCfgHdr()->RevisionID;

   if ( IsGeminiFamily() && ( revID >= 0x02 ) )  // Gemini and at least Rev D
     return ( ( decFieldHSFMT2 == 1 ) ? 48 :
              ( decFieldHSFMT2 == 2 ) ? 32 :
              ( decFieldHSFMT2 == 3 ) ? 16 : 64 );
   else
     return ( ( decFieldHSFMT == 0 ) ? 64 : 32 );
}



//===== Expected # of horizontal lines per frame (VTOTAL) - new for Gemini ==

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::SetLineCount( int lines )
// Purpose: Set expected number of horizontal video lines per frame
// Input:   None
// Output:  None
// Return:  Success, Fail or Err_WrongHardware
/////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::SetLineCount( int lines )
{
   if ( !IsGeminiFamily() )
      return ( Err_WrongHardware );

   if ( ( lines < 0 ) || ( lines > 0x3FF ) )    // max 10 bits
      return ( Fail );

   decRegVTOTAL = lines;
   return ( Success );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  int Decoder::GetLineCount( void )
// Purpose: Get expected number of horizontal video lines per frame
// Input:   None
// Output:  None
// Return:  Expected number of horizontal video lines per frame
/////////////////////////////////////////////////////////////////////////////
int Decoder::GetLineCount( void )
{
   return ( decRegVTOTAL );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Decoder::SelectCrystal( char useCrystal )
// Purpose: Select correct crystal for NTSC or PAL
// Input:   char useCrystal - 'N' for NTSC; 'P' for PAL
// Output:  None
// Return:  None
// NOTE:    Assume at most 2 crystals installed in hardware. i.e. 1 for NTSC
//          and the other for PAL/SECAM.
//          If there is only 1 crystal exists (which must be crystal XT0),
//          do nothing since it is already selected.
/////////////////////////////////////////////////////////////////////////////
void Decoder::SelectCrystal( char useCrystal )
{
   // locate crystal information in the registry
   // the keys to look for in registry are under product's id;
   // i.e. Bt848, Bt848A, etc.
   //    1. NumXTAL - number of crystal installed
   //                 possible values are "1" or "2"
   //    2. XT0     - what crystal type is for crystal 0
   //                 possible values are "NTSC", "PAL"
   // There is another key exist which may be useful in the future:
   //    XT1        - what crystal type is for crystal 1
   //                 possible values are "NTSC", "PAL", and "NONE"

   VRegistryKey vkey( PRK_LOCAL_MACHINE, "SOFTWARE\\Brooktree\\Video" );
   //VRegistryKey vkey( PRK_CLASSES_ROOT, "Bt848" );

   // make sure the key exists
   if ( vkey.lastError() == ERROR_SUCCESS )
   {
      char * numCrystalKey = "NumXTAL";
      char   nCrystal[5];
      DWORD  nCrystalLen = 2;    // need only first char; '1' or '2'

      // get number of crystal exists
      if ( vkey.getSubkeyValue( numCrystalKey, nCrystal, (DWORD *)&nCrystalLen ) )
      {
         // if there is only 1 crystal, no other crystal to change to
         if ( nCrystal[0] == '2' )
         {
            char * crystalTypeKey = "XT0";    // crystal 0 type
            char   crystalType[10];
            DWORD  crystalTypeLen = 6;    // need only first char: 'N' or 'P'

            // get the crystal 0 information
            if ( vkey.getSubkeyValue( crystalTypeKey, crystalType, (DWORD *)&crystalTypeLen ) )
               // compare with what we want to use
               if ( (  IsCrystal0Selected() && ( crystalType[0] != useCrystal ) ) ||
                    ( !IsCrystal0Selected() && ( crystalType[0] == useCrystal ) ) )
                  // need to change crystal
                  SetCrystal( IsCrystal0Selected() ? Crystal_XT1 : Crystal_XT0 );
         }
      }
   }
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Decoder::Mapping( int fromValue, CRegInfo fromRange,
//                                           int * toValue, CRegInfo toRange )
// Purpose: Map a value in certain range to a value in another range
// Input:   int fromValue - value to be mapped from
//          CRegInfo fromRange - range of value mapping from
//          CRegInfo toRange   - range of value mapping to
// Output:  int * toValue - mapped value
// Return:  Fail if error in parameter, else Success
// Comment: No range checking is performed here. Assume parameters are in
//          valid ranges.
//          The mapping function does not assume default is always the mid
//          point of the whole range. It only assumes default values of the
//          two ranges correspond to each other.
//
//          The mapping formula is:
//
//            For fromRange.Min() <= fromValue <= fromRange.Default():
//
//               fromValue (fromRange.Default() - fromRange.Min())
//               ------------------------------------------------ + fromRange.Min()
//                     toRange.Default() - toRange.Min()
//
//            For fromRange.Default() < fromValue <= fromRange.Max():
//
//               (fromValue - fromRange.Default()) (toRange.Max() - toRange.Default())
//               --------------------------------------------------------------------- + toRange.Default()
//                           toRange.Max() - toRange.Default()
//
////////////////////////////////////////////////////////////////////////////
ErrorCode Decoder::Mapping( int fromValue, CRegInfo fromRange,
                                 int * toValue, CRegInfo toRange )
{
   // calculate intermediate values
   DWORD a = toRange.Default() - toRange.Min();
   DWORD b = fromRange.Default() - fromRange.Min();
   DWORD c = toRange.Max() - toRange.Default();
   DWORD d = fromRange.Max() - fromRange.Default();

   // prevent divide by zero
   if ( ( b == 0 ) || ( d == 0 ) )
      return ( Fail );

   // perform mapping
   if ( fromValue <= fromRange.Default() )
      *toValue = (int) (DWORD)fromValue * a / b + (DWORD)toRange.Min();
   else
      *toValue = (int) ( (DWORD)fromValue - (DWORD)fromRange.Default() ) * c / d
                       + (DWORD)toRange.Default();

   return ( Success );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsAdjustContrast( void )
// Purpose: Check registry key whether adjust contrast is needed
// Input:   None
// Output:  None
// Return:  true = adjust contrast, false = don't adjust contrast
// Note:    If adjust contrast is turn on, brightness register value will be
//          adjusted such that it remains a constant after the calculation
//          performed by the hardware.
//
//          The formula is:
//             To keep brightness constant (i.e. not affect by changing contrast)
//             set brightness to B/(C/C0)
//             where B is value of brightness before adjustment
//                   C is contrast value
//                   C0 is nominal contrast value (0xD8)
//
//             To adjust the contrast level such that it is at the middle of
//             black and white: set brightness to (B * C0 + 64 * (C0 - C))/C
//             (this is what Intel wants)
//
//             Currently there is still limitation of how much adjustment
//             can be performed. For example, if brightness is already high,
//             (i.e. brightness reg value close to 0x7F), lowering contrast
//             until a certain level will have no adjustment effect on brightness.
//             In fact, it would even bring down brightness to darkness.
//
//             Example 1: if brightness is at nominal value (0x00), contrast can
//                        only go down to 0x47 (brightness adjustment is already
//                        at max of 0x7F) before it starts affecting brightness
//                        which takes it darkness.
//             Example 2: if brightness is at nominal value (0x00), contrast can
//                        go all the way up with brightness adjusted correctly.
//                        However, the max adjustment used is only 0xDC and
//                        the max adjustment we can use is 0x&F.
//             Example 3: if brightness is at max (0x7F), lowering contrast
//                        cannot be compensated by adjusting brightness anymore.
//                        The result is gradually taking brightness to darkness.
//             Example 4: if brightness is at min (0x80), lowering contrast has
//                        no visual effect. Bringing contrast to max is using
//                        0xA5 in brightness for compensation.
//
//             One last note, the center is defined as the middle of the
//             gamma adjusted luminance level. Changing it to use the middle of
//             the linear (RGB) luminance level is possible.
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsAdjustContrast( void )
{
   // locate adjust contrast information in the registry
   // the key to look for in registry is:
   //    Bt848\AdjustContrast - 0 = don't adjust contrast
   //                           1 = adjust contrast

   VRegistryKey vkey( PRK_LOCAL_MACHINE, "SOFTWARE\\Brooktree\\Video" );
   //VRegistryKey vkey( PRK_CLASSES_ROOT, "Bt848" );

   // make sure the key exists
   if ( vkey.lastError() == ERROR_SUCCESS )
   {
      char * adjustContrastKey = "AltContrast";
      char   key[3];
      DWORD  keyLen = 2;    // need only first char; '0' or '1'

      // get the registry value and check it, if exist
      if ( ( vkey.getSubkeyValue( adjustContrastKey, key, (DWORD *)&keyLen ) ) &&
           ( key[0] == '1' ) )
         return ( true );
   }
   return ( false );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool Decoder::IsDigitalSignal( void )
// Purpose: Check if digital video signal is selected
// Input:   None
// Output:  None
// Return:  true = digital; false = analog
/////////////////////////////////////////////////////////////////////////////
bool Decoder::IsDigitalSignal( void )
{
  return ( GetVideoSignalFormat() == Signal_Analog ) ? false : true;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  BYTE Decoder::RecalcBrightness( void )
// Purpose: Recalculate brightness register value to perform contrast adjustment
// Input:   None
// Output:  None
// Return:  Brightness value after contrast adjustment
/////////////////////////////////////////////////////////////////////////////
BYTE Decoder::RecalcBrightness( void )
{
   // regBright: brightness reg value before adjustment
   // regContrast: contrast reg value before adjustment

   BYTE defContrast = IsDigitalSignal() ? (BYTE)0x80 : (BYTE)0xD8;
   long A = (long)regBright * (long)defContrast;
   long B = 64 * ( (long)defContrast - (long)regContrast );
   long temp = 0x00;
   if ( regContrast != 0 )  // already limit contrast > zero; just in case here
      temp = ( ( A + B ) / (long)regContrast );
   temp = min( max( temp, -128 ), 127 );
   return (BYTE)temp;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  bool IsGeminiFamily( void )
// Purpose: Check if Gemini family hardware is installed in the system
// Input:   None
// Output:  None
// Return:  True if Bt878, Bt879, or Bt880 is found
/////////////////////////////////////////////////////////////////////////////
bool IsGeminiFamily( void )
{
   WORD devID = PsDevice::GetPsDevice()->getPciCfgHdr()->DeviceID;
   if ( ( devID >= 878 ) || ( devID <= 880 ) )
      return ( true );
   return ( false );
}

