// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/INTERFAC.CPP 2.18 1998/05/21 18:56:22 rudyl Exp $
// $Log: INTERFAC.CPP $
// Revision 2.18  1998/05/21 18:56:22  rudyl
// Graft from 2.17.1.2.
// Revision 2.17.1.2  1998/05/21 18:55:36  rudyl
// Added Nicam support. Works with Philips TDA9874H only. ITT is next.
// Revision 2.17.1.1  1998/05/15 11:59:32  rudyl
// Duplicate revision
// Revision 2.16.2.2  1998/05/15 21:23:17  rudyl
// Added Nicam stuffs.
// Revision 2.16  1998/04/18 08:13:00  trang
// Modified to compile under Microsoft VC.
// Revision 2.15  1998/02/21 01:36:23  dtharp
// Modified for grappler dynamic link to BtVid_32.dll.
// Revision 2.14  1997/12/03 21:48:56  peter
// Fixed regutil 16/32-bit incompatibility.
// Revision 2.13  1997/10/17 23:59:37  rudyl
// Gemini: Use CMD_MUTE & CMD_UNMUTE to mute and unmute.
// Revision 2.12  1997/10/08 00:58:11  rudyl
// Added Alps TSCH5 tuner support.
// Use "TunerType" registry key to support both Alps (default) and Philips tuners.
// Revision 2.11  1997/10/02 01:19:18  rudyl
// Bt878: don't unmute for composite & SVideo. when unmute is selected.
// Revision 2.10  1997/09/15 22:19:38  rudyl
// 878 DLL renamed to BtAud.
// Revision 2.9  1997/08/28 19:37:44  rudyl
// Added checking of tuner instance.
// Revision 2.8  1997/08/14 20:10:03  rudyl
// Graft from 2.5.1.3 which has the changes up to 2.7 and added Gemini support.
// Revision 2.5.1.3  1997/07/30 01:16:04  rudyl
// Use IsBt878Family() from Bt848_32.dll.
// Revision 2.5.1.2  1997/07/18 00:39:58  rudyl
// Added defines _BUILD_TVCTLDLL & _BUILD_RADIOCTLDLL.
// Revision 2.5.1.1  1997/07/16 01:31:11  rudyl
// Duplicate revision
// Revision 2.4  1997/07/10 21:16:24  rudyl
// Gemini: Added Set/GetAudioHandle() to let app passes audio handle to here.
// Revision 2.3  1997/07/03 22:11:36  rudyl
// Added support for gemini.
// 2 new exported APIs: SetRadioParam and GetRadioParam.
// Revision 2.2  1996/06/14 21:03:07  rudyl
// Fixed problem with not unable to change channel above 13 for cable.
// Since cable and antenna both connect to same connector, needs to remember which tuner source to tune to when change channel.
// Revision 2.1  1996/06/10 20:12:32  ssm
// MarkBeta1AsRev2
// Revision 1.13  1996/05/30 19:05:26  rudyl
// 0.54 - Due to removal of vxd related calls from Bt848api.h to vxdcall.h, added include "vxdcall.h" here.
// Revision 1.12  1996/05/22 18:28:42  rudyl
// Added call to VxD when channel is about to change.
// Revision 1.11  1996/05/22 00:45:21  rudyl
// Moved VxD calls from here to Bt848_32.dll in order to hide the calls.
// Revision 1.10  1996/05/10 23:15:47  rudyl
// Implement TV_ERR_... return values from Intel. Also added exported function GetTVErrString() to retrieve our specific error msg.
// Revision 1.9  1996/05/06 18:49:05  rudyl
// No changes; just added more comments into codes.
// Revision 1.8  1996/04/28 01:20:12  rudyl
// ver 0.50 - does not instantiate I2C and GPIO objects here. Just make API
// calls to BT848_32.DLL. Also returns error types to caller instead of just TRUE/FALSE result.
// Revision 1.7  1996/04/23 22:10:53  rudyl
// Removed codes inside SetAudio() and GetAudio() from GPIO to SetAudioSource() and GetAudioSource() here.
// Revision 1.6  1996/04/18 01:20:29  rudyl
// set audio to TV tuner when DLL starts and to mute when DLL ends
// Revision 1.5  1996/04/17 20:26:04  rudyl
// fixed no audio problem. Need to set GPOE to 0x0F (instead of 0x03). Don't know why.
// No changes in source here. Only in gpio.cpp.
// Revision 1.4  1996/04/16 22:00:00  rudyl
// Removed mapping function from here. Moved to decoder class.
// Revision 1.3  1996/04/16 18:18:33  rudyl
// Added range mapping from 0-255 to our own ranges for Brightness, Contrast, Saturation and Hue.
// Revision 1.2  1996/04/12 21:01:29  rudyl
// Renamed DLL from 848Tuner.dll to Grappler.dll.
// Added SetSaturation() and GetSaturation().
// Revision 1.1  1996/04/12 18:24:43  rudyl
// Initial revision

// CUT_HERE

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation
//
//  Module:
//
//    Interfac.cpp
//
//  Abstract:
//
//    Contains all interface functions to the Grappler DLL
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>

#define _BUILD_TVCTLDLL       // all __TVCTLFUNC    functions are exported
#define _BUILD_RADIOCTLDLL    // all __RADIOCTLFUNC functions are exported

#include "regutil.h"
#include "tvctl.h"
#include "radioctl.h"
#include "tverr.h"
#include "tuner.h"
#include "audio.h"
#include "bt848api.h"
#include "bt848fcn.h"
#include "bt878api.h"

#include "..\include\regutil.cpp"

#include "dynLink.h"

/////////////////////////////////////////////////////////////////////////////
// Parameter constants for brightness, contrast, saturation and hue
/////////////////////////////////////////////////////////////////////////////
const int paramMin = 0;       // min value of parameter
const int paramMax = 255;     // max value of parameter
const int paramDef = 128;     // def value of parameter


/////////////////////////////////////////////////////////////////////////////
// Following are the available TV control functions
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioMute   ( ULONG );
LONG GetAudioMute   ( void );
LONG SetVideoSource ( ULONG );
LONG GetVideoSource ( void );
LONG SetChannel     ( ULONG );
LONG GetChannel     ( void );
LONG SetBrightness  ( ULONG );
LONG GetBrightness  ( void );
LONG SetContrast    ( ULONG );
LONG GetContrast    ( void );
LONG SetHue         ( ULONG );
LONG GetHue         ( void );
LONG SetSaturation  ( ULONG );
LONG GetSaturation  ( void );
// --- TCZ Digital Audio APIs
LONG SetTvDaFlavor( ULONG );
LONG GetTvDaFlavor( void );
LONG SetTvDaStatus( ULONG );
LONG GetTvDaStatus( void );
LONG SetCountry( ULONG );
LONG GetCountry( void );
LONG GetTvChannelId( void );
// --- TCZ <end>


/////////////////////////////////////////////////////////////////////////////
// Following are the available Radio control functions
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioHandle     ( ULONG );   // for both tv and radio
LONG GetAudioHandle     ( void );    // for both tv and radio
LONG SetRadioFreq       ( ULONG );
LONG GetRadioFreq       ( void );
LONG GetSignalStrength  ( void );
// --- TCZ Digital Audio APIs
LONG SetRadioDaFlavor( ULONG );
LONG GetRadioDaFlavor( void );
LONG SetRadioDaStatus( ULONG );
LONG GetRadioDaStatus( void );
//LONG SetCountry( ULONG );
//LONG GetCountry( void );
// --- TCZ <end>


/////////////////////////////////////////////////////////////////////////////
// Pointer to function Types
/////////////////////////////////////////////////////////////////////////////
typedef LONG (* tvSetFunc)( ULONG );
typedef LONG (* tvGetFunc)( void );
typedef LONG (* radioSetFunc)( ULONG );
typedef LONG (* radioGetFunc)( void );


/////////////////////////////////////////////////////////////////////////////
// Create an array of ptrs to functions for the TV control functions
// Entries in these tables must be in the same order defined for TV Parameter in TVCtl.h
/////////////////////////////////////////////////////////////////////////////
tvSetFunc SetTVFunc[] = { NULL,              // 0x00
                          SetVideoSource,    // TV_PARM_SOURCE
                          SetChannel,        // TV_PARM_CHANNEL
                          SetBrightness,     // TV_PARM_BRIGHTNESS
                          SetContrast,       // TV_PARM_CONTRAST
                          SetHue,            // TV_PARM_HUE
                          SetSaturation,     // TV_PARM_SATURATION
                          NULL, NULL, NULL,  // 0x07 - 0x09
                          NULL, NULL, NULL,  // 0x0A - 0x0C
                          NULL, NULL,        // 0x0D - 0x0E
                          SetAudioHandle,    // TV_PARM_AUDIO_HANDLE
                          SetAudioMute,      // TV_PARM_MUTE
// --- TCZ
                          SetTvDaFlavor,     // TV_PARM_DAFLAVOR
                          SetTvDaStatus,     // TV_PARM_STATUS
                          SetCountry,        // TV_PARM_COUNTRY
                          NULL };            // TV_PARM_CHANNELID
// --- TCZ <end>


tvGetFunc GetTVFunc[] = { NULL,              // 0x00
                          GetVideoSource,    // TV_PARM_SOURCE
                          GetChannel,        // TV_PARM_CHANNEL
                          GetBrightness,     // TV_PARM_BRIGHTNESS
                          GetContrast,       // TV_PARM_CONTRAST
                          GetHue,            // TV_PARM_HUE
                          GetSaturation,     // TV_PARM_SATURATION
                          NULL, NULL, NULL,  // 0x07 - 0x09
                          NULL, NULL, NULL,  // 0x0A - 0x0C
                          NULL, NULL,        // 0x0D - 0x0E
                          GetAudioHandle,    // TV_PARM_AUDIO_HANDLE
                          GetAudioMute,      // TV_PARM_MUTE
// --- TCZ
                          GetTvDaFlavor,     // TV_PARM_DAFLAVOR
                          GetTvDaStatus,     // TV_PARM_STATUS
                          GetCountry,        // TV_PARM_COUNTRY
                          GetTvChannelId };  // TV_PARM_CHANNELID
// --- TCZ <end>


/////////////////////////////////////////////////////////////////////////////
// Create an array of ptrs to functions for the Radio control functions
// Entries in these tables must be in the same order defined for Radio Parameter in RadioCtl.h
/////////////////////////////////////////////////////////////////////////////
radioSetFunc SetRadioFunc[] = { NULL,                 // 0x00
                                SetAudioHandle,       // RADIO_PARM_DEV_HANDLE
                                SetRadioFreq,         // RADIO_PARM_FREQ
                                NULL,                 // RADIO_PARM_SIGNAL_STRENGTH
                                SetRadioDaFlavor,     // RADIO_PARM_DAFLAVOR
                                SetRadioDaStatus,     // RADIO_PARM_STATUS
                                SetCountry };         // RADIO_PARM_COUNTRY

radioGetFunc GetRadioFunc[] = { NULL,                 // 0x00
                                GetAudioHandle,       // RADIO_PARM_DEV_HANDLE
                                GetRadioFreq,         // RADIO_PARM_FREQ
                                GetSignalStrength,    // RADIO_PARM_SIGNAL_STRENGTH
                                GetRadioDaFlavor,     // RADIO_PARM_DAFLAVOR
                                GetRadioDaStatus,     // RADIO_PARM_STATUS
                                GetCountry };         // RADIO_PARM_COUNTRY

/////////////////////////////////////////////////////////////////////////////
// Local Function Prototypes
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioSource ( ULONG );
LONG GetAudioSource ( void );


/////////////////////////////////////////////////////////////////////////////
// Local variables to the DLL
/////////////////////////////////////////////////////////////////////////////
HINSTANCE    hInst;                          // Handle to instance
HINSTANCE    hAudDll           = NULL;       // handle to BtAud.dll
HINSTANCE    hinstBt32Dll      = NULL;       // handle to Btvid_32.dll

const  BYTE  TemicI2CAddress   = 0xC2;       // I2C address for Temic tuner
const  BYTE  PhilipsI2CAddress = 0xC0;       // I2C address for Philips FM1236 tuner
const  BYTE  AlpsI2CAddress    = 0xC0;       // I2C address for Alps TSCH5 tuner

static TunerWithFMRadio *theTuner;

int          audioSource;                    // audio source
int          videoSource;                    // video source
BOOL         audioMute = FALSE;              // audio mute state
static BOOL  Bt878HWFound;                   // 878 hardware found?
static DWORD dwHandle;                       // device handle to audio dll (BtAud.dll)

ProcessCommand_t  DllProcessCommand = NULL;  // API in BtAud.dll


//===========================================================================
// The only functions interfacing with the application level:
//    1) LONG SetTVParam( ULONG Parameter, ULONG Value )
//    2) LONG GetTVParam( ULONG Parameter )
//    3) LONG SetRadioParam( DWORD dwHandle, ULONG Parameter, ULONG Value )
//    4) LONG GetRadioParam( DWORD dwHandle, ULONG Parameter )
//===========================================================================

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetTVParam( ULONG Parameter, ULONG Value )
// Purpose: Exported function allows other application to set parameter
// Input:   ULONG Parameter - parameter to be set
//          ULONG Value     - value to be set to
// Output:  None
// Return:  Returned value of function called, or TV_ERR_UNSUPPORTED_PARAM
/////////////////////////////////////////////////////////////////////////////
LONG __TVCTLFUNC SetTVParam( ULONG Parameter, ULONG Value )
{
   if ( Parameter >= sizeof( SetTVFunc ) / sizeof( *SetTVFunc ) )
      return ( TV_ERR_UNSUPPORTED_PARAM );

   if ( SetTVFunc[ Parameter ] == NULL )
      return ( TV_ERR_UNSUPPORTED_PARAM );

   return (* SetTVFunc[ Parameter ])( Value );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetTVParam( ULONG Parameter )
// Purpose: Exported function allows other application to get parameter
// Input:   ULONG Parameter - parameter to get value of
// Output:  None
// Return:  Returned value of function called, or TV_ERR_UNSUPPORTED_PARAM
/////////////////////////////////////////////////////////////////////////////
LONG __TVCTLFUNC GetTVParam( ULONG Parameter )
{
   if ( Parameter >= sizeof( GetTVFunc ) / sizeof( *GetTVFunc ) )
      return ( TV_ERR_UNSUPPORTED_PARAM );

   if ( GetTVFunc[ Parameter ] == NULL )
      return ( TV_ERR_UNSUPPORTED_PARAM );

   return (* GetTVFunc[ Parameter ])();
}


/////////////////////////////////////////////////////////////////////////////
// Method:  char* __TVCTLFUNC GetTVErrString( LONG ErrCode )
// Purpose: Exported function allows other application to get our specific
//          error message
// Input:   LONG ErrCode - error code
// Output:  None
// Return:  Pointer to char string with the error message
/////////////////////////////////////////////////////////////////////////////
char* __TVCTLFUNC GetTVErrString( LONG ErrCode )
{
   static char msg[ 255 ];
   if ( LoadString( hInst, ErrCode, msg, sizeof( msg ) ) == 0 )
      return NULL;
   else
      return msg;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG __RADIOCTLFUNC SetRadioParam( ULONG Parameter, ULONG Value )
// Purpose: Exported function allows other application to set parameter
// Input:   ULONG Parameter - parameter to be set
//          ULONG Value     - value to be set to
// Output:  None
// Return:  Returned value of function called, or RADIO_ERR_UNSUPPORTED_PARAM
/////////////////////////////////////////////////////////////////////////////
LONG __RADIOCTLFUNC SetRadioParam( ULONG Parameter, ULONG Value )
{
   if ( !Bt878HWFound )
      return ( RADIO_ERR_WRONG_HW );

   if ( Parameter >= sizeof( SetRadioFunc ) / sizeof( *SetRadioFunc ) )
      return ( RADIO_ERR_UNSUPPORTED_PARAM );

   if ( SetRadioFunc[ Parameter ] == NULL )
      return ( RADIO_ERR_UNSUPPORTED_PARAM );

   return (* SetRadioFunc[ Parameter ])( Value );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG __RADIOCTLFUNC GetRadioParam( ULONG Parameter )
// Purpose: Exported function allows other application to get parameter
// Input:   ULONG Parameter - parameter to get value of
// Output:  None
// Return:  Returned value of function called, or RADIO_ERR_UNSUPPORTED_PARAM
/////////////////////////////////////////////////////////////////////////////
LONG __RADIOCTLFUNC GetRadioParam( ULONG Parameter )
{
   if ( !Bt878HWFound )
      return ( RADIO_ERR_WRONG_HW );

   if ( Parameter >= sizeof( GetRadioFunc ) / sizeof( *GetRadioFunc ) )
      return ( RADIO_ERR_UNSUPPORTED_PARAM );

   if ( GetRadioFunc[ Parameter ] == NULL )
      return ( RADIO_ERR_UNSUPPORTED_PARAM );

   return (* GetRadioFunc[ Parameter ])();
}


//===========================================================================
// Following are the functions to perform the Set...() and Get...() operations
//===========================================================================

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetVideoSource ( ULONG source )
// Purpose: Set video source
// Input:   ULONG source - video source to set to
//                           TV_SOURCE_BASEBAND_COMPOSITE
//                           TV_SOURCE_BASEBAND_SVIDEO
//                           TV_SOURCE_BASEBAND_CAMERA
//                           TV_SOURCE_TUNER_CABLE
//                           TV_SOURCE_TUNER_ANTENNA
// Output:  None
// Return:  TV control error value
/////////////////////////////////////////////////////////////////////////////
LONG SetVideoSource ( ULONG source )
{
   // Determine which connector associate with TV source
   // Also determine which audio source to use associate with TV source
   Connector conn;
   int audio;
   switch ( source )
   {
	   case TV_SOURCE_BASEBAND_COMPOSITE:
      case TV_SOURCE_BASEBAND_CAMERA:
         conn = ConComposite;
         audio = AUDIO_SOURCE_EXTAUDIO;
         break;

	   case TV_SOURCE_BASEBAND_SVIDEO:
         conn = ConSVideo;
         audio = AUDIO_SOURCE_EXTAUDIO;
         break;

      case TV_SOURCE_TUNER_CABLE:
      case TV_SOURCE_TUNER_ANTENNA:
         conn = ConTuner;
         audio = AUDIO_SOURCE_TVTUNER;
         break;

      default:
   		return ( TV_ERR_BAD_VALUE );
   }

   // set audio source also when TV source changes
   if ( DlkBt848SetVideoSource( conn ) == Success )
   {
      // since both cable and antenna connect to tuner, need to remember
      // which video source we really want when we call GetVideoSource().
      // Similary for composite and camera.
      videoSource = source;
      audioSource = audio;
      return ( SetAudioSource( audio ) );
   }
   else
      return ( TV_ERR_DLL_ERROR );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetVideoSource ( void )
// Purpose: Get video source
// Input:   None
// Output:  None
// Return:  LONG source - video source has been set to
//                           TV_SOURCE_BASEBAND_COMPOSITE
//                           TV_SOURCE_BASEBAND_SVIDEO
//                           TV_SOURCE_BASEBAND_CAMERA
//                           TV_SOURCE_TUNER_CABLE
//                           TV_SOURCE_TUNER_ANTENNA
// Note:    Video source set to Cable or Antenna returns TV_SOURCE_TUNER_CABLE
//          here since they both connect to same source.
//          Similarily, video source set to Composite or Camera returns
//          TV_SOURCE_BASEBAND_COMPOSITE.
/////////////////////////////////////////////////////////////////////////////
LONG GetVideoSource ( void )
{
   // Could return "videoSource" here without even asking DLL. But this is
   // the right way to do it.

   Connector conn;
   if ( DlkBt848GetVideoSource( &conn ) == Fail )
      return ( TV_ERR_DLL_ERROR );

   switch ( conn )
   {
	   case ConComposite:
         if ( ( videoSource == TV_SOURCE_BASEBAND_COMPOSITE ) ||
              ( videoSource == TV_SOURCE_BASEBAND_CAMERA ) )
            return ( videoSource );

	   case ConSVideo:
         return ( TV_SOURCE_BASEBAND_SVIDEO );

      case ConTuner:
         if ( ( videoSource == TV_SOURCE_TUNER_CABLE ) ||
              ( videoSource == TV_SOURCE_TUNER_ANTENNA ) )
            return ( videoSource );
   }

   return ( TV_ERR_DLL_ERROR );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetChannel( ULONG channel )
// Purpose: Set channel
// Input:   ULONG channel - channel to set to
// Output:  None
// Return:  TV control error value
/////////////////////////////////////////////////////////////////////////////
LONG SetChannel( ULONG channel )
{
   LONG source = GetVideoSource();

   // only cable and antenna can change channel
   if ( ( source != TV_SOURCE_TUNER_CABLE ) &&
        ( source != TV_SOURCE_TUNER_ANTENNA ) )
      return ( TV_ERR_SOURCE_CANNOT_TUNE );
   else
      return ( theTuner->SetChannel( channel,
                                    ( source == TV_SOURCE_TUNER_ANTENNA ) ? modeTV : modeCable ) );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetChannel( void )
// Purpose: Get channel
// Input:   None
// Output:  None
// Return:  Channel number
/////////////////////////////////////////////////////////////////////////////
LONG GetChannel( void )
{
   LONG source = GetVideoSource();

   // only cable and antenna have channel number
   if ( ( source != TV_SOURCE_TUNER_CABLE ) &&
        ( source != TV_SOURCE_TUNER_ANTENNA ) )
      return ( TV_ERR_SOURCE_CANNOT_TUNE );
   else
      return ( (LONG)theTuner->GetChannel() );
}

// --- TCZ Get channel ID string
static char cChanId[ 256 ]; // static so we can return it (yuk)
LONG GetTvChannelId( void )
{
   LONG source = GetVideoSource();

   // only cable and antenna have channel number
   if ( ( source != TV_SOURCE_TUNER_CABLE ) &&
        ( source != TV_SOURCE_TUNER_ANTENNA ) )
      return ( TV_ERR_SOURCE_CANNOT_TUNE );
   else
   {
       // TODO: get this from the actual table
      int iChannel = theTuner->GetChannel();
      sprintf( cChanId, "%d", iChannel );
   }
   return (LONG)cChanId;
}
// --- TCZ <end>

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetBrightness( ULONG brightness )
// Purpose: Set brightness
// Input:   ULONG brightness - brightness to set to
// Output:  None
// Return:  TV_ERR_SUCCESS if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG SetBrightness( ULONG brightness )
{
   // range checking
   if ( brightness > paramMax )
      return ( TV_ERR_BAD_VALUE );

   // request Bt848 DLL for action
   return ( DlkBt848SetBrightness( brightness ) == Success ? TV_ERR_SUCCESS
                                                        : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetBrightness( void )
// Purpose: Get brightness
// Input:   None
// Output:  None
// Return:  brightness value if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG GetBrightness( void )
{
   int brightness;
   return ( DlkBt848GetBrightness( &brightness ) == Success ? (LONG)brightness
                                                         : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetContrast( ULONG contrast )
// Purpose: Set contrast
// Input:   ULONG contrast - contrast to set to
// Output:  None
// Return:  TV_ERR_SUCCESS if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG SetContrast( ULONG contrast )
{
   // range checking
   if ( contrast > paramMax )
      return ( TV_ERR_BAD_VALUE );

   // request Bt848 DLL for action
   return ( DlkBt848SetContrast( contrast ) == Success ? TV_ERR_SUCCESS
                                                    : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetContrast( void )
// Purpose: Get contrast
// Input:   None
// Output:  None
// Return:  contrast value if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG GetContrast( void )
{
   int contrast;
   return ( DlkBt848GetContrast( &contrast ) == Success ? (LONG)contrast
                                                     : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetHue( ULONG hue )
// Purpose: Set hue
// Input:   ULONG hue - hue to set to
// Output:  None
// Return:  TV_ERR_SUCCESS if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG SetHue( ULONG hue )
{
   // range checking
   if ( hue > paramMax )
      return ( TV_ERR_BAD_VALUE );

   // request Bt848 DLL for action
   return ( DlkBt848SetHue( hue ) == Success ? TV_ERR_SUCCESS : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetHue( void )
// Purpose: Get hue
// Input:   None
// Output:  None
// Return:  hue value if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG GetHue( void )
{
   int hue;
   return ( DlkBt848GetHue( &hue ) == Success ? (LONG)hue : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetSaturation( ULONG sat )
// Purpose: Set saturation
// Input:   ULONG sat - saturation to set to
// Output:  None
// Return:  TV_ERR_SUCCESS if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG SetSaturation( ULONG sat )
{
   // range checking
   if ( sat > paramMax )
      return ( TV_ERR_BAD_VALUE );

   // request Bt848 DLL for action
   return ( DlkBt848SetSaturation( sat ) == Success ? TV_ERR_SUCCESS : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetSaturation( void )
// Purpose: Get saturation
// Input:   None
// Output:  None
// Return:  saturation value if success, else TV_ERR_DLL_ERROR
/////////////////////////////////////////////////////////////////////////////
LONG GetSaturation( void )
{
   int sat;
   return ( DlkBt848GetSaturation( &sat ) == Success ? (LONG)sat : TV_ERR_DLL_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetAudioMute ( ULONG mute )
// Purpose: Mute or UnMute audio
// Input:   ULONG mute - 0 to mute; 1-255 to unmute
// Output:  None
// Return:  TV control error value
// Note:    Audio source is controlled by setting appropriate value to
//          bits[1:0] of GPDATA. In addition, GPOE should be set to 0x0F so
//          value set in GPDATA will be output to the pins (Bt848 family only).
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioMute ( ULONG mute )
{
   // check parameter
   if ( mute > 255 )
      return ( TV_ERR_BAD_VALUE );

   if ( Bt878HWFound )
   {
      audioMute = ( mute == 0 );    // mute == 0 --> mute; !0 --> unmute
//      if ( !dwHandle )
//         return ( TV_ERR_NO_DEV_HANDLE );
      if ( audioSource == AUDIO_SOURCE_TVTUNER )
         return( ( Success == DllProcessCommand( audioMute ? CMD_MUTE : CMD_UNMUTE, 0, 0 ) ) ?
                 TV_ERR_SUCCESS : TV_ERR_AUDIO_ERROR );
      else
         return ( TV_ERR_SUCCESS );
   }

   // enables GPOE drivers for [1:0]
   // need to set GPOE to 0x0F in order to set audio mute/unmute
   DlkSetGPOE( 0x0000000FL );

   if ( mute == 0 )
   {  // try to mute
      if ( GetAudioSource() == AUDIO_SOURCE_MUTE )
         return ( TV_ERR_SUCCESS );    // already mute, returns success
      else
         return ( ( DlkSetGPDATABits( 0, 1, AUDIO_SOURCE_MUTE, 0 ) == Success ) ?
                        TV_ERR_SUCCESS : TV_ERR_AUDIO_ERROR );
   }
   else  // unmute
      return ( ( DlkSetGPDATABits( 0, 1, audioSource, 0 ) == Success ) ?
                        TV_ERR_SUCCESS : TV_ERR_AUDIO_ERROR );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetAudioMute ( void )
// Purpose: Check if audio is Mute or UnMute
// Input:   None
// Output:  None
// Return:  0 if mute, 1 if not mute, or TV_ERR_AUDIO_ERROR if error
// Note:    Audio source is controlled by bits[1:0] of GPDATA. In order to
//          read from pins, GPIE should be set to 0x00 (Bt848 family only).
/////////////////////////////////////////////////////////////////////////////
LONG GetAudioMute ( void )
{
   // Bt878 doesn't store audio source, return own value of what it was set to
   if ( Bt878HWFound )
      return ( audioMute ? 0 : 1 );

   // read GPIE from pin (not register)
   DlkSetGPIE( 0x00000000L );

   // ask GPDATA what the setting is
   DWORD value;
   return ( DlkGetGPDATABits( 0, 1, &value, 0 ) == Success ? ( value == AUDIO_SOURCE_MUTE ) ? 0 : 1
                                                        : TV_ERR_AUDIO_ERROR );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetAudioSource ( ULONG audio )
// Purpose: Set audio source
// Input:   ULONG audio - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,
//                        AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE    
// Output:  None
// Return:  TV control error value
// Note:    Audio source is controlled by setting appropriate value to
//          bits[1:0] of GPDATA. In addition, GPOE should be set to 0x0F so
//          value set in GPDATA will be output to the pins (Bt848 family only).
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioSource ( ULONG audio )
{
   // check parameter
   if ( audio > AUDIO_SOURCE_MUTE )
      return ( TV_ERR_BAD_VALUE );

   // Bt878: start audio if TV source is selected, else stop audio since it doesn't go through Bt878
   if ( Bt878HWFound )
   {
      //if ( !dwHandle )
      //   return ( TV_ERR_NO_DEV_HANDLE );

      if ( audio == AUDIO_SOURCE_TVTUNER )
      {
         if ( Success != DllProcessCommand( CMD_START_AUDIO, 0, 0 ) )
            return ( TV_ERR_AUDIO_ERROR );
         if ( audioMute )
            return( ( Success == DllProcessCommand( CMD_MUTE, 0, 0 ) ) ? TV_ERR_SUCCESS : TV_ERR_AUDIO_ERROR );
      }
      else
         return( ( Success == DllProcessCommand( CMD_STOP_AUDIO, 0, 0 ) ) ? TV_ERR_SUCCESS : TV_ERR_AUDIO_ERROR );
   }

   // enables GPOE drivers for [1:0]
   // need to set GPOE to 0x0F in order to set audio source
   DlkSetGPOE( 0x0000000FL );

   // if already mute, don't change audio source, just remember it since
   // changing audio source will enable audio
   if ( GetAudioSource() == AUDIO_SOURCE_MUTE )
   {
      audioSource = audio;
      return ( TV_ERR_SUCCESS );
   }
   else
   {  // not in mute, change audio source
      if ( DlkSetGPDATABits( 0, 1, audio, 0 ) == Success )
      {
         audioSource = audio;
         return ( TV_ERR_SUCCESS );
      }
      else
         return ( TV_ERR_AUDIO_ERROR );
   }
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetAudioSource ( void )
// Purpose: Get audio source
// Input:   None
// Output:  None
// Return:  audio source - AUDIO_SOURCE_CDROM, AUDIO_SOURCE_EXTAUDIO,
//                         AUDIO_SOURCE_TVTUNER, AUDIO_SOURCE_MUTE
// Note:    Audio source is controlled by bits[1:0] of GPDATA. In order to
//          read from pins, GPIE should be set to 0x00 (Bt848 family only).
/////////////////////////////////////////////////////////////////////////////
LONG GetAudioSource ( void )
{
   // Bt878 doesn't store audio source, return own value of what it was set to
   if ( Bt878HWFound )
      return ( audioSource );

   // read GPIE from pin (not register)
   DlkSetGPIE( 0x00000000L );

   // ask GPDATA what the setting is
   DWORD value;
   return ( DlkGetGPDATABits( 0, 1, &value, 0 ) == Success ? value : TV_ERR_AUDIO_ERROR );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetAudioHandle ( ULONG handle )
// Purpose: Set audio device handle (BtAud.dll)
// Input:   ULONG handle  - handle to audio dll (BtAud.dll)
// Output:  None
// Return:  TV_ERR_SUCCESS (= RADIO_ERR_SUCCESS) if success,
//          else TV_ERR_NO_DEV_HANDLE (= RADIO_ERR_NO_DEV_HANDLE)
/////////////////////////////////////////////////////////////////////////////
LONG SetAudioHandle ( ULONG handle )
{
   if ( !handle )
      return ( RADIO_ERR_NO_DEV_HANDLE );

   dwHandle = handle;
   return ( RADIO_ERR_SUCCESS );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetAudioHandle ( void )
// Purpose: Get audio device handle (BtAud.dll)
// Input:   None
// Output:  None
// Return:  audio device handle (BtAud.dll)
/////////////////////////////////////////////////////////////////////////////
LONG GetAudioHandle ( void )
{
   if ( !dwHandle )
      return ( RADIO_ERR_NO_DEV_HANDLE );

   return ( dwHandle );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  LONG SetRadioFreq( ULONG freq )
// Purpose: Set radio frequency
// Input:   ULONG freq - frequency to set to without decimal place (e.g. 975 = 97.5MHz)
// Output:  None
// Return:  Radio control error value
/////////////////////////////////////////////////////////////////////////////
LONG SetRadioFreq( ULONG freq )
{
   if ( !dwHandle )
      return ( RADIO_ERR_NO_DEV_HANDLE );

   return ( theTuner->SetRadioFreq( freq ) );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetRadioFreq( void )
// Purpose: Get radio frequency
// Input:   None
// Output:  None
// Return:  Radio frequency (1007 = 100.7MHz)
/////////////////////////////////////////////////////////////////////////////
LONG GetRadioFreq( void )
{
   if ( !dwHandle )
      return ( RADIO_ERR_NO_DEV_HANDLE );

   return ( (LONG)theTuner->GetRadioFreq() );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  LONG GetSignalStrength( void )
// Purpose: Get radio signal strength
// Input:   None
// Output:  None
// Return:  Radio signal strength: 0 (lowest) - 4 (highest) for Philips FM1236)
/////////////////////////////////////////////////////////////////////////////
LONG GetSignalStrength( void )
{
   if ( !dwHandle )
      return ( RADIO_ERR_NO_DEV_HANDLE );

   return ( (LONG)theTuner->GetRadioSignalStrength() );
}


//===========================================================================
// DLL Entry Point
//===========================================================================

/////////////////////////////////////////////////////////////////////////////
// Method:  (For Borland)   int PASCAL DllEntryPoint( HINSTANCE, DWORD dwReason, LPVOID )
//          (For Microsoft) int PASCAL DllMain( HINSTANCE, DWORD dwReason, LPVOID )
// Purpose: Specify DLL entry point and initialize I2C
// Input:   HINSTANCE      - no used
//          DWORD dwReason - the reason Dll is called
//          LPVOID         - no used
//
// Output:  None
// Return:  TRUE if success, else FALSE
/////////////////////////////////////////////////////////////////////////////
#ifdef __BORLANDC__
int PASCAL DllEntryPoint( HINSTANCE hInstance, DWORD dwReason, LPVOID )
#else  // Microsoft
int PASCAL DllMain( HINSTANCE hInstance, DWORD dwReason, LPVOID )
#endif
{
   // Initialize I2C when DLL is called
   if ( dwReason == DLL_PROCESS_ATTACH )
   {
      BOOL bAllFuncsMapped ;
      hinstBt32Dll = InitDynamicLinkage(bAllFuncsMapped) ;

      if ( hinstBt32Dll == (HINSTANCE) HINSTANCE_ERROR || !bAllFuncsMapped)
         return ( FALSE ) ;

      // Initialize I2C
      if ( DlkI2CIsInitOK() == false )
         return ( FALSE );

      // Use hardware mode with 100KHz frequency
      DlkI2CInitHWMode( 100000 );

      // Initialize GPIO
      if ( DlkGPIOIsInitOK() == false )
         return ( FALSE );

      // set GPIO to normal mode
      DlkSetGPIOMODE( GPIO_NORMAL );

      hInst = hInstance;      // save handle to instance for later

      // check if 878 family hardware is installed in the system
      Bt878HWFound = DlkIsBt878Family();

      // load audio dll if Bt878 is found
      if ( Bt878HWFound )
      {
         hAudDll = LoadLibrary( "BtAud.dll" );
         if ( !hAudDll )
            return ( FALSE );

         DllProcessCommand = (ProcessCommand_t)GetProcAddress( hAudDll, "ProcessCommand" );
         if ( !DllProcessCommand )
         {
            FreeLibrary( hAudDll );
            return ( FALSE );
         }
      }

      // instantiate different tuner depends on what hw is installed
      if ( Bt878HWFound )
      {
         char szTunerType[ 10 ];
         LONG dwSize = sizeof( szTunerType );
         RegUtil reg( BT_AUDIO_REG_SUBKEY );
         if ( reg.GetValue( szTunerType, &dwSize, "TunerType" ) != Success )
            szTunerType[ 0 ] = 'A';   // default is Alps tuner

         // P = Philips, otherwise Alps
         if ( szTunerType[ 0 ] == 'P' )
         {
            // set reg value to 0 for 0xC0 i2c addr, set to 2 for 0xC2
            DWORD dwOffset;
            if ( reg.GetValue( &dwOffset, "_I2COffset" ) == Success )
            {
               BYTE newI2C = 0xC0 + (BYTE)dwOffset;
                  theTuner = new TunerWithFMRadio( brandPhilips,
                                             formatNTSC,
                                             newI2C );
            }
            else
            theTuner = new TunerWithFMRadio( brandPhilips,
                                             formatNTSC,
                                             PhilipsI2CAddress );
         }                                          
         else
            theTuner = new AlpsTuner( brandAlps,
                                      formatNTSC,
                                      AlpsI2CAddress );
      }
      else
         theTuner = new TunerWithFMRadio( brandTemic,
                                          formatNTSC,
                                          TemicI2CAddress );
      if ( !theTuner )
         return ( FALSE );
   }
   else if ( dwReason == DLL_PROCESS_DETACH )
   {
      // mute audio when terminates (if not Bt878)
      if ( !Bt878HWFound )
         SetAudioSource( AUDIO_SOURCE_MUTE );

      // delete tuner instance
      if ( theTuner )
         delete theTuner;

      // unload audio dll
      if ( Bt878HWFound && hAudDll )
         FreeLibrary( hAudDll );

      // unload _32.dll
      if (hinstBt32Dll)
         FreeLibrary( hinstBt32Dll );
   }

   return ( TRUE );
}
