// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/IsBt878.cpp 1.3 1997/07/18 23:18:30 rudyl Released $
// $Log: IsBt878.cpp $
// Revision 1.3  1997/07/18 23:18:30  rudyl
// Responds to obtain HW info function # changed to 10.
// Revision 1.2  1997/07/16 01:29:36  rudyl
// Use function 21 to obtain hardware info.
// ********* NEEDS TO UPDATE FUNCTION NUMBER IF IT HAS BEEN MODIFIED. ***********
// Revision 1.1  1997/07/08 01:10:26  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 1997 Rockwell Semiconductor Systems - San Diego
//
//  Module:
//
//    878lin.cpp
//
//  Abstract:
//
//    Returns the base address of the Bt878
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "IsBt878.h"

const WORD BT878_DEVID = 0x036E;    // Bt878 device ID

// structure to receive hardware information
typedef struct _Bt878HWInfo
{
  WORD deviceId;
  BYTE revId;
  DWORD subSystemId;
} Bt878HWInfo;

//****************************************************************************
//  BOOL IsBt878HW( void )
//  	Purpose:   Search if Bt878 hardware is installed in the system
//  	Input:	  None
//  	Output:	  None
//  	Return:	  TRUE if hardware found, else FALSE
//****************************************************************************
BOOL IsBt878HW( void )
{
   HANDLE TestDev = CreateFile( "\\\\.\\Bt878Aud.vxd",
                                GENERIC_READ | GENERIC_WRITE,
                                0,              // exclusive access
                                NULL,           // no security
                                OPEN_EXISTING,
                                FILE_ATTRIBUTE_NORMAL, // | FILE_FLAG_OVERLAPPED
                                NULL );

   if ( TestDev == INVALID_HANDLE_VALUE )
      return FALSE;
   
   DWORD dwDataSize = 0;
   Bt878HWInfo hwInfo;

   // obtain hardware info; function 10
   DeviceIoControl( TestDev, 10, NULL, 0, &hwInfo,
                    sizeof( Bt878HWInfo ), &dwDataSize, NULL );

   CloseHandle( TestDev );

#pragma message("*** Fake Bt878 is found ***")
return( TRUE );
   return( hwInfo.deviceId == BT878_DEVID );
}
