// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/RadioCtl.h 1.5 1998/05/21 18:59:02 rudyl Exp $
// $Log: RadioCtl.h $
// Revision 1.5  1998/05/21 18:59:02  rudyl
// Graft from 1.4.2.2.
// Revision 1.4.2.2  1998/05/21 18:58:41  rudyl
// Added Nicam support. Works with Philips TDA9874H only. ITT is next.
// Revision 1.4  1998/04/18 08:13:01  trang
// Modified to compile under Microsoft VC.
// Revision 1.1  1997/12/22 22:44:28  ssm
// Initial revision
// Revision 1.3  1997/07/16 01:22:47  rudyl
// Added member function to get radio signal strength.
// Revision 1.2  1997/07/10 17:32:08  rudyl
// Gemini: Added return error RADIO_ ERR_NO_DEV_HANDLE if audio device handle is null.
// Revision 1.1  1997/07/06 19:53:32  rudyl
// Initial revision

//*****************************************************************************
//*                                                                           *
//*     Header file for Radio control in DLL                                  *
//*                                                                           *
//*     Copyright (C) 1997 Rockwell Semiconductor Systems - San Diego         *
//*                                                                           *
//*     All Rights Reserved                                                   *
//*                                                                           *
//*****************************************************************************


#ifndef __RADIOCTL_H
#define __RADIOCTL_H

// --- TCZ include common DA header
#include "dactl.h"
// --- TCZ <end>
#include "tverr.h"

//----------------------------------------
// Define BUILD_RADIOCTLDLL if you are building a Radio Control DLL.
// Do NOT define BUILD_RADIOCTLDLL if you are building an application
// that is using the DLL.
// Assume WIN32 is used
//----------------------------------------

#ifdef _BUILD_RADIOCTLDLL       // Building Radio Control DLL
   #ifdef __BORLANDC__
      #define __RADIOCTLCLASS __export
      #define __RADIOCTLFUNC  __export __cdecl
   #else // Microsoft
      #define __RADIOCTLCLASS
      #define __RADIOCTLFUNC  __cdecl
   #endif

#else                        // Building Application
   #ifdef __BORLANDC__
      #define __RADIOCTLCLASS __import
      #define __RADIOCTLFUNC  __import __cdecl
   #else // Microsoft
      #define __RADIOCTLCLASS
      #define __RADIOCTLFUNC  __cdecl
   #endif
#endif

//----------------------------------------
// Radio Parameter definitions
//----------------------------------------
#define RADIO_PARM_AUDIO_HANDLE          0x01       // Set/Get audio dll handle (Bt878.dll)
#define RADIO_PARM_FREQ                  0x02       // Set/Get tuner frequency
#define RADIO_PARM_SIGNAL_STRENGTH       0x03       // Get signal strength

// --- TCZ New grappler API for Digital audio (DA)
#define RADIO_PARM_DAFLAVOR				0x04	// DA flavor
#define RADIO_PARM_DASTATUS				0x05	// DA source status
#define RADIO_PARM_COUNTRY				0x06	// Country code (international dial)
// --- TCZ <end>

//----------------------------------------
// Radio Control Error Codes
//----------------------------------------
#define RADIO_ERR_SUCCESS                   0       // All is well
#define RADIO_ERR_GENERIC_ERR              -1       // Fill-all generic error
#define RADIO_ERR_UNSUPPORTED_PARAM        -2       // Bad or Unsupported Param
#define RADIO_ERR_BAD_VALUE                -3       // Out of Range Value
#define RADIO_ERR_NO_CARRIER               -4       // No Radio Signal on this freq

#define RADIO_ERR_VENDOR_BASE            -256       // Begin Vendor Specific Codes
#define RADIO_ERR_WRONG_HW               -257       //   These codes extend down
#define RADIO_ERR_I2C_ERROR              -258       //   (more negative) from here

#define RADIO_ERR_NO_DEV_HANDLE          TV_ERR_NO_DEV_HANDLE     // -260
                                                    
//----------------------------------------
// Radio Control Interface Function Prototypes
//----------------------------------------
#ifdef __cplusplus
extern "C"
{
#endif

LONG  __RADIOCTLFUNC SetRadioParam( ULONG Parameter, ULONG Value );
LONG  __RADIOCTLFUNC GetRadioParam( ULONG Parameter );

typedef LONG  (*SetRadioParam_t)( ULONG, ULONG );
typedef ULONG (*GetRadioParam_t)( ULONG );

#ifdef __cplusplus
}
#endif

#endif // __RADIOCTL_H
