// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/TVCTL.H 2.6 1998/05/21 19:07:49 rudyl Exp $
// $Log: TVCTL.H $
// Revision 2.6  1998/05/21 19:07:49  rudyl
// Graft from 2.5.2.2.
// Revision 2.5.2.2  1998/05/21 19:07:11  rudyl
// Added Nicam support. Works with Philips TDA9874H only. ITT is next.
// Revision 2.5  1998/04/18 08:13:06  trang
// Modified to compile under Microsoft VC.
// Revision 2.4  1997/08/14 20:15:05  rudyl
// Use 2.2 which added Gemini support.
// Revision 2.2  1997/07/06 19:50:42  rudyl
// Added TV_PARM_AUDIO_HANDLE to allow passing handle from app to grappler.
// Revision 2.1  1996/06/10 20:12:33  ssm
// MarkBeta1AsRev2
// Revision 1.4  1996/05/10 23:15:47  rudyl
// Implement TV_ERR_... return values from Intel. Also added exported function GetTVErrString() to retrieve our specific error msg.
// Revision 1.3  1996/04/28 01:20:13  rudyl
// ver 0.50 - does not instantiate I2C and GPIO objects here. Just make API
// calls to BT848_32.DLL. Also returns error types to caller instead of just TRUE/FALSE result.
// Revision 1.2  1996/04/12 21:01:09  rudyl
// Renamed DLL from 848Tuner.dll to Grappler.dll.
// Revision 1.1  1996/04/12 18:24:44  rudyl
// Initial revision


// CUT_HERE

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1996 Brooktree Corporation
//
//  Module:
//
//    TVCtl.h
//
//  Abstract:
//
//    Header file for TV Control
//
/////////////////////////////////////////////////////////////////////////////

/****************************************************************************

        INTEL CORPORATION PROPRIETARY INFORMATION
        Copyright (c) 1996 Intel Corporation
        All Rights Reserved

        This software is supplied under the terms of a license
        agreement or non-disclosure agreement with Intel Corporation
        and may not be copied or disclosed except in accordance
        with the terms of that agreement


****************************************************************************/
#ifndef __TVCTL_H
#define __TVCTL_H

//---------------------------------------- 
// Define BUILD_TVCTLDLL if you are building a TV Control DLL.
// Do NOT define BUILD_TVCTLDLL if you are building an Intercast application.
// assume WIN32 is used
//---------------------------------------- 
//#define BUILD_TVCTLDLL

#ifdef _BUILD_TVCTLDLL       // Building TV Control DLL
   #ifdef __BORLANDC__
      #define __TVCTLCLASS __export
      #define __TVCTLFUNC __export __cdecl
   #else // Microsoft
      #define __TVCTLCLASS
      #define __TVCTLFUNC __cdecl
   #endif

#else                        // Building Intercast Application
   #ifdef __BORLANDC__
      #define __TVCTLCLASS __import
      #define __TVCTLFUNC __import __cdecl
   #else // Microsoft
      #define __TVCTLCLASS
      #define __TVCTLFUNC __cdecl
   #endif
#endif

//---------------------------------------- 
// Registry Key and Value name definitions
//---------------------------------------- 
#define TV_CTL_REG_SUBKEY "SOFTWARE\\Intel\\Intercast\\TVControl"
#define TV_CTL_REG_VALNAME "TVControlDLL"

//---------------------------------------- 
// TV Parameter definitions
//---------------------------------------- 
#define TV_PARM_SOURCE                0x01       // Signal source (see below)
#define TV_PARM_CHANNEL               0x02       // Television Tuner Channel
#define TV_PARM_BRIGHTNESS            0x03       // Luminance Brightness
#define TV_PARM_CONTRAST              0x04       // Luminance Contrast
#define TV_PARM_HUE                   0x05       // Chrominance Hue Phase Angle
#define TV_PARM_SATURATION            0x06       // Chrominance Saturation

#define TV_PARM_AUDIO_HANDLE          0x0F       // Audio dll handle (Bt878.dll)
#define TV_PARM_MUTE                  0x10       // Audio Mute

// --- TCZ New grappler API for Digital audio (DA) and country support
#define TV_PARM_DAFLAVOR				0x11	// DA flavor
#define TV_PARM_DASTATUS				0x12	// DA source status
#define TV_PARM_COUNTRY					0x13	// Country code (international dial)
#define TV_PARM_CHANNELID				0x14	// Identification string
// --- TCZ <end>
     
     
//----------------------------------------
// TV Source Value definitions
//---------------------------------------- 
#define TV_SOURCE_BASEBAND_COMPOSITE  0x00       // Baseband Composite (typ RCA)
#define TV_SOURCE_BASEBAND_SVIDEO     0x01       // Baseband S/Video (typ DIN)
#define TV_SOURCE_BASEBAND_CAMERA     0x02       // Baseband Camera
#define TV_SOURCE_TUNER_CABLE         0x04       // TV Tuner, Cable Frequencies
#define TV_SOURCE_TUNER_ANTENNA       0x05       // TV Tuner, Antenna Freq's
     
     
//---------------------------------------- 
// TV Control Error Codes
//---------------------------------------- 
#define TV_ERR_SUCCESS                   0       // All is well
#define TV_ERR_GENERIC_ERR              -1       // Fill-all generic error
#define TV_ERR_UNSUPPORTED_PARAM        -2       // Bad or Unsupported Param
#define TV_ERR_BAD_VALUE                -3       // Out of Range Value
#define TV_ERR_NO_CARRIER               -4       // No TV Signal on this Chnl
#define TV_ERR_SOURCE_CANNOT_TUNE       -5       // Chnl Change, Baseband Source
     
#define TV_ERR_VENDOR_BASE            -256       // Begin Vendor Specific Codes
                                                 //   These codes extend down
                                                 //   (more negative) from here

//---------------------------------------- 
// TV Control Interface Function Prototypes 
//---------------------------------------- 
#ifdef __cplusplus
extern "C"
{
#endif
     
LONG  __TVCTLFUNC SetTVParam( ULONG Parameter, ULONG Value ); 
LONG  __TVCTLFUNC GetTVParam( ULONG Parameter );
char* __TVCTLFUNC GetTVErrString( LONG ErrCode );
     
#ifdef __cplusplus
}
#endif
     
#endif // __TVCTL_H
