// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/dactl.h 1.1 1998/05/21 18:25:49 rudyl Exp $
// $Log: dactl.h $
// Revision 1.1  1998/05/21 18:25:49  rudyl
// Initial revision

//*****************************************************************************
//*                                                                           *
//*     Header file for Digital Audio in DLL                                  *
//*                                                                           *
//*     Copyright (C) 1998 Rockwell Semiconductor Systems - San Diego         *
//*                                                                           *
//*     All Rights Reserved                                                   *
//*                                                                           *
//*****************************************************************************

#ifndef __DACTL_H
#define __DACTL_H

// --- TCZ Digital audio common, TV and Radio

//----------------------------------------
// DA Capabilities
//----------------------------------------
typedef enum _tagDATYPE{ DATYPE_I2S, DATYPE_PFSM, DATYPE_BTSC = -2, DATYPE_NONE = -1 } DATYPE;
typedef enum _tagDAMLB { DAMLB_MSB, DAMLB_LSB } DAMLB;
typedef enum _tagDASCE { DASCE_RISING, DASCE_FALLING } DASCE;
typedef enum _tagDALRI { DALRI_LEFT, DALRI_RIGHT, DALRI_RISING = 0, DALRI_FALLING } DALRI;
typedef struct _tagDAFLAVOR
{
	int size;			// size of this structure
	DATYPE DaType;		// type of digital audio source (if any)
	DAMLB DaMlb;
	DASCE DaSce;
	DALRI DaLri;
	int AscDelay;
	int CapRate;		// must be 32000 KHz currently
	int CapRes;			// must 16 bit currently
	int CapChannels;	// must be 2 (stereo)
} DAFLAVOR;

//----------------------------------------
// DA Status
//----------------------------------------
#define DASTATUS_OK			0x0001		// DA source working fine

#define DASTATUS_STEREO		0x0010		// DA source stereo
#define DASTATUS_DUAL		0x0020		// DA source dual language
#define DASTATUS_DIGITAL	0x0040		// DA source digital (NICAM)
#define DASTATUS_AUTOMUTE	0x0080		// DA source downgraded

#define DASTATUS_LANGUAGEA	0x0100		// DA language A (get/set)
#define DASTATUS_LANGUAGEB	0x0200		// DA language B (get/set)


// --- TCZ <end>

#endif /* __DACTL_H */
