// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Grappler/rcs/dynLink.cpp 1.4 1998/05/21 18:53:35 rudyl Exp $
// $Log: dynLink.cpp $
// Revision 1.4  1998/05/21 18:53:35  rudyl
// graft from 1.3.2.2.
// Revision 1.3.2.2  1998/05/21 18:51:48  rudyl
// Added NIcam support. Works with Philips TDA9874H only. ITT is next.
// Revision 1.3  1998/04/18 08:14:55  trang
// Modified to compile under MSVC.
// Revision 1.2  1998/04/07 17:34:58  rudyl
// Missing I2CHWWrite2().
// Revision 1.1  1998/02/21 01:30:40  dtharp
// Initial revision

// CUT_HERE

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 1998 Brooktree Corporation
//
//  Module:
//
//    dynLink.cpp
//
//  Abstract:
//
//    Provides typesafe dynamic linkage to BtVid_32 exports
//
/////////////////////////////////////////////////////////////////////////////


#include "Bt848fcn.h"
#include "Bt848api.h"

#include "dynLink.h"

#define LIB_NAME "BtVid_32.Dll"

// typedefs for function pointers into the dll. Provides type safe access

// from Bt848fcn.h
typedef ErrorCode ( WINAPI *Bt848SetVideoSource_f )   ( Connector conn )   ;
typedef ErrorCode ( WINAPI *Bt848GetVideoSource_f )   ( Connector * conn ) ;
typedef ErrorCode ( WINAPI *Bt848SetBrightness_f )    ( int brightness )   ;
typedef ErrorCode ( WINAPI *Bt848GetBrightness_f )    ( int * brightness ) ;
typedef ErrorCode ( WINAPI *Bt848SetContrast_f )      ( int contrast )     ;
typedef ErrorCode ( WINAPI *Bt848GetContrast_f )      ( int * contrast )   ;
typedef ErrorCode ( WINAPI *Bt848SetHue_f )           ( int hue )          ;
typedef ErrorCode ( WINAPI *Bt848GetHue_f )           ( int * hue )        ;
typedef ErrorCode ( WINAPI *Bt848SetSaturation_f )    ( int sat )          ;
typedef ErrorCode ( WINAPI *Bt848GetSaturation_f )    ( int * sat )        ;
typedef ErrorCode ( WINAPI *Bt848PreChannelChange_f ) ( int channel )      ;
typedef ErrorCode ( WINAPI *Bt848ChannelChanged_f )   ( int channel )      ;

// from Bt848api.h
typedef void      ( WINAPI *SetGPOE_f )               ( DWORD value )      ;
typedef ErrorCode ( WINAPI *SetGPDATABits_f )         ( int fromBit, int toBit, DWORD value, int offset );
typedef ErrorCode ( WINAPI *SetGPIE_f )               ( DWORD value )      ;
typedef ErrorCode ( WINAPI *GetGPDATABits_f )         ( int fromBit, int toBit, DWORD * value, int offset );
typedef bool      ( WINAPI *GPIOIsInitOK_f )          ( void )             ;
typedef void      ( WINAPI *SetGPIOMODE_f )           ( GPIOMode mode )    ;
typedef bool      ( WINAPI *I2CIsInitOK_f )           ( void )             ;
typedef ErrorCode ( WINAPI *I2CInitHWMode_f )         ( long freq )        ;
typedef ErrorCode ( WINAPI *I2CHWRead_f )             ( BYTE address, BYTE *value );
typedef ErrorCode ( WINAPI *I2CHWWrite2_f )           ( BYTE address, BYTE value1 );
typedef ErrorCode ( WINAPI *I2CHWWrite3_f )           ( BYTE address, BYTE value1, BYTE value2 );
// --- TCZ
typedef ErrorCode ( WINAPI *I2CHWMultiWrite_f )       ( BYTE address, BYTE sub, BYTE *block, int size );
typedef ErrorCode ( WINAPI *I2CHWMultiRead_f )        ( BYTE address, BYTE sub, BYTE *block, int size );
// --- TCZ
typedef BOOL      ( WINAPI *IsBt878Family_f )         ( void )             ;

// BtVid loaded functions
Bt848SetVideoSource_f		pBt848SetVideoSource	   = NULL;
Bt848GetVideoSource_f		pBt848GetVideoSource	   = NULL;
Bt848SetBrightness_f		   pBt848SetBrightness	   = NULL;
Bt848GetBrightness_f		   pBt848GetBrightness	   = NULL;
Bt848SetContrast_f		   pBt848SetContrast	      = NULL;
Bt848GetContrast_f		   pBt848GetContrast	      = NULL;
Bt848SetHue_f			      pBt848SetHue		      = NULL;
Bt848GetHue_f			      pBt848GetHue		      = NULL;
Bt848SetSaturation_f		   pBt848SetSaturation	   = NULL;
Bt848GetSaturation_f		   pBt848GetSaturation	   = NULL;
Bt848PreChannelChange_f		pBt848PreChannelChange	= NULL;
Bt848ChannelChanged_f		pBt848ChannelChanged	   = NULL;

SetGPOE_f			         pSetGPOE		      = NULL;
SetGPDATABits_f			   pSetGPDATABits		= NULL;
SetGPIE_f			         pSetGPIE		      = NULL;
GetGPDATABits_f			   pGetGPDATABits		= NULL;
GPIOIsInitOK_f			      pGPIOIsInitOK		= NULL;
SetGPIOMODE_f			      pSetGPIOMODE		= NULL;
I2CIsInitOK_f			      pI2CIsInitOK		= NULL;
I2CInitHWMode_f			   pI2CInitHWMode		= NULL;
I2CHWRead_f			         pI2CHWRead		   = NULL;
I2CHWWrite2_f			      pI2CHWWrite2		= NULL;
I2CHWWrite3_f			      pI2CHWWrite3		= NULL;
// --- TCZ
I2CHWMultiWrite_f		      pI2CHWMultiWrite  = NULL;
I2CHWMultiRead_f		      pI2CHWMultiRead   = NULL;
// --- TCZ
IsBt878Family_f			   pIsBt878Family		= NULL;


//
//  Initialization function
//
HINSTANCE InitDynamicLinkage(BOOL & bOk)
{
   bOk = FALSE ;

   HINSTANCE hVid32Dll = LoadLibrary( LIB_NAME );

   if ( hVid32Dll > (HINSTANCE) HINSTANCE_ERROR ) {

      pBt848SetVideoSource = (Bt848SetVideoSource_f) GetProcAddress( hVid32Dll, "Bt848SetVideoSource" );
      pBt848GetVideoSource = (Bt848GetVideoSource_f) GetProcAddress( hVid32Dll, "Bt848GetVideoSource" );
      pBt848SetBrightness  = (Bt848SetBrightness_f)  GetProcAddress( hVid32Dll, "Bt848SetBrightness" );
      pBt848GetBrightness  = (Bt848GetBrightness_f)  GetProcAddress( hVid32Dll, "Bt848GetBrightness" );
      pBt848SetContrast    = (Bt848SetContrast_f)    GetProcAddress( hVid32Dll, "Bt848SetContrast" );
      pBt848GetContrast    = (Bt848GetContrast_f)    GetProcAddress( hVid32Dll, "Bt848GetContrast" );
      pBt848SetHue         = (Bt848SetHue_f)         GetProcAddress( hVid32Dll, "Bt848SetHue" );
      pBt848GetHue         = (Bt848GetHue_f)         GetProcAddress( hVid32Dll, "Bt848GetHue" );
      pBt848SetSaturation  = (Bt848SetSaturation_f)  GetProcAddress( hVid32Dll, "Bt848SetSaturation" );
      pBt848GetSaturation  = (Bt848GetSaturation_f)  GetProcAddress( hVid32Dll, "Bt848GetSaturation" );
      pBt848PreChannelChange = (Bt848PreChannelChange_f) GetProcAddress( hVid32Dll, "Bt848PreChannelChange" );
      pBt848ChannelChanged = (Bt848ChannelChanged_f) GetProcAddress( hVid32Dll, "Bt848ChannelChanged" );

      pSetGPOE             = (SetGPOE_f)             GetProcAddress( hVid32Dll, "SetGPOE" );
      pSetGPDATABits       = (SetGPDATABits_f)       GetProcAddress( hVid32Dll, "SetGPDATABits" );
      pSetGPIE             = (SetGPIE_f)             GetProcAddress( hVid32Dll, "SetGPIE" );
      pGetGPDATABits       = (GetGPDATABits_f)       GetProcAddress( hVid32Dll, "GetGPDATABits" );
      pGPIOIsInitOK        = (GPIOIsInitOK_f)        GetProcAddress( hVid32Dll, "GPIOIsInitOK" );
      pSetGPIOMODE         = (SetGPIOMODE_f)         GetProcAddress( hVid32Dll, "SetGPIOMODE" );
      pI2CIsInitOK         = (I2CIsInitOK_f)         GetProcAddress( hVid32Dll, "I2CIsInitOK" );
      pI2CInitHWMode       = (I2CInitHWMode_f)       GetProcAddress( hVid32Dll, "I2CInitHWMode" );
      pI2CHWRead           = (I2CHWRead_f)           GetProcAddress( hVid32Dll, "I2CHWRead" );
      pI2CHWWrite2         = (I2CHWWrite2_f)         GetProcAddress( hVid32Dll, "I2CHWWrite2" );
      pI2CHWWrite3         = (I2CHWWrite3_f)         GetProcAddress( hVid32Dll, "I2CHWWrite3" );
// --- TCZ
      pI2CHWMultiWrite     = (I2CHWMultiWrite_f)     GetProcAddress( hVid32Dll, "I2CHWMultiWrite" );
      pI2CHWMultiRead      = (I2CHWMultiRead_f)      GetProcAddress( hVid32Dll, "I2CHWMultiRead" );
// --- TCZ
      pIsBt878Family       = (IsBt878Family_f)       GetProcAddress( hVid32Dll, "IsBt878Family" );

   }
   bOk = TRUE ;
   return hVid32Dll ;
}

ErrorCode DlkBt848SetVideoSource( Connector conn )
{
   return (pBt848SetVideoSource) ? pBt848SetVideoSource(conn) : Fail ;
}

ErrorCode DlkBt848GetVideoSource( Connector * conn )
{
   return (pBt848GetVideoSource) ? pBt848GetVideoSource(conn): Fail ;
}

ErrorCode DlkBt848SetBrightness( int brightness )
{
   return (pBt848SetBrightness) ? pBt848SetBrightness(brightness): Fail ;
}

ErrorCode DlkBt848GetBrightness( int * brightness )
{
   return (pBt848GetBrightness) ? pBt848GetBrightness(brightness): Fail ;
}

ErrorCode DlkBt848SetContrast( int contrast )
{
   return (pBt848SetContrast) ? pBt848SetContrast(contrast): Fail ;
}

ErrorCode DlkBt848GetContrast( int * contrast )
{
   return (pBt848GetContrast) ? pBt848GetContrast(contrast): Fail ;
}

ErrorCode DlkBt848SetHue( int hue )
{
   return (pBt848SetHue) ? pBt848SetHue(hue): Fail ;
}

ErrorCode DlkBt848GetHue( int * hue )
{
   return (pBt848GetHue) ? pBt848GetHue(hue): Fail ;
}

ErrorCode DlkBt848SetSaturation( int sat )
{
   return (pBt848SetSaturation) ? pBt848SetSaturation(sat): Fail ;
}

ErrorCode DlkBt848GetSaturation( int * sat )
{
   return (pBt848GetSaturation) ? pBt848GetSaturation(sat): Fail ;
}

ErrorCode DlkBt848PreChannelChange( int channel )
{
   return (pBt848PreChannelChange) ? pBt848PreChannelChange(channel): Fail ;
}
ErrorCode DlkBt848ChannelChanged( int channel )
{
   return (pBt848ChannelChanged) ? pBt848ChannelChanged(channel): Fail ;
}

// from Bt848api.h

void      DlkSetGPOE( DWORD value )
{
   if (pSetGPOE)  pSetGPOE(value) ;
}

ErrorCode DlkSetGPDATABits( int fromBit, int toBit,
                                     DWORD value, int offset )
{
   return (pSetGPDATABits) ? pSetGPDATABits(fromBit, toBit, value, offset): Fail ;
}

ErrorCode DlkSetGPIE( DWORD value )
{
   return (pSetGPIE) ? pSetGPIE(value): Fail ;
}

ErrorCode DlkGetGPDATABits( int fromBit, int toBit,
                                     DWORD * value, int offset )
{
   return (pGetGPDATABits) ? pGetGPDATABits(fromBit, toBit, value, offset): Fail ;
}

bool      DlkGPIOIsInitOK( void )
{
   return (pGPIOIsInitOK) ? pGPIOIsInitOK(): false ;
}

void      DlkSetGPIOMODE( GPIOMode mode )
{
   if (pSetGPIOMODE)  pSetGPIOMODE(mode) ;
}

bool      DlkI2CIsInitOK( void )
{
  return (pI2CIsInitOK) ? pI2CIsInitOK() : false ;
}


ErrorCode DlkI2CInitHWMode( long freq )
{
   return (pI2CInitHWMode) ? pI2CInitHWMode(freq): Fail ;
}

ErrorCode DlkI2CHWRead( BYTE address, BYTE *value )
{
   return (pI2CHWRead) ? pI2CHWRead(address,value): Fail ;
}

ErrorCode DlkI2CHWWrite2( BYTE address, BYTE value1 )
{
   return (pI2CHWWrite2) ? pI2CHWWrite2(address, value1): Fail ;
}

ErrorCode DlkI2CHWWrite3( BYTE address, BYTE value1, BYTE value2 )
{
   return (pI2CHWWrite3) ? pI2CHWWrite3(address, value1, value2): Fail ;
}

// --- TCZ
ErrorCode DlkI2CHWMultiWrite( BYTE address, BYTE sub, BYTE* block, int size )
{
   return (pI2CHWMultiWrite) ? pI2CHWMultiWrite(address, sub, block, size): Fail ;
}


ErrorCode DlkI2CHWMultiRead( BYTE address, BYTE sub, BYTE* block, int size )
{
   return (pI2CHWMultiRead) ? pI2CHWMultiRead(address, sub, block, size): Fail ;
}

// --- TCZ

BOOL      DlkIsBt878Family( void )
{
   return (pIsBt878Family) ? pIsBt878Family(): FALSE ;
}

// eof
