/* File: Bt848vxd.h
 * Purpose: contains ring 0 api provided by the 848 VxD
 * Author: sasha
 * $Log: bt848vxd.h $
 * Revision 1.4  1998/02/24 07:07:36  dtharp
 * Graft from 1.3.2.2
 * Revision 1.3.2.2  1998/02/10 03:34:04  dtharp
 * Added VVL Read & Write byte functions
 * Revision 1.3  1997/09/04 22:44:22  dtharp
 * Merged VSYNC Callback changes
 * Revision 1.2.1.1  1997/08/21 01:41:35  dtharp
 * Branch for vsync callback
 * Revision 1.2  1997/07/22 15:38:58  dtharp
 * Added VxD Service Bt848_Get_PCI_Config_Header.
 * Revision 1.1  1996/11/19 17:49:15  dtharp
 * Initial revision
 */

#ifndef __848API_H
#define __848API_H

Begin_VxD_Service_Table(BT848)
   VxD_Service( BT848_Get_Version )
   VxD_Service( BT848_Set_GPIO_Callback )
   VxD_Service( BT848_Set_I2C_Callback )
   VxD_Service( Bt848_Open_VBI_Channel )
   VxD_Service( Bt848_Start_VBI_Capture )
   VxD_Service( Bt848_Stop_VBI_Capture )
   VxD_Service( Bt848_Close_VBI_Channel )
   VxD_Service( Bt848_Get_PCI_Config_Header )
   VxD_Service( BT848_Set_VSYNC_Callback )
   VxD_Service( BT848_VVL_Read_Byte )
   VxD_Service( BT848_VVL_Write_Byte )
End_VxD_Service_Table

      

#endif