/* File: Chaniface.h
 * Purpose: Contains definition of the base interface between CaptureChip class
 *   and VxDVideoChannel class
 * Author: sasha
 * $Log: chanifac.h $
 * Revision 2.3  1997/08/08 11:15:58  dtharp
 * Fix for bug 714: NotifyArg now passed by reference.
 * Revision 2.2  1997/06/27 16:18:06  dtharp
 * Modifications to pass drop count to ring 3.
 * Revision 2.1  1996/06/10 20:13:37  ssm
 * MarkBeta1AsRev2
 * Revision 1.3  1995/09/24 14:21:24  sasha
 * First major check-in for testing
 * Revision 1.2  1995/09/24 06:21:24  sasha
 * Just to make Mike happy
 * Revision 1.1  1995/09/23 23:21:24  sasha
 * Initial revision
 */

#ifndef __CHANIFACE_H
#define __CHANIFACE_H


/* Class: ChanIface
 * Purpose: Defines interface between CaptureChip class and VxDVideoChannel class
 * Attributes:
 * Operations:
 *   virtual void Notify() - called by CaptureChip to report an interrupt
 */

typedef struct NotifyArg {
  DWORD idx_ ;
  DWORD currSkipCount_ ;
  NotifyArg(DWORD idx, DWORD currSkipCount) : idx_(idx) , currSkipCount_(currSkipCount){}
};

class ChanIface
{
   public:
      virtual void Notify( NotifyArg &na ) {}
};



#endif