/* util_16.h
 * Purpose: Header of 16-bit registry access helper fns.
 * Author: peter
 * $Log: util_16.h $
 * Revision 1.9  1997/12/12 23:58:38  peter
 * Fixed REG_BINARY problem.
 * Revision 1.8  1997/12/11 23:11:22  dtharp
 * removed hard coded paths to include files
 * Revision 1.7  1997/12/11 17:11:46  peter
 * Added REG_BINARY support to btutil*.dll.
 * Revision 1.6  1997/12/09 23:18:58  peter
 * Fixed hard-coded path to def__.h.
 * Revision 1.5  1997/12/09 17:35:40  peter
 * Fixed 16/32-bit thunking exception upon startup bug.
 * Revision 1.4  1997/12/04 17:01:50  peter
 * Added RCS comment strings.
 * Initial revision
 */

#ifndef __UTIL_16_H
#define __UTIL_16_H

#define _BUILD_BT848DLL    // all __BT848FUNC functions are exported

#include "def__.h"    

#ifndef BYTE
   typedef unsigned char       BYTE;
#endif

#ifdef __BORLANDC__
   #ifndef CLASSLIB_DEFS_H
   #include <classlib/defs.h>
   #endif
#else	// Microsoft 
   #define bool		BOOL
   #define true 	TRUE
   #define false 	FALSE
#endif

#ifndef __WINDOWS_H
#include <windows.h>
#endif


#ifdef __cplusplus
extern "C"
{
#endif

int			WINAPI RegUtilCreateKey( LPCSTR );
int			WINAPI RegUtilQueryValue( LPCSTR, LPSTR, LPLONG );
int			WINAPI RegUtilSetValue( LPCSTR, LPCSTR );
int			WINAPI RegUtilQueryBinValue( int*, LPSTR, LPCSTR, LPCSTR );
int			WINAPI RegUtilSetBinValue( int, LPSTR, LPCSTR, LPCSTR );

#ifdef __cplusplus
}
#endif

#endif	// __UTIL_16_H

