/* File: Chstrmin.h
 * Purpose: Defines class derived from ChanIface to be included in the
 *   VxDVideoChannel. Needed to decouple CaptureChip from VxDVideoChannel
 * Author: sasha
 * $Log: vidchifc.h $
 * Revision 2.3  1997/08/08 11:16:14  dtharp
 * Fix for bug 714: NotifyArg now passed by reference.
 * Revision 2.2  1997/06/27 16:18:06  dtharp
 * Modifications to pass drop count to ring 3.
 * Revision 2.1  1996/06/10 20:13:43  ssm
 * MarkBeta1AsRev2
 * Revision 1.2  1995/09/24 01:48:38  sasha
 * First major check-in for testing
 */

#ifndef __VIDCHIFC_H
#define __VIDCHIFC_H


#ifndef __CHANIFACE_H
#include "chanifac.h"
#endif

/* Class: VideoChanIface
 * Purpose: Used to establish a callback mecanism when CaptureChip-derived class
 *   can call VxDVideoChannel class back to notify about an interrupt
 */
class VxDVideoChannel;

class VideoChanIface : public ChanIface
{
   private:
      VxDVideoChannel *ToBeNotified_;
   public:
      virtual void Notify( NotifyArg &na );
      VideoChanIface( VxDVideoChannel *aChan ) : ToBeNotified_( aChan ) {}
};

#endif