#ifndef VIDHDRQ_H
#define VIDHDRQ_H

class VidHdrQueue
{
   private :
   DWORD head_ ;
   DWORD tail_ ;
   LPVIDEOHDR * elements_ ;
   DWORD size_ ;
   DWORD count_ ;

   void incQptr( DWORD & ptr ) 
   {
      ptr++ ;
      ptr %= size_ ;
   }

   public :
   VidHdrQueue (int size): size_(size+1) ,head_ (0), tail_ (0), count_(0)
   { elements_ = new LPVIDEOHDR[size_]; }
   virtual ~VidHdrQueue () { delete [] elements_ ;}

   DWORD * GetCountAddress() { return &count_ ; }

   // queue operations
   BOOL Add(LPVIDEOHDR pItem) 
   {
      BOOL st = FALSE ;
      if (!IsFull())
      {
         elements_[head_] = pItem ;
         incQptr(head_) ;
         count_++ ;
         st = TRUE ;
      }
      return st ;
   }
   LPVIDEOHDR Remove (void) 
   {
      LPVIDEOHDR ret = NULL ;
      if (!IsEmpty())
      {
         ret = elements_[tail_] ;
         incQptr(tail_) ;
         count_-- ;
      }
      return ret;
   }

   LPVIDEOHDR Peek (void) 
   {
      LPVIDEOHDR ret = NULL ;
      if (!IsEmpty())
      {
         ret = elements_[tail_] ;
      }
      return ret;
   }

   void Flush(void)
   {
      head_ = tail_ = count_ = 0 ;
   }
   
   int Count (void) {return count_ ;}
   int Size (void) {return size_ -1 ;}
   BOOL IsEmpty() { return head_ == tail_; }
   BOOL IsFull() 
   { 
      DWORD tmp = head_;
      incQptr(tmp) ;
      return tmp == tail_ ; 
   } 
} ;

#endif