/////////////////////////////////////////////////////////////////////////////
// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/pll/rcs/pll.cpp 1.2 1997/02/04 18:36:02 rudyl Released $
// $Log: pll.cpp $
// Revision 1.2  1997/02/04 18:36:02  rudyl
// First Pisces+ check in.
// Revision 1.1  1996/08/21 22:19:34  rudyl
// Initial revision
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    PLL.cpp
//
//  Abstract:
//
//    Bt848A/Bt849 PLL Class API
//
//  DESIGN NOTES
//
//
/////////////////////////////////////////////////////////////////////////////

#include "pll.h"
#include "p_constr.h"



//===========================================================================
// Bt848A/Bt849 PLL Class Implementation
//===========================================================================


/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////

PLL::PLL( void ):
   CONSTRUCT_PLL_REGISTERS
{
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
PLL::~PLL()
{
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void PLL::SetPLL( BYTE f_lo, BYTE f_hi, BYTE i, bool c, bool x )
// Purpose: Set PLL register values to synthesize desired frequency
// Input:   BYTE f_lo - value for PLL_F_LO
//          BYTE f_hi - value for PLL_F_HI
//          BYTE i    - value for PLL_I
//          bool c    - true to set PLL_C; else clear PLL_C
//          bool x    - true to set PLL_X; else clear PLL_X
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void PLL::SetPLL( BYTE f_lo, BYTE f_hi, BYTE i, bool c, bool x )
{
//char str [80];
//sprintf( str, "pll.cpp-> %X %X %X %X %X", f_lo, f_hi, i, c, x );
//OUTPUT_MESS( str );

   pllRegPLL_F_LO = f_lo;
   pllRegPLL_F_HI = f_hi;
   pllFieldPLL_I  = i;
   pllFieldPLL_C  = ( c == false ) ? 0 : 1;
   pllFieldPLL_X  = ( x == false ) ? 0 : 1;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  BYTE PLL::GetPLL_F_LO( void )
// Purpose: Obtain PLL_F_LO register value
// Input:   None
// Output:  None
// Return:  Content of PLL_F_LO
/////////////////////////////////////////////////////////////////////////////
BYTE PLL::GetPLL_F_LO( void )
{
   return pllRegPLL_F_LO;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  BYTE PLL::GetPLL_F_HI( void )
// Purpose: Obtain PLL_F_HI register value
// Input:   None
// Output:  None
// Return:  Content of PLL_F_HI
/////////////////////////////////////////////////////////////////////////////
BYTE PLL::GetPLL_F_HI( void )
{
   return pllRegPLL_F_HI;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  BYTE PLL::GetPLL_I( void )
// Purpose: Obtain PLL_I register value
// Input:   None
// Output:  None
// Return:  Content of PLL_I
/////////////////////////////////////////////////////////////////////////////
BYTE PLL::GetPLL_I( void )
{
   return pllFieldPLL_I;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool PLL::GetPLL_C( void )
// Purpose: Obtain PLL_C register value
// Input:   None
// Output:  None
// Return:  true if PLL_C is set; else false
/////////////////////////////////////////////////////////////////////////////
bool PLL::GetPLL_C( void )
{
  return (pllFieldPLL_C == 1) ? true : false;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  bool PLL::GetPLL_X( void )
// Purpose: Obtain PLL_X register value
// Input:   None
// Output:  None
// Return:  true if PLL_X is set; else false
/////////////////////////////////////////////////////////////////////////////
bool PLL::GetPLL_X( void )
{
  return (pllFieldPLL_X == 1) ? true : false;
}


