/////////////////////////////////////////////////////////////////////////////
// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/pll/rcs/pll.h 1.2 1997/02/04 18:36:02 rudyl Released $
// $Log: pll.h $
// Revision 1.2  1997/02/04 18:36:02  rudyl
// First Pisces+ check in.
// Revision 1.1  1996/08/21 22:18:32  rudyl
// Initial revision
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    pll.h
//
//  Abstract:
//
//    Header file Bt849 PLL Registers
//
/////////////////////////////////////////////////////////////////////////////


#ifndef __PLL_H
#define __PLL_H

#ifdef VXD
#include <vtoolscp.h>
#endif

#undef FAR

#include "regField.h"



/////////////////////////////////////////////////////////////////////////////
// CLASS PLL
//
// Description:
//    This class encapsulates the PLL register fields in the Bt848A/Bt849.
//
// Methods:
//    // set various PLL registers
//    virtual void SetPLL( BYTE f_lo, BYTE f_hi, BYTE i, bool c, bool x );
//
//    // get contents of PLL registers
//    virtual BYTE GetPLL_F_LO( void );
//    virtual BYTE GetPLL_F_HI( void );
//    virtual BYTE GetPLL_I( void );
//    virtual bool GetPLL_C( void );
//    virtual bool GetPLL_X( void );
//
// Note:
//
/////////////////////////////////////////////////////////////////////////////

class PLL
{
	public:
      #include "p_declar.h"

		PLL( void );
		~PLL();

      // set various PLL registers
      virtual void SetPLL( BYTE f_lo, BYTE f_hi, BYTE i, bool c, bool x );

      // get contents of PLL registers
      virtual BYTE GetPLL_F_LO( void );
      virtual BYTE GetPLL_F_HI( void );
      virtual BYTE GetPLL_I( void );
      virtual bool GetPLL_C( void );
      virtual bool GetPLL_X( void );
};


#endif __PLL_H








