/* File: Compreg.cpp
 * Purpose: Contains implementation of the CompositeReg class
 * Author: sasha
 * $Log: compreg.cpp $
 * Revision 2.1  1996/06/10 20:13:45  ssm
 * MarkBeta1AsRev2
 * Revision 1.6  1995/11/22 18:15:59  sasha
 * Revision 1.5  1995/07/29 01:44:06  sasha
 * Included vtoolsd headers
 * Revision 1.4  1995/07/29 01:42:56  SASHA
 * Changed names for LowPart_ to LSBPart_ and for
 * HighPart_ to MSBPart_
 * Revision 1.3  1995/07/24 21:56:24  SASHA
 * Revision for the code review. Should be no changes from previous check-in.
*/
#include "compreg.h"

/* Method: CompositeReg::operator DWORD()
 * Purpose: Performs the read from a composite register
*/
CompositeReg::operator DWORD()
{
   // if write-only return the shadow
   if ( GetRegisterType() == WO )
      return GetShadow();

// obtain the low and high values
   DWORD dwLowBits  = (DWORD)LSBPart_;
   DWORD dwHighBits = (DWORD)MSBPart_;

   // put high part to the proper place
   dwHighBits <<= LowPartWidth_;

   // done !
   return dwHighBits | dwLowBits;
}


/* Method: CompositeReg::operator=
 * Purpose: performs the assignment to a composite register
*/
DWORD CompositeReg::operator=( DWORD dwValue )
{
// if a register is read-only nothing is done. This is an error
   if ( GetRegisterType() == RO )
      return ReturnAllFs();

   // keep a shadow around
   SetShadow( dwValue );
 // compute the mask to apply to the passed value, so it can be...
   DWORD dwMask = ::MakeAMask( LowPartWidth_ );

 // ... assigned to the low portion register
   LSBPart_ = dwValue & dwMask;

   // shift is enough to get the high part
   MSBPart_ = ( dwValue >> LowPartWidth_ );
   return dwValue;
}
