// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Scaler/rcs/s_constr.h 2.2 1997/11/26 06:23:59 rudyl Released $
// $Log: s_constr.h $
// Revision 2.2  1997/11/26 06:23:59  rudyl
// Added support for Scotch but calculating of HDelay is always truncated
// instead of rounding up to even number (until HW fixed).
// Added CBSENSE since both odd and even values are allowed for HDelay.
// Revision 2.1  1996/06/10 20:12:39  ssm
// MarkBeta1AsRev2
// Revision 1.2  1996/05/02 22:10:01  rudyl
// Take care of the problem of VDelay register is reversed in hardware.
// That is odd reg is really even and vice versa.
// Revision 1.1  1996/05/02 16:59:51  rudyl
// Initial revision

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    S_Constr.h
//
//  Abstract:
//
//    Construct register and register fields for Bt848 Scalar Registers
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __S_CONSTR_H
#define __S_CONSTR_H


#define CONSTRUCT_SCALER_REGISTERS( offset ) \
regCROP ( (0x03 * 4) + (offset), RW ) ,\
fieldVACTIVE_MSB( regCROP, 4, 2, RW) ,\
fieldHDELAY_MSB( regCROP, 2, 2, RW) ,\
fieldHACTIVE_MSB( regCROP, 0, 2, RW) ,\
regVACTIVE_LO ( (0x05 * 4) + (offset), RW ) ,\
regHDELAY_LO ( (0x06 * 4) + (offset), RW ) ,\
regHACTIVE_LO ( (0x07 * 4) + (offset), RW ) ,\
regHSCALE_HI ( (0x08 * 4) + (offset), RW ) ,\
fieldHSCALE_MSB( regHSCALE_HI, 0, 8, RW) ,\
regHSCALE_LO ( (0x09 * 4) + (offset), RW ) ,\
regSCLOOP ( (0x10 * 4) + (offset), RW ) ,\
fieldHFILT( regSCLOOP, 3, 2, RW) ,\
regVSCALE_HI ( (0x13 * 4) + (offset), RW ) ,\
fieldVSCALE_MSB( regVSCALE_HI, 0, 5, RW) ,\
regVSCALE_LO ( (0x14 * 4) + (offset), RW ) ,\
regVActive( regVACTIVE_LO, 8, fieldVACTIVE_MSB, RW ),\
regVScale( regVSCALE_LO, 8, fieldVSCALE_MSB, RW ),\
regHDelay( regHDELAY_LO, 8, fieldHDELAY_MSB, RW ),\
regHActive( regHACTIVE_LO, 8, fieldHACTIVE_MSB, RW ),\
regHScale( regHSCALE_LO, 8, fieldHSCALE_MSB, RW ),\
regVTC ( (0x1B * 4) + (offset), RW ) ,\
fieldVFILT( regVTC, 0, 2, RW),\
regCONTROL ( (0x0B * 4) + (offset), RW ) ,\
fieldCBSENSE( regCONTROL, 4, 1, RW)

#endif   // __S_CONSTR_H
