// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/Scaler/rcs/scaler.cpp 2.19 1998/05/29 19:32:51 rudyl Exp $
/////////////////////////////////////////////////////////////////////////////
// $Log: scaler.cpp $
// Revision 2.19  1998/05/29 19:32:51  rudyl
// Fixed: green lines at bottom in PAL mode for full screen.
// Problem was still using 284 lines settings for VActive and VDelay.
// Fix was to change VActive to 0x240 (=576 lines) and VDelay to 0x22.
// Revision 2.18  1998/02/24 22:16:47  rudyl
// Calculation for "Min_UncroppedPixels " modified for digital format only.
// Revision 2.17  1998/01/16 22:00:18  rudyl
// Gemini Rev D: HSFMT changes from 1 to 2 bits.
// Revision 2.16  1997/11/26 06:23:57  rudyl
// Added support for Scotch but calculating of HDelay is always truncated
// instead of rounding up to even number (until HW fixed).
// Added CBSENSE since both odd and even values are allowed for HDelay.
// Revision 2.15  1997/11/03 05:32:51  dtharp
// Moved _QuartzSight reg key to PRK_LOCAL_MACHINE\SOFTWARE\Brooktree\Bt848.
// Revision 2.14  1997/11/01 00:38:23  rudyl
// Graft from 2.13.1.2.
// Revision 2.13.1.2  1997/11/01 00:37:37  rudyl
// Added temp reg key "_QuartzSight" to use different calculation for HDelay register.
// Revision 2.13.1.1  1997/10/21 02:40:34  rudyl
// For QuartzSight demo only.
// Revision 2.13  1997/10/21 00:33:58  rudyl
// Merge 2.7.1.4 & 2.11.
// Revision 2.12  1997/05/14 17:47:04  dtharp
// Made some casts to avoid compiler warnings.
// Revision 2.11  1997/05/06 00:20:50  dtharp
// 848A Merge: Note that this mod originated from 2.9 and includes
// branch 2.7.1.4. Rev 2.10 was found to be a no-go. This present
// mod replaces 2.10 on the tip.
// Revision 2.9  1997/03/18 19:49:51  rudyl
// Graft from 2.8.1.3. Fix PAL YUV9 slow capture problem by using 288 lines in pal 
// and fake VSCALE to generate 1 more line.
// Revision 2.8.1.3  1997/03/18 19:47:42  rudyl
// Fake VSCALE to generate 1 more line to fix pal yuv9 capture problem.
// Revision 2.8.1.2  1997/03/08 02:47:08  rudyl
// Now PAL uses 288 lines per field.
// Revision 2.8.1.1  1997/03/06 20:05:26  rudyl
// Use 288 lines for PAL/SECAM
// Revision 2.8  1996/12/06 22:34:11  meierdw
// Grafted 2.7.1 into trunk; NTSC-Japan support added.
// Revision 2.7.1.2  1996/11/08 18:49:22  rudyl
// Added NTSC-Japan, PAL-M & PAL-N formats.
// Revision 2.7  1996/08/06 20:05:25  rudyl
// HDelay must be even or else color would be wrong.
// Revision 2.6  1996/07/29 05:31:13  sasha
// Modified SetVFilter to see if the VFilterFlag_ is turned off or on.
// This presumably removes junk lines on the top of the video.
// Revision 2.5  1996/07/26 19:41:22  rudyl
// Undo modifying VDelay to get rid of data at top of screen.
// It highlights magenta line at bottom of video in primary surface mode.
// Revision 2.4  1996/07/25 19:58:54  rudyl
// Remove garbage line at top of video by increasing VDelay.
// Revision 2.3  1996/06/26 21:36:03  rudyl
// Added Cropping feature by adjusting HDelay, HActive & VDelay.
// Revision 2.2  1996/06/13 22:45:15  rudyl
// Removed commented out table for old video info.
// Revision 2.1  1996/06/10 20:12:41  ssm
// MarkBeta1AsRev2
// Revision 1.19  1996/05/20 23:45:14  rudyl
// Added support of SECAM except Chroma U & V values need to be changed.
// Deleted Scaler::Set525Lines() but added Scaler::VideoFormatChanged() which is called in Decoder::SetVideoFormat().
// Revision 1.18  1996/05/18 01:58:34  rudyl
// Works for PAL now.
// Changed Set525Lines() and m_525Lines static so Set525Lines() is called in SetVideoFormat() in decoder.cpp
// in order to set up correct register values for different formats.
// Revision 1.17  1996/05/17 17:08:13  rudyl
// Fixed black region sometimes appears on top and/or left problem.
// Revision 1.16  1996/05/15 00:32:59  rudyl
// Calculation of Max_VFilter3_Lines was wrong in the spec;
// should be = Active_lines_per_field * 2 / 5 (not * 5 / 2)
// Revision 1.15  1996/05/13 23:37:37  rudyl
// In SetDigitalWin(), should compare both Height and Width instead of just area of digital window to that of analog window.
// Revision 1.14  1996/05/02 22:10:01  rudyl
// Take care of the problem of VDelay register is reversed in hardware.
// That is odd reg is really even and vice versa.
// Revision 1.13  1996/05/02 16:59:25  rudyl
// Modified to use Register class. Fixed variable scaling problem.
// Revision 1.12  1996/04/22 21:42:47  rudyl
// Added variable scaling. No testing done.
// Revision 1.11  1996/02/01 03:29:02  ssm
// change test for ScaleHardNTSC FULL to 640x240
// Revision 1.10  1996/01/29 02:38:15  sasha
// Changed values for the QCIF and fixed writes to the scaling registers
// Revision 1.9  1996/01/29 00:14:06  ssm
// add ScaleRegStruct & values for NTSC FULL, CIF & QCIF;
// add ScaleHardNTSC method;
// #ifdef out scaling calc calls in Scale, force call to ScaleHardNTSC
// Revision 1.8  1996/01/19 00:32:56  sasha
// Fixed accesses to the array of pointers and pointer declaration
// Revision 1.7  1996/01/17 22:29:04  sasha
// Changed argument from TRect to TRect & to Scaler functions.
// Call Scale from SetDigitalWindow()
// Revision 1.6  1996/01/06 01:42:55  sasha
// Removed inline specifier
// Revision 1.5  1996/01/06 01:36:17  ssm
// stubbed in code from alex's scaler to test interface only
// Revision 1.4  1996/01/06 01:18:34  ssm
// removed implied floats (i.e. [0-9]*\.[0-9]+ )
// Revision 1.3  1996/01/06 00:55:50  ssm
// 1st compile with scaler
// Revision 1.2  1996/01/05 22:19:07  ssm
// 1st compile
// Revision 1.1  1996/01/05 21:03:43  ssm
// Initial revision
/////////////////////////////////////////////////////////////////////////////

#include "Scaler.h"
#include "S_constr.h"
#include "device.h"
#include "dbgprint.h"

//===========================================================================
// Function Prototypes
//===========================================================================
extern bool IsGeminiFamily( void );

// video information for NTSC
VideoInfoStruct NTSCVideoInfo =
{
   730,     // Clkx1_HACTIVE          = 746
   148,     // Clkx1_HDELAY           = 140
   44,      // Min_Pixels             =  44
   240,     // Active_lines_per_field = 240
   144,     // Min_UncroppedPixels    = Min_Pixels + 100
   724,     // Max_Pixels             = ((Clkx1_HACTIVE < 774) ? Clkx1_HACTIVE - 6 : 768)
   32,      // Min_Lines              = (Active_lines_per_field / 16 + 1) * 2
   240,     // Max_Lines              = Active_lines_per_field
   352,     // Max_VFilter1_Pixels    = ((Clkx1_HACTIVE > 796) ? 384 : (Clkx1_HACTIVE * 14 / 29))
   176,     // Max_VFilter2_Pixels    = Clkx1_HACTIVE * 8 / 33
   176,     // Max_VFilter3_Pixels    = Clkx1_HACTIVE * 8 / 33
   240,     // Max_VFilter1_Lines     = Active_lines_per_field
   120,     // Max_VFilter2_Lines     = Active_lines_per_field / 2
   96,      // Max_VFilter3_Lines     = Active_lines_per_field * 2 / 5
   0x1F4,   // VActive
   0x001A,  // VDelay
};

// video information for PAL
VideoInfoStruct PALVideoInfo =
{
   914,     // Clkx1_HACTIVE          = 914
   190,     // Clkx1_HDELAY           = 190
#pragma message("should be 58 per Ben's recommendation")
   48,      // Min_Pixels             =  48
   288,     // Active_lines_per_field = 284
   148,     // Min_UncroppedPixels    = Min_Pixels + 100
   768,     // Max_Pixels             = ((Clkx1_HACTIVE < 774) ? Clkx1_HACTIVE - 6 : 768)
   38,      // Min_Lines              = (Active_lines_per_field / 16 + 1) * 2
   288,     // Max_Lines              = Active_lines_per_field
   384,     // Max_VFilter1_Pixels    = ((Clkx1_HACTIVE > 796) ? 384 : (Clkx1_HACTIVE * 14 / 29))
   221,     // Max_VFilter2_Pixels    = Clkx1_HACTIVE * 8 / 33
   221,     // Max_VFilter3_Pixels    = Clkx1_HACTIVE * 8 / 33
   288,     // Max_VFilter1_Lines     = Active_lines_per_field
   144,     // Max_VFilter2_Lines     = Active_lines_per_field / 2
   115,     // Max_VFilter3_Lines     = Active_lines_per_field * 2 / 5
   0x240,   // VActive
   0x0022,  // VDelay
};

// video information for PAL-Nc
VideoInfoStruct PAL_NCVideoInfo =
{
   744,     // Clkx1_HACTIVE          = 744
   150,     // Clkx1_HDELAY           = 150
   46,      // Min_Pixels             = Ceiling(Clkx1_HACTIVE * 8 / 127)
   288,     // Active_lines_per_field = 284 (same as PAL)
   146,     // Min_UncroppedPixels    = Min_Pixels + 100
   738,     // Max_Pixels             = ((Clkx1_HACTIVE < 774) ? Clkx1_HACTIVE - 6 : 768)
   36,      // Min_Lines              = (Active_lines_per_field / 16 + 1) * 2
   288,     // Max_Lines              = Active_lines_per_field
   359,     // Max_VFilter1_Pixels    = ((Clkx1_HACTIVE > 796) ? 384 : (Clkx1_HACTIVE * 14 / 29))
   180,     // Max_VFilter2_Pixels    = Clkx1_HACTIVE * 8 / 33
   180,     // Max_VFilter3_Pixels    = Clkx1_HACTIVE * 8 / 33
   288,     // Max_VFilter1_Lines     = Active_lines_per_field
   144,     // Max_VFilter2_Lines     = Active_lines_per_field / 2
   113,     // Max_VFilter3_Lines     = Active_lines_per_field * 2 / 5
   0x240,   // VActive
   0x0022,  // VDelay
};

//===========================================================================
// Bt848 Scaler Class Implementation
//===========================================================================

// static member of the class
VideoFormat Scaler::m_videoFormat = VFormat_NTSC;  // assume NTSC
State Scaler::VFilterFlag_ = On;
VideoInfoStruct Scaler::anyVideoInfo = NTSCVideoInfo;  // assume NTSC video signal
SignalFormat Scaler::m_signalFormat = Signal_Analog;  // assume analog signal

/////////////////////////////////////////////////////////////////////////////
// Constructor
/////////////////////////////////////////////////////////////////////////////

Scaler::Scaler( VidField field ):
   CONSTRUCT_SCALER_REGISTERS( ( ( field == VF_Even ) ? 0 : 0x80 ) ),

   // Since VDelay in hardware is reversed; i.e. odd reg is really even field
   // and vice versa, construct the opposite here
   regReverse_CROP ( (0x03 * 4) + ( ( field == VF_Even ) ? 0x80 : 0 ), RW ),
   fieldVDELAY_MSB( regReverse_CROP, 6, 2, RW),
   regVDELAY_LO ( (0x04 * 4) + ( ( field == VF_Even ) ? 0x80 : 0 ), RW ),
   regVDelay( regVDELAY_LO, 8, fieldVDELAY_MSB, RW )
{
   m_HActive = 0;
   m_pixels = 0;
   m_lines = 0;
   m_VFilter = 0;
}


/////////////////////////////////////////////////////////////////////////////
// Destructor
/////////////////////////////////////////////////////////////////////////////
Scaler::~Scaler()
{
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::VideoFormatChanged( VideoFormat format )
// Purpose: Set which video format is using
// Input:   Video format -
//            Auto format:          VFormat_AutoDetect
//            NTSC (M):             VFormat_NTSC
//            NTSC (J):             VFormat_NTSC_J
//            PAL (B, D, G, H, I):  VFormat_PAL_BDGHI
//            PAL (M):              VFormat_PAL_M
//            PAL(N):               VFormat_PAL_N
//            SECAM:                VFormat_SECAM
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::VideoFormatChanged( VideoFormat format )
{
	m_videoFormat = format;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::Scale( TRect & clientScr )
// Purpose: Perform scaling
// Input:   TRect & clientScr - rectangle to scale to
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::Scale( TRect & clientScr )
{
   // setup ptr to point to correct video info structure
   if ( m_signalFormat != Signal_Analog )
      m_ptrVideoIn = &anyVideoInfo;    // digital video signal
   else
   if ( m_videoFormat == VFormat_PAL_NC )
      m_ptrVideoIn = &PAL_NCVideoInfo; // set scaling constants for PAL-Nc
   else
   if ( IsNTSCCompatible( m_videoFormat ) )
      m_ptrVideoIn = &NTSCVideoInfo;   //  set scaling constants for NTSC
   else
      m_ptrVideoIn = &PALVideoInfo;    // set scaling constants for PAL/SECAM

   // the order of functions calling here is important because some
   // calculations are based on previous results
   SetHActive( clientScr );
   SetVActive();

   // New code to fix PAL capture problem. Problem is when capture in YUV9,
   // some sizes capture in very slow process and capture a fraction of the
   // specified time.
   // Fix is to fake VSCALE to generate 1 more line to fix capture problem.
   TRect tempDigWin( clientScr );
   if ( tempDigWin.Height() < m_ptrVideoIn->Max_Lines )
      tempDigWin.bottom++;
   SetVScale( tempDigWin );

   SetVFilter();
   SetVDelay();
   SetHDelay();
   SetHScale();
   SetHFilter();

}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetHActive( TRect & clientScr )
// Purpose: Set HActive register
// Input:   TRect & clientScr - rectangle to scale to
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetHActive( TRect & clientScr )
{
   m_HActive = min( m_ptrVideoIn->Max_Pixels,
                    max( (WORD)clientScr.Width(), m_ptrVideoIn->Min_Pixels ) );

  regHActive = m_HActive;
char s[80];
sprintf( s, "Scaler--> m_HActive = %d (0x%X)\n", m_HActive, m_HActive );
DebugPrint((0, s));
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetHDelay( void )
// Purpose: Set HDelay register
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetHDelay( void )
{
   // calculations here requires calculation of HActive first!
   m_pixels = m_HActive;
   if ( m_pixels < m_ptrVideoIn->Min_UncroppedPixels )
      m_pixels += (WORD) ( ( m_ptrVideoIn->Min_UncroppedPixels - m_pixels + 9 ) / 10 );

   LONG a = (LONG)m_pixels * (LONG)m_ptrVideoIn->Clkx1_HDELAY;
   LONG b = (LONG)m_ptrVideoIn->Clkx1_HACTIVE * 2L;
   WORD HDelay = (WORD) ( ( a + (LONG)m_ptrVideoIn->Clkx1_HACTIVE * 2 - 1) / b * 2L );

   // Gemini Rev D expanded the HReset to handle 16 clk which is what Scotch/QuartzSight needs.
   // If Rev D and beyond is found, truncating calculation is not needed.
   WORD revID = (WORD)PsDevice::GetPsDevice()->getPciCfgHdr()->RevisionID;

   if ( !( IsGeminiFamily() && ( revID >= 0x02 ) ) )  // NOT( Gemini and at least Rev D )
   {
      // if "_QuartzSight" registry key exists and set to 1, use different calculation for HDelay.
      // Actually the only difference is instead of using an even ceiling calculation for HDelay,
      // QuartzSight camera works fine with truncating calculation.
      VRegistryKey vkey( PRK_LOCAL_MACHINE, "SOFTWARE\\Brooktree\\Video" );

      // make sure the key exists
      if ( vkey.lastError() == ERROR_SUCCESS )
      {
         char * QuartzSightKey = "QuartzSight";
         char   key[3];
         DWORD  keyLen = 2;    // need only first char; '0' or '1'

         // get the registry value and check it, if exist
         if ( ( vkey.getSubkeyValue( QuartzSightKey, key, (DWORD *)&keyLen ) ) &&
              ( key[0] == '1' ) )
            HDelay = (WORD) ( (LONG)m_pixels * (LONG)m_ptrVideoIn->Clkx1_HDELAY /
                              (LONG)m_ptrVideoIn->Clkx1_HACTIVE );
      }
   }

   // now add the cropping region into HDelay register; i.e. skip some pixels
   // before we start taking them as real image
   HDelay += (WORD)AnalogWin_.left;

//   // HDelay must be even or else color would be wrong
//   HDelay &= ~01;

   // need to adjust CBSENSE when allowing both odd and even value for HDelay
   fieldCBSENSE = BOOL( HDelay );
   regHDelay = HDelay;

   // since we increase HDelay, we should decrease HActive by the same amount
   m_HActive -= (WORD)AnalogWin_.left;
   regHActive = m_HActive;

char s[80];
sprintf( s, "Scaler--> HDelay = %d (0x%X)   m_HActive = %d (0x%X)\n", HDelay, HDelay, m_HActive, m_HActive );
DebugPrint((0, s));
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetHScale( void )
// Purpose: Set HScale register
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetHScale( void )
{
   regHScale = (WORD) ( ( ( (LONG)m_ptrVideoIn->Clkx1_HACTIVE * 4096L ) /
                                            (LONG)m_pixels ) - 4096L );
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetHFilter( void )
// Purpose: Set HFilt register field
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetHFilter( void )
{
   if ( ( m_signalFormat != Signal_Analog ) ||
        ( m_videoFormat  != VFormat_SECAM ) )
      fieldHFILT = HFilter_AutoFormat;
   else  // SECAM
      if ( m_pixels < m_ptrVideoIn->Clkx1_HACTIVE / 7 )
         fieldHFILT = HFilter_ICON;
      else
         fieldHFILT = HFilter_QCIF;
}         

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetVScale( TRect & clientScr )
// Purpose: Set VScale register
// Input:   TRect & clientScr - rectangle to scale to
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetVScale( TRect & clientScr )
{
   m_lines = min( m_ptrVideoIn->Max_Lines,
                  max( (WORD)clientScr.Height(), m_ptrVideoIn->Min_Lines ) );

   WORD LPB_VScale_Factor = (WORD) ( 1 + ( m_lines - 1 ) / m_ptrVideoIn->Active_lines_per_field );

   m_lines = (WORD) ( ( m_lines + LPB_VScale_Factor - 1 ) / LPB_VScale_Factor );

   LONG a = (LONG)m_ptrVideoIn->Active_lines_per_field * 512L / (LONG)m_lines;
   WORD VScale = (WORD) ( ( 0x10000L - a + 512L ) & 0x1FFFL );
   regVScale = VScale;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetVDelay( void )
// Purpose: Set VDelay register
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetVDelay( void )
{
   WORD VDelay, moreDelay;

   // increase VDelay will eliminate garbage lines at top of image
   switch ( m_VFilter )
   {
      case 3:
         moreDelay = 4;
         break;

      case 2:
         moreDelay = 2;
         break;

      case 1:
      case 0:
      default:
         moreDelay = 0;
         break;
   }

   // VDelay should be increase/decrease by half of VActive's decrease/increase.
   // For example, with PAL signal, increasing VActive from 568 to 576 lines
   // should decrease VDelay from 0x26 to 0x22.
   VDelay = WORD( m_ptrVideoIn->VDelay + moreDelay );

   // now add the cropping region into VDelay register; i.e. skip some pixels
   // before we start taking them as real image
   VDelay += (WORD)( ( (LONG)m_ptrVideoIn->Max_Lines * (LONG)AnalogWin_.top + m_lines - 1 ) / (LONG)m_lines * 2 );

   regVDelay = VDelay;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetVActive( void )
// Purpose: Set VActive register
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetVActive( void )
{
   // No calculation needed for VActive register since it based on the UNSCALED image
   // VActive = number of half lines in a field
   // Settings for PAL: for 284 lines/field -> VActive = 284 * 2; VDelay = 0x26
   //                   for 288 lines/field -> VActive = 288 * 2; VDelay = 0x22
   regVActive = m_ptrVideoIn->VActive;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetVFilter( void )
// Purpose: Set VFilt register field
// Input:   None
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetVFilter( void )
{
   // this is to remove junk lines at the top of video. flag set to off
   // when image hight is above CIF
   if ( VFilterFlag_ == Off ) {
      fieldVFILT = 0;
      m_VFilter  = 0;
      return;
   }
   if ( ( m_HActive <= m_ptrVideoIn->Max_VFilter3_Pixels ) &&
        ( m_lines   <= m_ptrVideoIn->Max_VFilter3_Lines ) )
      m_VFilter = 3;
   else if ( ( m_HActive <= m_ptrVideoIn->Max_VFilter2_Pixels ) &&
             ( m_lines   <= m_ptrVideoIn->Max_VFilter2_Lines ) )
      m_VFilter = 2;
   else if ( ( m_HActive <= m_ptrVideoIn->Max_VFilter1_Pixels ) &&
             ( m_lines   <= m_ptrVideoIn->Max_VFilter1_Lines ) )
      m_VFilter = 1;
   else
      m_VFilter = 0;

   fieldVFILT = m_VFilter;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::GetDigitalWin( TRect &DigWin ) const
// Purpose: Retreives the size of digital window
// Input:   None
// Output:  TRect &DigWin - retrieved value
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::GetDigitalWin( TRect &DigWin ) const
{
   DigWin = DigitalWin_;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Scaler::SetDigitalWin( const TRect &DigWin )
// Purpose: Sets the size and location of the digital window
// Input:   const TRect &DigWin - window size to set to
// Output:  None
// Return:  Success or Fail if passed rect is bigger then analog window
// Note:    This function can affect the scaling, so Scale() is called
/////////////////////////////////////////////////////////////////////////////
ErrorCode Scaler::SetDigitalWin( const TRect &DigWin )
{
   // we can not scale up
   if ( ( DigWin.Height() > AnalogWin_.Height() ) ||
        ( DigWin.Width() > AnalogWin_.Width() ) )
      return Fail;

   DigitalWin_ = DigWin;

   // every invocation of SetDigitalWin potentially changes the scaling
   Scale( DigitalWin_ );

   return Success;
}


/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::GetAnalogWin( TRect &AWin ) const
// Purpose: Retreives the size of analog window
// Input:   None
// Output:  TRect &DigWin - retrieved value
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::GetAnalogWin( TRect &AWin ) const
{
   AWin = AnalogWin_;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  ErrorCode Scaler::SetAnalogWin( const TRect &AWin )
// Purpose: Sets the size and location of the analog window
// Input:   const TRect &AWin - window size to set to
// Output:  None
// Return:  Success or Fail if passed rect is bigger then analog window
/////////////////////////////////////////////////////////////////////////////
ErrorCode Scaler::SetAnalogWin( const TRect &AWin )
{
   AnalogWin_ = AWin;
   return Success;
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetVideoInfo( VideoInfo info )
// Purpose: Set generic video info
// Input:   VideoInfo info - video specific parameters, contains:
//             WORD HActive
//             WORD HDelay
//             WORD VActive;
//             WORD VDelay;
//             WORD activeLinesPerField
// Output:  None
// Return:  None
// Note:    This function provides a way to scale any video signal with
//          the video information passed in as formal paremeters
//          Currently this is only being used for digital signals only.
//          In order to be truly generic which allows to pass in both analog
//          and digital parameters, Min_UncroppedPixels should be calculated
//          differently depends on whether the signal is analog or digital.
/////////////////////////////////////////////////////////////////////////////
void Scaler::SetVideoInfo( VideoInfo info )
{
   // setup parameters passed in
   anyVideoInfo.Clkx1_HACTIVE          = WORD( max( 1, info.HActive ) );
   anyVideoInfo.Clkx1_HDELAY           = WORD( max( 1, info.HDelay ) );
   anyVideoInfo.VActive                = WORD( max( 1, info.VActive ) );
   anyVideoInfo.VDelay                 = WORD( max( 1, info.VDelay ) );
   anyVideoInfo.Active_lines_per_field = WORD( max( 1, info.linesPerField ) );

   // compute the rest of the video info
   anyVideoInfo.Min_Pixels             = WORD( anyVideoInfo.Clkx1_HACTIVE * 8 / 127 );

   // For digital signal (like camera), data are very stable and there is no need to
   // add extra pixels for cushion.
   //   anyVideoInfo.Min_UncroppedPixels    = WORD( anyVideoInfo.Min_Pixels + 100 );
   anyVideoInfo.Min_UncroppedPixels    = WORD( anyVideoInfo.Min_Pixels );

   // For analog signal (which goes through the decoder), 6 is subtracted from the Clkx1_HACTIVE
   // so we won't ask for "too many" pixels occasionally depends on the signal.
   // With digital signal (which does not go through decoder and is very stable), nothing is subtracted
   // from Clkx1_HACTIVE so we get maximum number of pixels from the camera
   anyVideoInfo.Max_Pixels             = WORD( ((anyVideoInfo.Clkx1_HACTIVE < 774) ? anyVideoInfo.Clkx1_HACTIVE : 768) );
   anyVideoInfo.Min_Lines              = WORD( (anyVideoInfo.Active_lines_per_field / 16 + 1) * 2 );
   anyVideoInfo.Max_Lines              = WORD( anyVideoInfo.Active_lines_per_field );
   anyVideoInfo.Max_VFilter1_Pixels    = WORD( ((anyVideoInfo.Clkx1_HACTIVE > 796) ? 384 : (anyVideoInfo.Clkx1_HACTIVE * 14 / 29)) );
   anyVideoInfo.Max_VFilter2_Pixels    = WORD( anyVideoInfo.Clkx1_HACTIVE * 8 / 33 );
   anyVideoInfo.Max_VFilter3_Pixels    = WORD( anyVideoInfo.Clkx1_HACTIVE * 8 / 33 );
   anyVideoInfo.Max_VFilter1_Lines     = WORD( anyVideoInfo.Active_lines_per_field );
   anyVideoInfo.Max_VFilter2_Lines     = WORD( anyVideoInfo.Active_lines_per_field / 2 );
   anyVideoInfo.Max_VFilter3_Lines     = WORD( anyVideoInfo.Active_lines_per_field * 2 / 5 );

char s[80];
sprintf( s, "Scaler--> Clkx1_HACTIVE          = %d (0x%X)\n", anyVideoInfo.Clkx1_HACTIVE         , anyVideoInfo.Clkx1_HACTIVE          ); DebugPrint((0, s));
sprintf( s, "Scaler--> Clkx1_HDELAY           = %d (0x%X)\n", anyVideoInfo.Clkx1_HDELAY          , anyVideoInfo.Clkx1_HDELAY           ); DebugPrint((0, s));
sprintf( s, "Scaler--> VActive                = %d (0x%X)\n", anyVideoInfo.VActive               , anyVideoInfo.VActive                ); DebugPrint((0, s));
sprintf( s, "Scaler--> VDelay                 = %d (0x%X)\n", anyVideoInfo.VDelay                , anyVideoInfo.VDelay                 ); DebugPrint((0, s));
sprintf( s, "Scaler--> Active_lines_per_field = %d (0x%X)\n", anyVideoInfo.Active_lines_per_field, anyVideoInfo.Active_lines_per_field ); DebugPrint((0, s));
sprintf( s, "Scaler--> Min_Pixels             = %d (0x%X)\n", anyVideoInfo.Min_Pixels            , anyVideoInfo.Min_Pixels             ); DebugPrint((0, s));
sprintf( s, "Scaler--> Min_UncroppedPixels    = %d (0x%X)\n", anyVideoInfo.Min_UncroppedPixels   , anyVideoInfo.Min_UncroppedPixels    ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_Pixels             = %d (0x%X)\n", anyVideoInfo.Max_Pixels            , anyVideoInfo.Max_Pixels             ); DebugPrint((0, s));
sprintf( s, "Scaler--> Min_Lines              = %d (0x%X)\n", anyVideoInfo.Min_Lines             , anyVideoInfo.Min_Lines              ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_Lines              = %d (0x%X)\n", anyVideoInfo.Max_Lines             , anyVideoInfo.Max_Lines              ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter1_Pixels    = %d (0x%X)\n", anyVideoInfo.Max_VFilter1_Pixels   , anyVideoInfo.Max_VFilter1_Pixels    ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter2_Pixels    = %d (0x%X)\n", anyVideoInfo.Max_VFilter2_Pixels   , anyVideoInfo.Max_VFilter2_Pixels    ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter3_Pixels    = %d (0x%X)\n", anyVideoInfo.Max_VFilter3_Pixels   , anyVideoInfo.Max_VFilter3_Pixels    ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter1_Lines     = %d (0x%X)\n", anyVideoInfo.Max_VFilter1_Lines    , anyVideoInfo.Max_VFilter1_Lines     ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter2_Lines     = %d (0x%X)\n", anyVideoInfo.Max_VFilter2_Lines    , anyVideoInfo.Max_VFilter2_Lines     ); DebugPrint((0, s));
sprintf( s, "Scaler--> Max_VFilter3_Lines     = %d (0x%X)\n", anyVideoInfo.Max_VFilter3_Lines    , anyVideoInfo.Max_VFilter3_Lines     ); DebugPrint((0, s));
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::GetVideoInfo( VideoInfo *pInfo )
// Purpose: Get generic video info
// Input:   None
// Output:  VideoInfo * pInfo - ptr to video specific parameters, contains:
//             WORD HActive
//             WORD HDelay
//             WORD VActive;
//             WORD VDelay;
//             WORD activeLinesPerField
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::GetVideoInfo( VideoInfo * pInfo )
{
   // Cannot reference m_ptrVideoIn since it get initialized only when
   // Scaler::Scale() is called but this function could be called before that.
   VideoInfoStruct * ptrInfo;

   if ( m_signalFormat != Signal_Analog )
      ptrInfo = &anyVideoInfo;    // digital video signal
   else
   if ( m_videoFormat == VFormat_PAL_NC )
      ptrInfo = &PAL_NCVideoInfo; // PAL-Nc
   else
   if ( IsNTSCCompatible( m_videoFormat ) )
      ptrInfo = &NTSCVideoInfo;   // NTSC
   else
      ptrInfo = &PALVideoInfo;    // PAL/SECAM

   *pInfo = VideoInfo( ptrInfo->Clkx1_HACTIVE,
                       ptrInfo->Clkx1_HDELAY,
                       ptrInfo->VActive,
                       ptrInfo->VDelay,
                       ptrInfo->Active_lines_per_field );
}

/////////////////////////////////////////////////////////////////////////////
// Method:  void Scaler::SetSignalFormat( SignalFormat format )
// Purpose: Set video signal format
// Input:   Video signal formats:
//            Signal_Analog         - Analog
//            Signal_CCIR656        - CCIR 656
//            Signal_ByteStream     - ByteStream
//            Signal_ExtHSYNC_VSYNC - External HSYNC, VSYNC
//            Signal_ExtHSYNC_FIELD - External HSYNC, FIELD
// Output:  None
// Return:  None
/////////////////////////////////////////////////////////////////////////////
void Scaler::SignalFormatChanged( SignalFormat format )
{
   m_signalFormat = format;
}
