/////////////////////////////////////////////////////////////////////////////
// $Header: G:/SwDev/W95/Video/pisces/dvlpmnt/TimGen/rcs/TimGen.h 1.2 1997/02/04 18:36:40 rudyl Released $
// $Log: TimGen.h $
// Revision 1.2  1997/02/04 18:36:40  rudyl
// First Pisces+ check in.
// Revision 1.1  1996/08/22 00:23:30  rudyl
// Initial revision
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//
//  Copyright 1996 Brooktree Corporation
//
//  Module:
//
//    TimGen.h
//
//  Abstract:
//
//    Header file for Bt848A/Bt849 Timing Generator Registers
//
/////////////////////////////////////////////////////////////////////////////


#ifndef __TIMGEN_H
#define __TIMGEN_H

#ifdef VXD
#include <vtoolscp.h>
#endif

#undef FAR

#include "regField.h"
#include "viddefs.h"
#include "retcode.h"


/////////////////////////////////////////////////////////////////////////////
// CLASS TimGen
//
// Description:
//    This class encapsulates the Timing Generator Control register in the
//    Bt848A/Bt849.
//
// Methods:
//    See below
//
// Note:
//
/////////////////////////////////////////////////////////////////////////////

class TimGen
{
	public:
      #include "t_declar.h"

		TimGen( void );
		~TimGen();

      virtual ErrorCode       LoadSRAM( PBYTE fp, int nBytes );
      virtual ErrorCode       ReadSRAM( PBYTE p, int nBytes );
      virtual void            EnableTimGenVideoMode( bool mode );
      virtual bool            IsTimGenVideoModeEnabled( void );
      virtual void            TimGenAddrReset( void );
      virtual void            IncrTimGenReadAddr( void );
      virtual ErrorCode       SetDecoderInputClock( DecInputClk clk );
      virtual int             GetDecoderInputClock( void );
      virtual ErrorCode       SetGPCLKOutputClock( GPCLKOutputClk clk );
      virtual int             GetGPCLKOutputClock( void );
      virtual int             BytesInSRAM( void ) { return bytesInSRAM; }

   private:
      int bytesInSRAM;     // number of bytes loaded in the SRAM
};


#endif __TIMGEN_H








