/* util_16.cpp
 * Purpose: Implementation of 16-bit registry access helper fns.
 * Author: peter
 * $Log: util_16.cpp $
 * Revision 1.7  1997/12/12 23:58:09  peter
 * Fixed REG_BINARY problem.
 * Revision 1.6  1997/12/11 17:11:22  peter
 * Added REG_BINARY support to btutil*.dll.
 * Revision 1.5  1997/12/09 17:40:41  peter
 * Fixed 16/32-bit thunking exception upon startup bug.
 * Revision 1.4  1997/12/04 17:01:40  peter
 * Added RCS comment strings.
 * Initial revision
 */



#include "util_16.h"
#include "dbgprint.h"

extern "C" 
{
int  WINAPI Thunk_RegUtilCreateKey( LPCSTR );
int  WINAPI Thunk_RegUtilQueryValue( LPCSTR, LPSTR, LPLONG );
int  WINAPI Thunk_RegUtilSetValue( LPCSTR, LPCSTR );
int  WINAPI Thunk_RegUtilQueryBinValue( int*, LPSTR, LPCSTR, LPCSTR );
int  WINAPI Thunk_RegUtilSetBinValue( int, LPSTR, LPCSTR, LPCSTR );
BOOL WINAPI UTIL_ThunkConnect16( LPSTR, LPSTR, WORD, DWORD );
}

#include <stdio.h>

extern "C" BOOL WINAPI _export DllEntryPoint( DWORD dwReason, WORD hInst, WORD, WORD, DWORD, WORD )
{
   //DebugPrint(( 0, "BtUtil16.dll: DllEntryPoint(): dwReason = 0x%08X\nhInst = 0x%04X\n", dwReason, hInst ) );

	if ( !UTIL_ThunkConnect16( "btutil16.dll", "btutil32.dll", hInst, dwReason ) )
	{
		DebugPrint(( 0, "BtUtil16.dll: DllEntryPoint() done FALSE\n" ));
		return FALSE;
	}
	else
	{
		//DebugPrint(( 0, "BtUtil16.dll: DllEntryPoint() done TRUE\n" ));
	}
	return TRUE;
}



int __export  WINAPI RegUtilCreateKey( LPCSTR szKeyName )
{
	return Thunk_RegUtilCreateKey( szKeyName );
}

int __export  WINAPI RegUtilQueryValue( LPCSTR szKeyName, LPSTR szValue, LPLONG plSize )
{
	return Thunk_RegUtilQueryValue( szKeyName, szValue, plSize );
}

int __export  WINAPI RegUtilSetValue( LPCSTR szKeyName, LPCSTR szValue )
{
	return Thunk_RegUtilSetValue( szKeyName, szValue );
}

int __export  WINAPI RegUtilQueryBinValue( int* plSize, LPSTR cbData, LPCSTR szKeyName, LPCSTR szValueName )
{
	return Thunk_RegUtilQueryBinValue( plSize, cbData, szKeyName, szValueName );
}

int __export  WINAPI RegUtilSetBinValue( int lSize, LPSTR cbData, LPCSTR szKeyName, LPCSTR szValueName )
{
	return Thunk_RegUtilSetBinValue( lSize, cbData, szKeyName, szValueName );
}
