/* util_32.h
 * Purpose: Header of 32-bit registry access helper fns.
 * Author: peter
 * $Log: util_32.h $
 * Revision 1.7  1997/12/12 23:57:59  peter
 * Fixed REG_BINARY problem.
 * Revision 1.6  1997/12/11 17:12:19  peter
 * Added REG_BINARY support to btutil*.dll.
 * Revision 1.5  1997/12/09 17:39:13  peter
 * Fixed 16/32-bit thunking exception upon startup bug.
 * Revision 1.4  1997/12/04 17:02:02  peter
 * Added RCS comment strings.
 * Initial revision
 */

#ifndef __UTIL_32_H
#define __UTIL_32_H

#include "def__.h"        // define __BT848CLASS & __BT848FUNC

#ifndef BYTE
   typedef unsigned char       BYTE;
#endif

#ifdef __BORLANDC__
   #ifndef CLASSLIB_DEFS_H
   #include <classlib/defs.h>
   #endif
#else	// Microsoft 
   #define bool		BOOL
   #define true 	TRUE
   #define false 	FALSE
#endif

#ifndef __WINDOWS_H
#include <windows.h>
#endif


#ifdef __cplusplus
extern "C"
{
#endif

int		__BT848FUNC RegUtilCreateKey32( LPCSTR );
int		__BT848FUNC RegUtilQueryValue32( LPCSTR, LPSTR, LPLONG );
int		__BT848FUNC RegUtilSetValue32( LPCSTR, LPCSTR );
int		__BT848FUNC RegUtilQueryBinValue32( int*, LPSTR, LPCSTR, LPCSTR );
int		__BT848FUNC RegUtilSetBinValue32( int, LPSTR, LPCSTR, LPCSTR );

#ifdef __cplusplus
}
#endif

#endif	// __UTIL_32_H

