# vtoolsd.mak
#
# Master makefile for VtoolsD examples
# Copyright (c) 1994 Vireo Software, Inc.
#
#########################################################################
# NMAKE Symbols and Environment Variables
#
#########################################################################
#
#   The following symbol should be defined in the environment:
#
#     VTOOLSD	Directory where VtoolsD is installed
#
#   Vireo recommends defining VTOOLSD in your autoexec.bat file
#

! ifdef VTOOLSDISPRESENT
!	error VTOOLSD.MAK included twice in makefile
! endif

VTOOLSDISPRESENT = 1


!include .\USER.MAK

INCLUDEVXD	= $(VTOOLSD)\INCLUDE;$(INCVXD2)
SEGFILE		= $(VTOOLSD)\include\default.seg
SEGALIAS	= $(VTOOLSD)\bin\segalias

.SUFFIXES: .c .cpp .asm .obj 

#########################################################################
#
#		Allow lower case TARGET definitions
#
#########################################################################


TARGET	=	WIN95


! if "$(TARGET)" ==  "win95"
TARGET		= WIN95
! endif

! if "$(TARGET)" ==  "win31"
TARGET		= WIN31
! endif

! if "$(TARGET)" ==  "wfw311"
TARGET		= WFW311
! endif



#########################################################################
#
#		Make DEBUG, DYNAMIC, and NDIS canonical (0 or 1)
#
#########################################################################

! ifndef DEBUG
DEBUG = 0
! endif

! ifndef DYNAMIC
DYNAMIC = 0
! endif

! if "$(DYNAMIC)" != "0"
DYNAMIC = 1
DYNASWITCH	= DYNAMIC
! else
DYNASWITCH	=
! endif

! if $(DYNAMIC) == 1
! if "TARGET"== "WIN31"
!    error Dynamic VxDs not available for Windows 3.1
! endif
! endif

! ifndef NDIS
NDIS = 0
! endif
! if "$(NDIS)" != "0"
NDIS = 1
! endif
! if "$(TARGET)" == "WIN31"
NDIS = 0
! endif

#########################################################################
#
#		Select compiler
#
#########################################################################

! if "$(COMPILER)" == "MS8"
INCMAKE_1 = $(VTOOLSD)\INCLUDE\MS8.MAK
INCMAKE_2 = $(VTOOLSD)\INCLUDE\MS8VXD.MAK
! endif


! if "$(COMPILER)" == "MS9"
INCMAKE_1 = $(VTOOLSD)\INCLUDE\MS9.MAK
INCMAKE_2 = $(VTOOLSD)\INCLUDE\MS9VXD.MAK
! endif


! if "$(COMPILER)" == "BC4"
INCMAKE_1 = .\BC4.MAK
INCMAKE_2 = .\BC4VXD.MAK
! endif

! ifndef INCMAKE_1
!	error COMPILER must be defined to MS8, MS9, or BC4
! endif

! include $(INCMAKE_1)

#########################################################################
#
#		Select debugger (symbol mapper)
#
#########################################################################


!ifndef MSYM
MSYM = $(VTOOLSD)\bin\notfound MSYM.EXE "Nu-Mega's msym.exe utility"
! endif


!   if "$(DEBUGGER)" == "WDEB386"
MAKESYM		= $(VTOOLSD)\bin\mapsym $(MAPNAME)
!   endif

!   if "$(DEBUGGER)" == "SOFTICE"
MAKESYM		= $(MSYM) $(MAPNAME)
!   endif


#########################################################################
#
#		Select target devicetype
#
#########################################################################

!ifndef DEVICETYPE
DEVICETYPE	= VXD
!endif
__DEVICE_TYPE_DEFINED	= 0


#########################################################################

!   if "$(DEVICETYPE)" == "PORTDRIVER"
TARGNAME	= $(DEVICENAME).PDR
__DEVICE_TYPE_DEFINED	= 1
!   endif


!   if "$(DEVICETYPE)" == "VXD"
TARGNAME	= $(DEVICENAME).VXD
__DEVICE_TYPE_DEFINED	= 1
!   endif


! if "$(__DEVICE_TYPE_DEFINED)" == "0"
!	error DEVICETYPE must be VXD or PORTDRIVER
! endif

#########################################################################









