# vxdtarg.mak
#
# Master makefile for VtoolsD examples
# Copyright (c) 1994 Vireo Software, Inc.

#########################################################################
#		Error checking:
#

!ifndef VTOOLSDISPRESENT
!	error VTOOLSD.MAK must be included before VXDTARG.MAK
!endif

!ifndef DEVICENAME
!	error DEVICENAME must be defined before including VXDTARG.MAK
!endif

!ifndef OBJECTS
!	error OBJECTS must be defined before including VXDTARG.MAK
!endif

!ifndef FRAMEWORK
!	error FRAMEWORK must be defined before including VXDTARG.MAK
!endif

!if "$(FRAMEWORK)" != "C"
!if "$(FRAMEWORK)" != "CPP"
!	error FRAMEWORK must be C or CPP
!endif
!endif


#########################################################################
#
#	The VxD output file is dependent on the object files and the 
#	.DEF file.  The .DEF file is generated automatically by NMAKE.

VERSUFFIX	= 40
CLSFWSUFFIX	= 40


! if $(DEBUG) != 0
DEBUGSUFFIX	= D
! else
DEBUGSUFFIX	=
! endif

LIBSUFFIX	= $(COMPILER)$(VERSUFFIX)$(DEBUGSUFFIX)


! if "$(FRAMEWORK)" == "C"
FWLIB		= $(VTOOLSD)\lib\cf$(LIBSUFFIX).lib
! endif

! if "$(FRAMEWORK)" == "CPP"
FWLIB		= $(VTOOLSD)\lib\cl$(COMPILER)$(CLSFWSUFFIX)$(DEBUGSUFFIX).lib
! endif

CRTLIB		= $(VTOOLSD)\lib\rt$(LIBSUFFIX).lib
NDISLIB		= $(VTOOLSD)\lib\nd$(LIBSUFFIX).lib

# no debug lib for wraps
#
W0		= $(VTOOLSD)\lib\wr0$(COMPILER)$(VERSUFFIX).lib
W1		= $(VTOOLSD)\lib\wr1$(COMPILER)$(VERSUFFIX).lib
W2		= $(VTOOLSD)\lib\wr2$(COMPILER)$(VERSUFFIX).lib
W3		= $(VTOOLSD)\lib\wr3$(COMPILER)$(VERSUFFIX).lib


! include $(INCMAKE_2)

################################################################
#
#		Delete derivative files for clean builds
#

clean:
	del *.ob?
	del *.exe
	del *.map
	del *.sym
	del $(DEVICENAME).def
	del *.vxd
	del *.386
	del *.exp
	del *.lib
	del *.pel
	del *.rsp
