# BC4.MAK
#
# Master makefile for Borland BC4 builds
# Copyright (c) 1994-1996 Vireo Software, Inc.
#

LOCKFLAGS	= -DDEFSEG=1 -zC_LTEXT -zALCODE -zR_LDATA -zTLCODE
INITFLAGS	= -DDEFSEG=2 -zC_ITEXT -zAICODE -zR_IDATA -zTICODE
PAGEABLEFLAGS	= -DDEFSEG=3 -zC_PTEXT -zAPCODE -zR_PDATA -zTPDATA
STATICFLAGS	= -DDEFSEG=4 -zC_STEXT -zASCODE -zR_SDATA -zTSCODE
DEBUGFLAGS	= -DDEFSEG=5 -zC_DBOTEXT -zDBOCODE -zR_DBODATA -zTDBOCODE

! ifndef COPTFLAGS
COPTFLAGS	= -Ox -Oa
! endif

! ifndef CFLAGS
CFLAGS		= -RT- -x- -c $(COPTFLAGS) -Oi -DIS_32 -DWANTVXDWRAPS -DVTOOLSD -I$(INCLUDEVXD)
! endif

! if "$(COMPILER)" == "BC5"
CFLAGS		= $(CFLAGS) -VC
! endif


! ifndef ASMFLAGS
ASMFLAGS	= -m9 -mx -d__BORLANDC__=1 -I$(VTOOLSD)\INCLUDE -I$(VTOOLSD)\LIB\INCLUDE
! endif

ASMDEBUG	= -DDEBUG -zd
CDEBUG		= -DDEBUG -y

CLEAR		= $(VTOOLSD)\bin\clear

! if $(DEBUG) != 0
CFLAGS		= $(CFLAGS) $(CDEBUG)
ASMFLAGS	= $(ASMFLAGS) $(ASMDEBUG)
! endif


! ifdef OBJPATH
!   ifndef SOURCEPATH
SOURCEPATH = .
!   endif
! endif



CFLAGS		= $(CFLAGS) -DWIN40
ASMFLAGS	= $(ASMFLAGS) -DWIN40

CFLAGS = $(CFLAGS) $(XFLAGS)
ASMFLAGS = $(ASMFLAGS) $(XAFLAGS)


{$(SOURCEPATH)}.c{$(OBJPATH)}.obj:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

.c.obj:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obj:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

.cpp.obj:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.c{$(OBJPATH)}.obl:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obl:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(LOCKFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@


{$(SOURCEPATH)}.c{$(OBJPATH)}.obi:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(INITFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obi:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(INITFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.c{$(OBJPATH)}.obs:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(STATICFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obs:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(STATICFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@


{$(SOURCEPATH)}.c{$(OBJPATH)}.obd:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(DEBUGFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obd:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(DEBUGFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@


{$(SOURCEPATH)}.c{$(OBJPATH)}.obp:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(PAGEABLEFLAGS) -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@

{$(SOURCEPATH)}.cpp{$(OBJPATH)}.obp:
	$(CLEAR)
	$(C32) @&&|
$(CFLAGS) $(PAGEABLEFLAGS) -ps -o$@ $<
|
	$(SEGALIAS) -p $(SEGFILE) $@


{$(SOURCEPATH)}.asm{$(OBJPATH)}.obj:
	$(CLEAR)
	$(TASM32) @&&|
$(ASMFLAGS) -I$(VTOOLSD)\include
| $<, $@
