/* File: PISCES.h
 * Purpose: Defines the VxD PISCES classes
 * Author: sasha
 * $Log: device.h $
 * Revision 2.26  1998/04/03 05:32:48  dtharp
 * Merge DT_VIDEOHDR branch. Implements a new buffer 
 * management scheme.
 * Revision 2.25  1998/03/28 03:21:12  rudyl
 * Added BtScotch class object.
 * Revision 2.24  1998/03/13 00:10:40  dtharp
 * Renamed variable TrueViewMode to QuartzSightMode
 * Revision 2.23  1998/03/12 23:46:16  dtharp
 * Removed dead member variable "FullSizeQue_" to reduce confusion.
 * Revision 2.22  1998/03/12 00:55:39  dtharp
 * Merged HP8180 shutdown fix.
 * Revision 2.21  1998/02/27 18:18:43  dtharp
 * Capture Controler constructor now takes devID as a param.
 * Revision 2.20  1998/02/24 21:14:49  rudyl
 * Merged 2.18.2.2 & 2.19.
 * Revision 2.18.2.2  1998/02/24 21:12:35  rudyl
 * Added SetVScaleMode() and GetVScaleMode().
 * Revision 2.18.2.1  1997/10/29 18:37:30  rudyl
 * Duplicate revision
 * Revision 2.19  1998/02/24 17:57:13  dtharp
 * Merge VVL AEC Code
 * Revision 2.18.1.2  1998/02/10 03:38:13  dtharp
 * Added VVL read and write functions. Also added vxd debug interface.
 * Revision 2.18  1997/10/29 18:37:30  dtharp
 * Merged TrueView branch.
 * Revision 2.17.1.1  1997/10/28 16:07:27  dtharp
 * TrueView Branch
 * Revision 2.17  1997/10/21 00:39:03  rudyl
 * Added support to expected total line count by decoder.
 * Revision 2.16  1997/09/04 22:46:04  dtharp
 * Merged VSYNC Callback changes
 * Revision 2.15.1.1  1997/08/21 01:38:55  dtharp
 * Branch for vsync callback
 * Revision 2.15  1997/07/23 18:38:45  dtharp
 * Added getPciCfgHdr() access method.
 * Revision 2.14  1997/07/22 15:36:17  dtharp
 * Added FNGetPciHdr functionality via DevIOCtl and VxD Service.
 * Revision 2.13  1997/07/21 23:19:47  dtharp
 * Fix for Bug ID 675: Suspend/Resume IRQ problems.
 * Revision 2.12  1997/06/20 20:30:16  dtharp
 * Intel VBI Mods; reworked oversample selection, added call to VBISetMostParams()
 * Revision 2.11  1997/06/17 22:19:08  dtharp
 * Modification for Intel Intercast VBI. 
 * Revision 2.10.1.1  1997/06/10 17:56:55  dtharp
 * Branch for new Buffer mgmnt scheme.
 * Revision 2.10  1997/05/02 23:54:10  dtharp
 * 848A Merge: from 2.7.2.3
 * Revision 2.9  1997/04/25 16:48:36  dtharp
 * Grafted WST Interface branch (2.8.1.1).
 * Revision 2.8.1.1  1997/04/03 16:49:06  dtharp
 * Modifications to support WST interface.
 * Revision 2.8  1997/04/02 00:20:55  dtharp
 * Grafted ReadConfig branch (driver reads and stores DevId and 
 * Revision info from PCI config space).
 * Revision 2.7.4.1  1997/03/31 18:19:52  dtharp
 * Added ststic vars wDevId_ and byRev_.
 * Revision 2.7  1996/10/25 00:35:21  sasha
 * Removed SetRate() member function ( not needed ).
 * Revision 2.6  1996/10/02 05:20:24  sasha
 * Changed #defines to BT848 from PISCES. Added APIs to set ring 0
 * I2C and GPIO callbacks.
 * Revision 2.5  1996/09/07 07:15:56  sasha
 * Added a bool argument to the AssignQuePointer()
 * Revision 2.4  1996/07/19 01:42:53  rudyl
 * Fixed DOS box completely covered video freeze problem.
 * Revision 2.3  1996/06/17 21:07:45  sasha
 * Added OnSetDeviceFocus() to the PsVM class.
 * Revision 2.2  1996/06/15 00:00:31  sasha
 * Added OnCreateVM() to PsDevice. Updated PsVM to process destroy message
 * Revision 2.1  1996/06/10 20:12:49  ssm
 * MarkBeta1AsRev2
 * Revision 1.13  1996/05/14 23:59:29  ssm
 * move 1.12.1.3 to head
 * Revision 1.12.1.3  1996/05/14 18:32:10  sasha
 * Added VBIDecoderInited_ member
 * Revision 1.12.1.2  1996/05/12 00:29:24  sasha
 * Added functions to work with VBI channels from ring3. Added functions that
 * check for validity of a video channel
 * Revision 1.12.1.1  1996/05/11 01:22:08  sasha
 * Revision 1.12  1996/04/26 22:33:20  sasha
 * Removed BufferList. Added IsInited()
 * Revision 1.11  1996/04/22 18:02:22  sasha
 * Added SetRate() and power events function
 * Revision 1.10  1996/03/29 20:25:16  sasha
 * Added bunch of decoder Get...() functions.
 * Revision 1.9  1996/03/26 18:48:42  sasha
 * Added VBISetChannel() function
 * Revision 1.8  1996/03/21 23:57:42  sasha
 * Added support for detecting full-screen dos boxes and stopping Pisces
 * Revision 1.7  1996/03/15 23:05:40  sasha
 * Changed types of the VBI buffers to PVOID
 * Revision 1.6  1996/03/05 00:41:48  sasha
 * Removed timer class. Added members for the VBI buffers. Added set of
 * VBI capture functions.
 * Revision 1.5  1996/02/19 02:36:51  sasha
 * Added VBI channels
 * Revision 1.4  1996/02/08 23:40:07  sasha
 * Changed SetClipping()'s prototype
 * Revision 1.3  1996/02/06 01:48:26  sasha
 * Deleted timer code. Made Finish() out-of line. Added CreateCaptureController()
 * Revision 1.2  1996/01/23 00:01:31  sasha
 * Added decoder functions
 * Revision 1.1  1995/09/08 00:18:56  sasha
 * Initial revision
 */

#ifndef __DEVICE_H
#define __DEVICE_H

#include <vtoolscp.h>

#undef FAR
#define _WINNT_

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __PISCES_H
#include "pisces.h"
#endif

#ifndef __GEMINI_H
#include "gemini.h"
#endif

#ifndef __SCOTCH_H
#include "scotch.h"
#endif

#ifndef __MYTYPES_H
#include "mytypes.h"
#endif

#ifndef __VXDVIDCH_H
#include "vxdvidch.h"
#endif

#include "session.h"

#include "vxdfunc.h"

#include "vxdid.h"

#include "pspagebl.h"

#define DEVICE_CLASS           PsDevice
#define BT848_Init_Order       UNDEFINED_INIT_ORDER
#define BT848_Major            1
#define BT848_Minor            0

typedef enum {CHANNEL_CHANGE, VIDEO_FORMAT_CHANGE } VBI_CHANGE_TYPE ;
typedef enum {VBI_INTERNAL, VBI_INTERCAST, VBI_WST } VBI_INITIATOR_TYPE ;


/* Class: PsInterrupt
 * Purpose: Hooks HW interrupt generated by BtPisces
 */
class PsInterrupt : public VHardwareInt
{
   public:
      PsInterrupt( int irq );
      virtual VOID OnHardwareInt( VMHANDLE );
};

extern PsInterrupt      *HWInt;

/* Type: VBI_PARMS
 * Purpose: Contains information about current VBI data consumer
 */
typedef struct tagVBI_PARMS
{
   DWORD dwDecoder;
   DWORD dwChange;
   DWORD dwTag;
   tagVBI_PARMS() : dwDecoder( 0 ), dwChange( 0 ), dwTag( 0 ) {}
   tagVBI_PARMS( VBI_DECODE_SESSION &sess ) : dwDecoder( sess.dwDecoderCallback ),
      dwChange( sess.dwChangeCallback ), dwTag( sess.dwTag ) {}
} VBI_PARMS;

class PsDevice : public VDevice
{
   private:
      bool bQuartzSightMode_ ;
      VMHANDLE         hCurVM_;
      static  PCI_CONFIG_848 pciCfgHdr_ ;

      BtGemini                *CaptureContrll_;
		BtScotch						*QuartzSightVP_;
      
      CaptureVxDVideoChannel  VideoIn_;
      PreviewVxDVideoChannel  VideoOut_;
      VBIVxDChannel           VBIEven_;
      VBIVxDChannel           VBIOdd_;

      VxDVideoChannel         *FullSizeChannel_;
      VxDVideoChannel         *SlaveChannel_;
      DWORD                   dwFullSizePitch_;

      static LPVIDEOHDR       EvenVBIBuf_ [2];
      static LPVIDEOHDR       OddVBIBuf_  [2];
      static bool             ChangingChannel_;

      VBIIntrCallback         VBIProcessor_;

      VBI_PARMS               *CurrVBIDec_;

      VideoFormat      CurVidFormat_;

      DWORD            dwDummyRegisterAddr [200];

      bool             VBIDecoderInited_;

   bool IsInited() { return bool( CaptureContrll_ != NULL ); }
   bool IsVideoChannel( VxDVideoChannel &aChan );
   bool IsVBIChannel( VxDVideoChannel &aChan );
   bool IsOurChannel( VxDVideoChannel &aChan );

   PVOID GetData( DWORD ptr16_16 );

   ErrorCode SetChannelsAnalogWindows( TRect &r );
   ErrorCode SetChannelsDigitalWindows( TRect &r );

   void AssignQuePointer( DWORD dwOffset, bool swap );
   void CreateCaptureController( WORD devId );

   // api handlers
   void AllocBuffer( PVOID pData );
   void FreeBuffer( PVOID pData );
   void OpenChannel( PVOID pData );
   void CloseChannel( DWORD dwData );
   void AddBuffer( VxDVideoChannel &aChan, LPVIDEOHDR pVidHdr );
   void PreStart(VxDVideoChannel &VidChan, StartParms *pParms) ;
   ErrorCode StartQuartzSight( VxDVideoChannel &VidChan, StartParms *pParms );
   ErrorCode StartInterlaced( VxDVideoChannel &VidChan, StartParms *pParms );
   ErrorCode StartSingle( VxDVideoChannel &VidChan, StartParms *pParms );
   ErrorCode Start( VxDVideoChannel &VidChan, PVOID pData );
   void Stop( VxDVideoChannel &VidChan );
   void SetClipping( VxDVideoChannel &VidChan, RGNDATA &const clip );
   void FlushQue( VxDVideoChannel &VidChan );

   void SetSaturation( VxDVideoChannel &aVidChan, PVOID pData );
   void SetHue( VxDVideoChannel &aVidChan, PVOID pData );
   void SetBrightness( VxDVideoChannel &aVidChan, PVOID pData );
   void SetSVideo( VxDVideoChannel &aVidChan, PVOID pData );
   void SetContrast( VxDVideoChannel &aVidChan, PVOID pData );
   void SetFormat( VxDVideoChannel &aVidChan, PVOID pData );
   void SetConnector( VxDVideoChannel &aVidChan, PVOID pData );
   void SetVScaleMode( DWORD dwData );

   void GetSaturation( PDWORD pData );
   void GetHue( PDWORD pData );
   void GetBrightness( PDWORD pData );
   void GetSVideo( PDWORD pData );
   void GetContrast( PDWORD pData );
   void GetFormat( PDWORD pData );
   void GetConnector( PDWORD pData );
   void GetVScaleMode( PDWORD pData );

   void Finish();

   void SetSignalFormat( VxDVideoChannel &aVidChan, PVOID pData );
   void SetSyncRef( VxDVideoChannel &aVidChan, PVOID pData );
   void SetSyncOutput( VxDVideoChannel &aVidChan, PVOID pData );
   void SetHReset( VxDVideoChannel &aVidChan, PVOID pData );
   void SetVideoInfo( PVOID pData );
   void SetPLL( PVOID pData );
   void SetTimGenLoadByte( PVOID pData, DWORD dwData );
   void SetDecInputClock( PVOID pData );
   void SetGPCLKOutputClock( PVOID pData );
   void SetTotalLineCount( PVOID pData );

   void GetSignalFormat( PVOID pData );
   void GetSyncRef( PVOID pData );
   void GetSyncOutput( PVOID pData );
   void GetHReset( PVOID pData );
   void GetVideoInfo( PVOID pData );
   void GetPLL( PVOID pData );
   void GetTimGenLoadByte( PVOID pData, PDWORD pdwData );
   void GetDecInputClock( PVOID pData );
   void GetGPCLKOutputClock( PVOID pData );
   void GetTotalLineCount( PVOID pData );

   void ResetFieldCounter( void );
   void GetFieldCounter( PVOID pData );

   // vbi functions

          ErrorCode VBIConnect();
          ErrorCode VBISetChannel( DWORD dwChannel );
   static ErrorCode VBISetMostParams();
   static ErrorCode VBISetParams();
   static void      VxDVBIIntrCallback( VideoStream aStrm, DWORD dwBufAddr );
   static void      VBI_API_Processor( VideoStream aStrm, DWORD dwBufAddr );
   static BOOL      VBI_Change_Processor( VBI_CHANGE_TYPE ct, DWORD arg );
   static void      CapDrvVBIIntrCallback( VideoStream aStrm, DWORD dwBufAddr );
   static void      VBIDecoderCallback();
          void      AddBufVBI( VxDVideoChannel &aVBIChan, LPVIDEOHDR lpvh );

          void      FreeVBIChannels();
          ErrorCode GrabVBIChannels();
          
   static void      StartVBI(VBI_INITIATOR_TYPE vbiInitiator);
   static void      StopVBI();

   public:
      virtual BOOL  OnSysDynamicDeviceInit();
      virtual BOOL  OnSysDynamicDeviceExit();
      virtual VOID  OnCritRebootNotify();
      virtual VOID  OnSystemExit( VMHANDLE hSysVM );
      virtual VOID  PM_API_Entry(VMHANDLE hVM, CLIENT_STRUCT* pRegs);
      virtual BOOL  OnPowerEvent( DWORD dwEvent, PDWORD pResult );
      virtual DWORD OnW32DeviceIoControl( PIOCTLPARAMS pDIOCParams );
      virtual BOOL  OnCreateVM( VMHANDLE hVM );
      virtual void  OnKernel32Shutdown(void) ;
      virtual CONFIGRET OnPnpNewDevnode(DWORD devNode, DWORD loadType);
      virtual VOID  OnDebugQuery( );


      void PauseCapture();
      void RestartCapture();

      VMHANDLE GetVMHandle() { return hCurVM_; }
      static PsDevice *GetPsDevice();

      static CONFIGRET CM_HANDLER ConfigHandler( CONFIGFUNC cfFuncName,
         SUBCONFIGFUNC scfSubFuncName, DEVNODE dnToDevNode, DWORD dwRefData,
         ULONG ulFlags );

      // VxD Services
      static DWORD _cdecl BT848_Get_Version();
      static void  _cdecl BT848_Set_VSYNC_Callback( DWORD cb );
      static void  _cdecl BT848_Set_GPIO_Callback( DWORD cb );
      static void  _cdecl BT848_Set_I2C_Callback( DWORD cb );
      static void  _cdecl Bt848_Open_VBI_Channel();
      static void  _cdecl Bt848_Start_VBI_Capture();
      static void  _cdecl Bt848_Stop_VBI_Capture();
      static void  _cdecl Bt848_Close_VBI_Channel();

      static WORD  _cdecl BT848_VVL_Read_Byte(BYTE reg);
      static WORD  _cdecl BT848_VVL_Write_Byte(BYTE reg , BYTE val);
      static PCI_CONFIG_848 *  _cdecl Bt848_Get_PCI_Config_Header() ;

      State Interrupt(bool bPwrDnInEffect) { return CaptureContrll_->Interrupt(bPwrDnInEffect); }
      
      PCI_CONFIG_848 * getPciCfgHdr() { return  &pciCfgHdr_; }

   PsDevice() : VDevice(), VideoIn_( VS_Capture ), VideoOut_( VS_Preview ),
      VBIEven_( VS_VBIE ), VBIOdd_( VS_VBIO ), hCurVM_( 0 ), CurrVBIDec_( NULL ),
      VBIProcessor_( VxDVBIIntrCallback ), VBIDecoderInited_( false ),
      CaptureContrll_( NULL ), SlaveChannel_( NULL ), FullSizeChannel_( NULL ),
      dwFullSizePitch_( 0 ), CurVidFormat_( VFormat_NTSC ),
	  bQuartzSightMode_(false), QuartzSightVP_( NULL )
   { RegBase::SetBaseAddress( (DWORD)&dwDummyRegisterAddr ); }
};

/* Class: PsVM
 * Purpose: Created for the system VM. Responsible for restarting Pisces when
 *   switching from a full-screen DOS box
 */
class PsVM : public VVirtualMachine
{
//RL   bool FullScreen_;
public:
   virtual VOID OnSetDeviceFocus( DWORD devID, DWORD flags, VMHANDLE aVM );

   PsVM( VMHANDLE hVM );
   VOID OnDestroyVM();
//RL   void SetState( bool full ) { FullScreen_ = full; }
//RL   bool IsFull() { return FullScreen_; }
};

/* Class: PsThread
 * Purpose: Not used
 */
class PsThread : public VThread
{
public:
    PsThread( THREADHANDLE hThread );
};

#include "bt848vxd.h"


#endif
