/****************************************************************************
     
        INTEL CORPORATION PROPRIETARY INFORMATION 
        Copyright (c) 1996 Intel Corporation
        All Rights Reserved
     
        This software is supplied under the terms of a license 
        agreement or non-disclosure agreement with Intel Corporation 
        and may not be copied or disclosed except in accordance
        with the terms of that agreement
     
****************************************************************************/

//**************************************************************************/
// VBIDEC.H
//
// For use in building a VBI Capture VxD using VToolsD build environment.
//
// See the "Intel VBI Decoder External Interface Specification" for details.
//**************************************************************************/

//--------------------------------------
// Device ID for VBI Decoder VxD
//--------------------------------------
#define ICVBIDEC_DeviceID   0x327F

//--------------------------------------
// Service Table Definition 
//    (for calls from Capture VxD to Intel VBI Decoder VxD)
//--------------------------------------
Begin_VxD_Service_Table(ICVBIDEC)
   VxD_Service( ICVBIDEC_Get_Version )
   VxD_Service( ICVBIDEC_Register_Callback )
   VxD_Service( ICVBIDEC_Set_Oversample )
   VxD_Service( ICVBIDEC_Set_Line_Pitch )
   VxD_Service( ICVBIDEC_Set_Channel )
   VxD_Service( ICVBIDEC_Decode_Field )
End_VxD_Service_Table

//--------------------------------------
// INT2F Interface Definitions
//    (for calls from 16-bit Capture DLL to VBI Decoder VxD)
//--------------------------------------
#define   I2F_ICVBIDEC_Get_Version        0
#define   I2F_ICVBIDEC_Register_Callback  1
#define   I2F_ICVBIDEC_Set_Oversample     2
#define   I2F_ICVBIDEC_Set_Line_Pitch     3
#define   I2F_ICVBIDEC_Set_Channel        4
#define   I2F_ICVBIDEC_Decode_Field_Odd   5
#define   I2F_ICVBIDEC_Decode_Field_Even  6

