# $Header: G:/SwDev/W95/Video/pisces/rcs/pmake.ksh 1.9 1998/04/14 21:58:27 ssm Exp $

# $Log: pmake.ksh $
# Revision 1.9  1998/04/14 21:58:27  ssm
# add echo of make line
# Revision 1.8  1998/04/08 19:07:59  ssm
# ch version opt to -ver
# Revision 1.7  1998/03/11 22:38:07  ssm
# handle case where -v opt is used && VERSIONSTRING is defined
# Revision 1.6  1998/03/04 22:29:26  dtharp
# exported VERSIONSTRING
# Revision 1.5  1998/01/20 18:31:48  ssm
# fixed -ne vs -lt problem
# Revision 1.4  1998/01/17 04:36:09  ssm
# forgot to shift the version string so that the rest of the cmd lne would get passed on to make
# Revision 1.3  1998/01/17 04:21:27  ssm
# add sh var versionstring

#########################################
#set -a -x

echo "pmake.ksh $Revision: 1.9 $ Bt848 make script"
if [ "$1" = "-?" ]
then
	echo "SYNTAX: pmake [-ver version] [makeoptions] (eg. pmake -v 1.2.3.4)"
	echo "        the makeoptions are passed on to \"make\""
	exit 1
fi

#########################################
if [ $1 = "-ver" ]
then
	shift
	VERSIONSTRING=$1
	shift	
fi

#########################################
if [ -z $VERSIONSTRING ]
then
	VERSIONSTRING=`date +%d%b%y.%H%M%S`
	echo "\n\nWARNING \"VERSIONSTRING\" NOT DEFINED, using \"$LOGNAME$VERSIONSTRING\"\n\n"
fi
export VERSIONSTRING


#########################################
if [ "$SWTOOLS" = "" ]
then
	echo "ERROR: \"SWTOOLS\" MUST BE DEFINED USING KSH FRONT SLASHES"
	exit 1
fi

# set env vars
export SWTOOLSD=$(echo $SWTOOLS | sed -e s#/#'\\'#)
export VTOOLSD=$SWTOOLSD\\VtD204
export PATH="$SWTOOLS/mks/mksnt;$SWTOOLS/bc5/bin;$SWTOOLS/bin"
export LIB=$SWTOOLSD\\\\bc5\\\\lib
export INCLUDE=$SWTOOLSD\\\\bc5\\\\include


#########################################
#export RCSVERSIONSTRING=G$(echo $VERSIONSTRING | gres '\.' '_')
#echo "***** make started `date`: VERSIONSTRING=$VERSIONSTRING, RCSVERSIONSTRING=$RCSVERSIONSTRING, SWTOOLS=$SWTOOLS"
#########################################
echo "***** make started `date`: VERSIONSTRING=$VERSIONSTRING, SWTOOLS=$SWTOOLS"
#########################################
export PMAKEINVOKED=1
echo "pmake.ksh: make $*"
make $*

if [ $? -eq 0 ]
then
	echo "\n\n***** pmake: SUCCESS `date`\n\n"
	exit 0
else
	echo "\n\n***** pmake: FAILED `date`\n\n"
exit 1
fi



